define("io.ox/office/editframework/app/editapplication",["exports","io.ox/core/tk/doc-converter-utils","io.ox/core/api/user","io.ox/core/api/tab","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/forms","io.ox/office/tk/utils/io","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/tabutils","io.ox/office/tk/utils/driveutils","io.ox/office/tk/worker/intervalrunner","io.ox/office/tk/dialogs","io.ox/office/baseframework/utils/apputils","io.ox/office/baseframework/utils/errorcode","io.ox/office/baseframework/utils/errorcontext","io.ox/office/baseframework/utils/errorcontextdata","io.ox/office/baseframework/utils/clienterror","io.ox/office/baseframework/utils/infostate","io.ox/office/baseframework/utils/errormessages","io.ox/office/baseframework/utils/infomessages","io.ox/office/baseframework/utils/seleniumlogger","io.ox/office/baseframework/app/baseapplication","io.ox/office/baseframework/app/extensionregistry","io.ox/office/rt2/rt2const","io.ox/office/rt2/rt2protocol","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/utils/operationutils","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/utils/webfonts","io.ox/office/editframework/app/rtconnection","io.ox/office/editframework/app/rtconnectionviewer","io.ox/office/editframework/app/acquireeditrightsworker","io.ox/office/editframework/view/editlabels","gettext!io.ox/office/editframework/main"],function(e,Wt,Yt,zt,Kt,t,n,Zt,r,i,Qt,Jt,o,a,s,Xt,en,tn,nn,rn,on,an,sn,l,ln,cn,dn,un,gn,c,d,pn,fn,u,En,hn){"use strict";var On=t.isFiniteNumber,_n=t.getNumber,Sn=t.getArray,g=t.newDeferred,mn=t.newFulfilled,In=t.newRejected,Rn=t.toPromise,Nn=n.stringEndsWith,An=n.trimAndCleanString,Dn=n.capitalizeFirst,vn=n.filterArray,yn=r.FILTER_MODULE_NAME,bn=r.requireOptModule,Cn=i.globalLogger,Tn=i.getFormattedLogBuffer,wn=un.SaveAsType,Fn=un.STORAGE_AVAILABLE,Ln=un.RENAME_DISABLED,Un=un.TRANSFER_EDIT_RIGHTS_TIMEOUT,xn=o.IntervalRunner,kn=a.MessageDialog,$n=s.FlushReason,Pn=s.QuitReason,Mn=l.BaseApplication,Bn=c.otLogger,Hn=c.dbgDumpActions,Gn=d.importWebFonts,qn=u.acquireEditLogger,jn=u.AcquireEditRightsWorker,Vn="accept",Wn="decline",Yn="inactive",zn=hn("unnamed"),Kn=["editUserId","editUser","hasErrors","writeProtected","activeUsers","locked","lockedByUser","lockedByUserId","failSafeSaveDone","serverOSN"];function Zn(e){var t=Sn(e,"operations",!0);return t.every(_.isObject)?t:(Cn.error("$badge{EditApp} getOperationsFromData: invalid elements in operations array",t),[])}function Qn(e){if(_.isObject(e)&&_.isString(e.action))switch(e.action){case"reload":e.action={itemKey:"document/reload",icon:En.RELOAD_ICON,label:En.RELOAD_LABEL};break;case"acquireedit":e.action={itemKey:"document/acquireeditOrPending",icon:En.EDIT_ICON,label:En.EDIT_LABEL};break;case"loadrestored":e.action={itemKey:"document/reload",icon:En.LOAD_RESTORED_ICON,label:En.LOAD_RESTORED_LABEL};break;default:delete e.action}}function Jn(e,t,n){var r=g();e.done(function(e){r.resolve(e)}),e.fail(function(e){r.reject(e)});var i=window.setTimeout(function(){r.reject("timeout"),Cn.warn(n+" - operation timed out")},t);return e.always(function(){window.clearTimeout(i)}),r.promise()}e.EditApplication=Mn.extend(function(e,w,F){var L=this,U=null,x=null,t=null,k=null,n=null,P=null,M=null,p=[],i=null,r=!1,o=!1,a=0,B=Kt.getFunctionOption(F,"preProcessHandler"),H=Kt.getFunctionOption(F,"postProcessHandler"),f=Kt.getFunctionOption(F,"fastEmptyLoadHandler"),E=Kt.getFunctionOption(F,"previewHandler"),s=Kt.getFunctionOption(F,"importFailedHandler",_.noop),l=Kt.getFunctionOption(F,"optimizeOperationsHandler"),c=!0,h=Kt.getFunctionOption(F,"mergeCachedOperationsHandler"),O=!F||!F.otConfigKey||un.getFlag(F.otConfigKey,!0),d=O?100:Kt.getNumberOption(F,"sendActionsDelay",0),u=Kt.getBooleanOption(F,"isMultiSelectionApp",!0),g=Kt.getBooleanOption(F,"isSnapshotApp",!0),S=null,m=null,I=!1,R=null,N=null,A=!1,D=!1,v=null,y=!1,b=!1,G=!1,C=null,T=!1,q=!1,j=!1,V=null,W=!1,Y=Kt.getBooleanOption(F,"localStorageApp",!1)&&!O,z=Kt.getIntegerOption(F,"requiredStorageVersion",0),K=Kt.getIntegerOption(F,"supportedStorageVersion",0),Z=!1,Q=un.USE_LOCAL_STORAGE&&!0===ox.secretCookie&&!w.auth_code,J=!1,X={},ee=1,te=[],ne=[],re=[],ie=null,oe=0,ae=!1,se=Kt.getBooleanOption(F,"supportsOnlineSync",!0),le=null,ce=!1,de=!1,ue={},ge="",pe={},fe=[],Ee=!0,he=!1,Oe=[],_e=null,Se=null,me=!1,Ie=!1,Re=!1,Ne=null,Ae=null,De=0,ve=!0,ye=null,be=null,Ce=!1,Te="slow load",we=!1,Fe=[],Le=0,Ue=null,xe=-1,ke=0,$e=[],Pe={},Me=null,Be=null,He=!1;function Ge(e,t){var n=L.getState();L.setRootAttribute("data-app-state",n),L.trigger("docs:state",n,e,t),L.trigger("docs:state:"+n,t),qn.log("statechange",n,e)}function qe(e){var t=T?"error":ie?"preview":I?G||!N?"readonly":vt()?"sending":A?"ready":"initial":"offline";if(S!==t){var n=S;S=t,Ge(n,e)}}function je(e){N!==e&&(N=e,L.trigger("docs:editmode",N),qn.log("$back{LightPink}changeEditMode",N),L.trigger(N?"docs:editmode:enter":"docs:editmode:leave"),qe())}function Ve(){return{documentFileLockedByUser:C,fullFileName:L.getFullFileName(),oldEditUser:R,isEditor:Et()}}function We(e,t){var n=hn("Read-Only Mode"),r=null,i=null,o=null;_.isString(e)?(i={type:"info",message:e,headline:n},isNaN(t)||(i.duration=t),i=_.extend({},i,{action:"acquireedit"})):(o=Ve(),r=L.getErrorState(),i=ye,_.isObject(i)||(_.isObject(r)&&(r.isError()||r.isWarning())?i=on.getMessageData(r,o):(r=L.getInfoState(),_.isString(r)&&(i=an.getMessageData(r,o))))),L.extendMessageData(i),x.yell(i)}Mn.call(this,e,function(){var l=[],N=L.createDeferred("EditApplication.asynchronousLoadFinished"),e=null,t=null,c=$.Deferred(),d=!1,u=!1,A=[],D=[],v=!1,o=-1,g=L.launchTracker;function y(e,t){A.push(t),pn.log("Document status update received during document import")}function b(e,t){D.push(t),pn.log("Clients update received during document import")}function C(e,t){pn.log("Final operation message received for asynchronous load"),O&&!L.isViewerMode()&&_t(t.docStatus.serverOSN),t.hasErrors||"error"===L.getState()?N.reject(t):c.always(function(){var e,n,r,i;l.push(t),N.resolve((e=l,n={},r=[],i=null,_.each(e,function(e){var t=e.operations;$.extend(n,e),t&&(delete e.operations,r=r.concat(t)),e.rescueOperations&&(i=e.rescueOperations)}),Pe=n&&n.syncInfo,pn.log("loadDocInfo",Pe),n.operations=r,i&&(n.rescueOperations=i),_.isEmpty(n.operations)&&n.syncInfo&&o===parseInt(n.syncInfo["document-osn"],10)&&(v=!0),n))})}function T(e,t){var n,r,i,o,a=null;if(ae)return delete t.actions,0<l.length?l[0]=_.extend(l[0],t):l.push(t),void c.resolve();if(n=t,Kt.getBooleanOption(n,"preview",!1))return d=!0,void l.push(t);if(d&&!u){u=!0,r=l,i=0,o=[],_.each(r,function(e){i=_.isNumber(e.activeSheet)?e.activeSheet:i,o=o.concat(e.operations)}),a={preview:{activeSheet:i,operations:o}},(l=[]).push(t);var s=function(n){var e=new Xt(n),r=Kt.getObjectOption(n,"preview"),t=e.isError()?$.Deferred().reject(n):$.when();r&&_.isArray(r.operations)&&(t=function(){var e=Rt(B,"previewPreProcessing","Preview preprocess handler finished");return e=e.then(function(){B=null;var e=Sn(n.preview,"operations"),t=e?U.applyExternalOperations(e,{expand:!0}):L.createResolvedPromise();return g.asyncStep(t,"previewApplyOperations","$badge{EditApp} "+(e?e.length:0)+" preview operations applied"),t=t.then(function(){return E.call(L,r)?L.leaveBusyDuringImport():$.when()},function(e){e&&"abort"===e||(n.operationError=!0,n.message=hn("An unrecoverable error occurred while modifying the document."))})}),g.asyncStep(e,"previewEnd","$badge{EditApp} Preview postprocess handler finished")}());return t}(a);return g.asyncStep(s,"previewProcessing","$badge{EditApp} Preview data processed"),s.done(function(){c.resolve()}),void s.fail(function(){c.reject(),Nt(t)})}d||"pending"!==c.state()||c.resolve(),l.push(t)}function r(t){var n,r,e,i,o,a,s,l,c,d,u,g,p,f,E=Zn(t),h=(n=t.docStatus,r={},Kn.forEach(function(e){e in n&&(r[e]=n[e])}),r),O=new Xt(t),S=null;function m(e,t){return He=!!e.rescueOperations||Kt.getBooleanOption(e.docStatus,"rescueDoc",null),ht(e).always(function(){gt(e.docStatus)}),Se=Kt.getStringOption(e.syncInfo,"restore_id",null),Z=Kt.getBooleanOption(e.syncInfo,"renameNeedsReload",!1),L.waitForImportSuccess(function(){pn.log("Applying clients update messages, count = "+D.length),_.each(D,function(e){ht(e)}),pn.log("Applying document update messages, count = "+t.length),_.each(t,function(e){It(e)}),xt()&&(M.off(dn.RESPONSE_OPEN_DOC_CHUNK,T),M.off(dn.RESPONSE_OPEN_DOC,C),M.off(dn.BROADCAST_UPDATE_CLIENTS,b).on(dn.BROADCAST_UPDATE_CLIENTS,function(e,t){ht(t)}),M.off(dn.BROADCAST_UPDATE,y).on(dn.BROADCAST_UPDATE,function(e,t){It(t)})),qe(),un.DEBUG&&e.rescueOperations&&L.trigger("docs:rescueoperations",e.rescueOperations),N.resolve({action:[]})}),$.when()}function I(){return L.getUserInfo(ox.user_id).done(function(e){P=Kt.escapeHTML(e.operationName)})}if(L.isViewerMode()&&(G=!0,je(!(Pe={}))),k=Kt.getStringOption(t.docStatus,"clientId",""),X[k]=0,e=null,Kt.getBooleanOption(t,"hasErrors",!1)?(Cn.error("$badge{EditApp} importHandler: server side error"),e="server"):Kt.getBooleanOption(t,"operationError",!1)?(Cn.error("$badge{EditApp} importHandler: operation failure"),e=t.message):O.isError()?(Cn.error("$badge{EditApp} importHandler: server side error, errorCode="+O.getCodeAsConstant()),e="server"):0===k.length?(Cn.error("$badge{EditApp} importHandler: missing client identifier"),e="noclientid"):ae||v||_.isArray(E)&&0!==E.length||(Cn.error("$badge{EditApp} importHandler: missing document operations"),e="noactions"),S=e?{cause:e}:null,_.isObject(S))return S=_.extend(S,Nt(t)),$.Deferred().reject(S);if(i=!0,s=0,u=d=c=l=a=o=null,"load"===w.action&&_.isObject(w.file)&&(Fn&&Y&&Q&&t.syncInfo&&t.syncInfo.fileVersion&&On(t.syncInfo["document-osn"])&&t.syncInfo.fileId&&t.syncInfo.folderId&&_.isFunction(U.setFullModelNode)&&_.isFunction(U.getSupportedStorageExtensions)&&(o=t.syncInfo.fileId+"_"+t.syncInfo.folderId,d=o+"_FILEVERSION",a=o+"_STORAGEVERSION",l=o+"_OSN",c=o+"_OPERATIONS",u=U.getSupportedStorageExtensions(),s=localStorage.getItem(a)&&parseInt(localStorage.getItem(a),10)||1,z<=s?(Cn.info("$badge{EditApp} importHandler: document-osn="+t.syncInfo["document-osn"]+", document-rev="+t.syncInfo.fileVersion),localStorage.getItem(d)&&localStorage.getItem(d)===t.syncInfo.fileVersion&&localStorage.getItem(l)&&parseInt(localStorage.getItem(l),10)===parseInt(t.syncInfo["document-osn"],10)?function(){var e=JSON.parse(localStorage.getItem(c));if(_.isArray(e)){0<E.length&&U.setExternalLocalStorageOperationsExist(!0),E=e.concat(E);var t=_.last(E);return _.isNumber(t.osn)||(t.opl=1,t.osn=parseInt(localStorage.getItem(l),10)-1),1}}()?u.some(function(e){var t=o+e.extension,n={usedLocalStorage:!0};_.isObject(e.additionalOptions)&&_.extend(n,e.additionalOptions);var r=localStorage.getItem(t);if(r)Cn.info("$badge{EditApp} importHandler: loading document from local storage. Key: "+t+" Length: "+localStorage.getItem(t).length),J=!0,Te="local storage",U.setFullModelNode(r,n);else{if(!e.optional)return Cn.info("$badge{EditApp} importHandler: key in local storage not found. Key: "+t+". But found OSN key: "+l),R(),!(J=!1);Cn.info("$badge{EditApp} importHandler: optional local storage value not found. Key: "+t)}}):(Cn.info("$badge{EditApp} importHandler: required operations in local storage not found. Key: "+c),R()):(Cn.info("$badge{EditApp} importHandler: file in local storage not found. Key: "+o),R())):(Cn.info("$badge{EditApp} importHandler: version of file in local storage not supported. Key: "+o),R())),J&&U.trigger("update:model",{usedLocalStorage:!0})),!i)return $.Deferred().reject({cause:"localStorageFailed",headline:_.noI18n("LocalStorage failure")});function R(){_.each(u,function(e){localStorage.removeItem(o+e.extension)}),localStorage.removeItem(l),localStorage.removeItem(a),localStorage.removeItem(d),localStorage.removeItem(c)}return g=null,p="",f=Kt.getBooleanOption(t,"fastLoad",!1),J||(!t.htmlDoc&&un.DEBUG&&!ae&&U.setFullModelNode&&f&&L.getFileDescriptor()&&!Nn(L.getFileDescriptor().filename,"_ox")&&x.yell({type:"error",headline:_.noI18n("Error in fastload"),message:_.noI18n('you should have a look in the backend logfiles ("Exception while creating the generic html document")')}),t.htmlDoc&&_.isFunction(U.setFullModelNode)&&!ae&&(Cn.info("$badge{EditApp} importHandler: load complete HTML document, osn: ",t.syncInfo["document-osn"]),(g=JSON.parse(t.htmlDoc)).mainDocument&&U.setFullModelNode(g.mainDocument),g.headerFooter&&(_.each(g.headerFooter,function(e){p+=e}),U.setFullModelNode(p,{headerFooterLayer:!0}),U.getPageLayout().headerFooterCollectionUpdate()),g.comments&&(p="",_.each(g.comments,function(e){p+=e}),U.setFullModelNode(p,{commentLayer:!0})),Te="fast load",U.trigger("fastload:done"))),A.unshift({docStatus:h}),ae?(Te="fast empty",m(t,A).then(I)):Rt(B,"preProcessing","Import preprocess handler finished").then(I).then(function(){var e=Rt(function(){var e=F&&F.applyActionsDetached;return e&&x.detachAppPane(),U.applyExternalOperations(E,{expand:!0}).always(function(){e&&x&&!x.destroyed&&x.attachAppPane()})},"applyOperations",E.length+" document operations applied");return e=e.then(function(){if(U.getOperationStateNumber()<0)return $.Deferred().reject({cause:"applyactions",headline:hn("Synchronization Error")});var e=J&&!U.externalLocalStorageOperationsExist();return Rt(H?H.bind(L,e):null,"postProcessing","Import postprocess handler finished").then(function(){return m(t,A)},function(e){return _.extend({cause:"postprocess"},e)})},function(e){if(xt()&&M.off(dn.RESPONSE_OPEN_DOC,C),"destroy"!==e)throw _.extend({cause:"applyactions"},e)})},function(e){throw _.extend({cause:"preprocess"},e)})}U.undoManager.on("undogroup:open",function(){i=At()}),U.undoManager.on("undogroup:close",function(){Dt()&&wt(i),i=null,U.setInternalOperationBlocker(!1)}),U.on("operations:success",function(e,t,n,r){n||he||(_.isObject(i)?(pn.log("operations:success - push operations into pending action"),i.operations=i.operations.concat(t),r&&(i.userData=r)):wt(At(t,r)))}),U.on("cacheBuffer:flush",function(){pn.log("cacheBuffer:flush received - send cached operations"),_.isFunction(h)&&Oe.length&&(p=h.call(L,p,Oe),Tt())}),U.on("operations:error",function(){L.isImportFinished()?(L.setInternalError(nn.ERROR_WHILE_MODIFYING_DOCUMENT,en.GENERAL),pn.error("An unrecoverable error occurred while modifying the document")):(L.setInternalError(nn.ERROR_WHILE_LOADING_DOCUMENT,en.GENERAL),pn.error("An unrecoverable error occurred while loading the document"),N.reject())}),L.getWindowNode().on("drop",!1),M=L.isViewerMode()?new fn(L,F):new pn(L);this.rtConnection=M,ae||x.enterBusy({skipCancelOnReadOnly:!0,cancelHandler:function(){L.isInQuit()||($t(".abortOpen"),Mt(),L.quit())},immediate:!0,topLabel:_.noI18n(L.getFullFileName()),warningLabel:hn("Sorry, your document is very large. It will take some time to be loaded."),warningDelay:1e4});xt()&&(M.on(cn.EVENT_OFFLINE,Je),M.on(cn.EVENT_ONLINE,Xe),M.on(cn.EVENT_ERROR,function(e,t){!function(e,t){var n;pn.log("Error handler called by RT2 communication layer, cause = "+JSON.stringify(e)),t&&"pending"===t.state()&&t.reject(e);_.isObject(e)&&_.isString(e.error)&&(n=new Xt(e));L&&("GENERAL_SESSION_INVALID_ERROR"===n.getCodeAsConstant()?function(e){if(Ce)return;var t=Ce=!0;function n(){ox.off("relogin:success",n),ox.off("relogin:fail",r),t=!1,(O?et:tt)(),Ce=!1}function r(){ox.off("relogin:success",n),ox.off("relogin:fail",r),L.setInternalError(e),Ce=!1}L.setInternalError(nn.WARNING_SESSION_INVALID_DETECTED,en.CONNECTION),G=!0,je(!1),qe(),ox.on("relogin:success",n),ox.on("relogin:fail",r),L.executeDelayed(function(){t&&(t=!1,ox.trigger("relogin:required"))},"EditApplication.connectionErrorHandler",5e3)}(n):"GENERAL_DOCUMENT_ALREADY_DISPOSED_ERROR"===n.getCodeAsConstant()?_.isString(le)?(ce=!0,O?pt({cause:"error:disposed"}):ft(0,null,null,{cause:"error:disposed"})):L.setInternalError(n,en.CONNECTION):"TOO_MANY_CONNECTIONS_ERROR"===n.getCodeAsConstant()?(ce=!0,le=null,L.setInternalError(n,en.CONNECTION)):L.isLocked()||L.isInQuit()||_.isString(le)?_.isString(le)&&(ce=!0,O?pt({cause:"reset"}):ft(0,null,null,{cause:"reset"})):"HANGUP_INVALID_OPERATIONS_SENT_ERROR"===e.error||"HANGUP_INVALID_OSN_DETECTED_ERROR"===e.error||"GENERAL_OFFLINE_CLIENT_IN_NON_SYNC_STATE"===e.error?L.setInternalError(e,en.CONNECTION):"HANGUP_NO_EDIT_RIGHTS_ERROR"===e.error?L.restoreDocument(n):(n=nn.ERROR_UNKNOWN_REALTIME_FAILURE,L.setInternalError(e,en.CONNECTION)))}(t,N)}),M.on(cn.EVENT_NORESPONSE_IN_TIME,nt),M.on(dn.BROADCAST_UPDATE,y),M.on(dn.BROADCAST_UPDATE_CLIENTS,b),M.on(dn.BROADCAST_SHUTDOWN,rt),M.on(dn.BROADCAST_CRASHED,it),M.on(dn.BROADCAST_RENAMED_RELOAD,lt),M.on(dn.BROADCAST_HANGUP,ot),M.on(dn.BROADCAST_OT_RELOAD,at));return g.step("initImport","$badge{EditApp} Import process initializated"),t=function(){var t=L.createDeferred("EditApplication.establishConnection");return Rt(function(){var e=xt()?M.connect():L.createRejectedPromise();return pn.log("Channel UID:",xt()?M.getChannelUID():null),Me=xt()?M.getDocUID():"null",Be=xt()?M.getClientUID():"null",(e=e.then(function(e){if(e.hasErrors||new Xt(e).isError())throw e;return e})).done(function(e){t.resolve(e)}),e.fail(function(e){t.reject(e)}),t.promise()},"connect","Realtime connection established")}(),Ye(),(e=t.then(function(e){var t=new Xt(e),n={fastEmpty:ae};if(!t.isError())return xt()&&(M.on(dn.RESPONSE_OPEN_DOC_CHUNK,T),M.on(dn.RESPONSE_OPEN_DOC,C)),w.auth_code&&(n=_.extend({auth_code:w.auth_code},n)),"new"===w.action&&(n=_.extend({newDoc:!0},n)),ae&&(n=_.extend({fastEmptyOSN:U.getOperationStateNumber()},n)),Fn&&!ae&&Q&&(function(e,t){if("load"!==e.action||!_.isObject(e.file))return;var n=e.file.id+"_"+e.file.folder_id,r=n+"_OSN",i=n+"_FILEVERSION",o=n+"_STORAGEVERSION",a=localStorage.getItem(r),s=localStorage.getItem(i);localStorage.getItem(o)>=z&&a&&s&&(a=parseInt(a,10),s=parseInt(s,10),_.isNumber(a)&&_.isNumber(s)&&(t.storageOSN=a,t.storageVersion=s))}(w,n),o=n.storageOSN),xt()&&M.open(n),N.then(r,function(e){return In(e)});Nt(e)}).catch(function(e){return In(Nt(e))})).always(function(){ie=null,qe()}),e},w,_.extend({},F,{initHandler:function(){var e=Gn();un.DEBUG&&(e=e.then(function(){return bn("io.ox/office/debug/common/main",function(e){return e.initializeApp(L)})}));return e},initFileHandler:function(){if(!L||!w)return Cn.warn("$badge{EditApp} initFileHandler: called on an already destroyed instance."),$.Deferred().reject();var e={},n=!1,r=L.launchTracker;e.initial_language=ox.language.replace(/_/g,"-"),w.cryptoAction&&(e.cryptoAction=w.cryptoAction);w.decrypt_auth_code&&(e.cryptoAuth=w.decrypt_auth_code,e.encrypted_file=!0);switch(Kt.getStringOption(w,"action","load")){case"load":return Jt.isDriveFile(w.file)?Jt.getFile(w.file).done(function(e){w.file=e}):$.when();case"convert":n=!0;break;case"new":var t=F&&F.prepareNewDocHandler;t&&_.extend(e,t.call(L));break;default:return Cn.error("$badge{EditApp} initFileHandler: unsupported launch action"),$.Deferred().reject()}var i=Kt.getObjectOption(w,"templateFile"),o=Kt.getBooleanOption(w,"preserveFileName",!1),a=Kt.getStringOption(w,"target_filename",zn),s=Kt.getStringOption(w,"target_folder_id",""),l=Kt.getObjectOption(i,"origin");function c(e){return L.setInternalError(e,en.CREATEDOC),$.Deferred().reject({cause:n?"convert":"create"})}_.extend(e,{action:"createdefaultdocument",document_type:L.appType,target_filename:a,target_folder_id:s,preserve_filename:o,convert:n}),w.template&&_.extend(e,{action:"createfromtemplate",file_id:i.id});_.isObject(i)&&_.extend(e,{file_id:i.id,version:i.version});L.waitForImportSuccess(function(){var e=L.getFileDescriptor(),t=!w.template&&s!==e.folder_id;(w.template?e.converted:n)?L.setCurrentInfoState(t?rn.INFO_DOC_CONVERT_STORED_IN_DEFFOLDER:rn.INFO_DOC_CONVERTED_AND_STORED):t&&L.setCurrentInfoState(rn.INFO_DOC_CREATED_IN_DEFAULTFOLDER)});var d=_.url.hash("fields"),u=_.url.hash("fields-source");(d||u)&&(_.url.hash("fields",null),_.url.hash("fields-source",null),e.fields=d,e.sourcefields=u);var g=L.sendRequest(yn,e);return g=g.then(function(e){var t=new Xt(e);return t.isError()?c(t):e},function(){return c()}),r.asyncStep(g,"createNewDocAfterRequest","$badge{EditApp} New file in remote storage created"),(g=(g=g.then(function(t){return Jt.getFile(t.file).then(function(e){return t.file=e,t})})).then(function(e){function t(t,n){var e=L.isPresentationApp()?L.createResolvedPromise():L.leaveBusyDuringImport(!t,{immediateShow:!0});return r.asyncStep(e,"afterLeaveBusyEarly","$badge{EditApp} Busy state after creation of document left"),e.then(function(){if(t)return n;throw n},function(e){throw t?e:n})}return _.isObject(e.file)?(l&&(e.file.origin=l),e.file.source="drive",e.converted&&(e.file.converted=e.converted),(ae=_.isString(e.htmlDoc)&&_.isArray(e.operations)&&0<e.operations.length)&&f?f.call(L,e.htmlDoc,e.operations).then(t.bind(null,!0),t.bind(null,!1)).then(function(){return e}):e):(Cn.error("$badge{EditApp} initFileHandler: missing file descriptor"),$.Deferred().reject())})).then(function(e){return e.file})},flushHandler:function(e){if(T)return In();var t=Ft(e);e===$n.QUIT&&t.always(function(){je(!1)});return t=t.then(function(){return xt()?M.flushDocument():In()})},messageDataHandler:Qn,printOptionsHandler:function(){return xt()?{doc_uid:M.getDocUID(),client_uid:M.getClientUID()}:null}}));var Ye=un.DEBUG?function(){Q=L.getUserSettingsValue("debugUseLocalStorage",Q)&&!L.isDocumentEncrypted()}:$.noop;function ze(e){var t=_.findWhere(te,{clientUID:e});return t&&t.userName||""}var Ke=un.LOG_PERFORMANCE_DATA?function(){var i=x.getToolBarTabs(),o=0;i.on("tab:activated",function e(t,n){if(o++,n){var r="tabActivated_"+Dn(n);L.launchTracker.step(r,'$badge{EditApp} Toolbar tab "'+n+'" activated')}2===o&&i.off("tab:activated",e)})}:$.noop;function Ze(){function e(){L.getController().update().done(function(){L.launchTracker.step("considerToolbarUIStable","$badge{EditApp} Toolbar is visually stable"),L.isReloading()&&L.setAppReloadDone(L)})}function t(){Re=!0,L.showEditToolbarAtStart()?x.one("edittoolpane:layout:finished",e):x.one("docs:toolpane:unhide",function(){L.executeDelayed(function(){e()},"registerFirstTabActivatedHandler.unhideToolpaneHandler",150)})}L.showEditToolbarAtStart()?x.getToolBarTabs().one("tab:activated",t):L.waitForImportSuccess(t)}function Qe(e){var t=Xt.isErrorCode(e)?e:function(e){var t;switch(e){case"reset":t=new Xt(nn.ERROR_CONNECTION_RESET_RECEIVED);break;case"timeout":t=new Xt(nn.ERROR_CONNECTION_TIMEOUT);break;case"notMember":t=new Xt(nn.ERROR_CONNECTION_NOT_MEMBER);break;default:t=new Xt(nn.ERROR_UNKNOWN_REALTIME_FAILURE)}return t}(e);if(t.setErrorContext(en.CONNECTION),xt()){var n=M.hasPendingActions()||L.hasUnsavedChangesOffice();je(!(G=!0)),n?O?L.setInternalError(nn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,en.CONNECTION):L.restoreDocument(t):(w.action="load",delete w.template,L.reloadDocument())}else L.setInternalError(t,en.CONNECTION)}function Je(){j=!0,I&&!T&&!L.isInQuit()&&xt()&&(q=N,I=!1,O&&Ue.abort(),le?M.hasPendingActions()?L.setInternalError(nn.ERROR_OFFLINE_WHILE_SYNC_LOCAL_CHANGES,en.OFFLINE):L.setInternalError(nn.ERROR_OFFLINE_WHILE_SYNCHRONIZING,en.OFFLINE):(je(!(G=!0)),qe(),L.setInternalError(nn.WARNING_READONLY_DUE_TO_OFFLINE,en.OFFLINE)),pn.log("Connection offline handler called by Realtime!"),dt())}function Xe(){!j||I||T||L.isInQuit()||(pn.log("Connection online handler called by Realtime!"),O&&Vt(),I=!0,se&&(O?et:tt)(),qe(),We())}function et(){pn.log("Client supports synchronization - starting to sync with server"),_.isObject(L)&&(q?(L.setInternalError(nn.WARNING_SYNC_AFTER_OFFLINE,en.SYNCHRONIZATION),pn.log("Client is editor - synchronizing with server using current client state"),le="editSync",p&&0<p.length&&Tt()):(L.setInternalError(nn.WARNING_SYNC_FOR_VIEWER,en.SYNCHRONIZATION),pn.log("Client is viewer - waiting for server messages to unlock view"),le="viewSync"),L.executeDelayed(function(){!ce&&le&&(pn.log("Synchronization time out detected - no synchronization possible"),pt({cause:"timeout"}))},"EditApplication.startSynchronizationProcessOT",3e4),le&&xt()&&(M.sync(),M.syncStable().then(function(e){pn.log("SyncStable response received ",e),e&&e.docStatus?pt(null):pt({cause:"reset"})},function(){pt({cause:"reset"})}).done(function(){L.repeatDelayed(function(){return!le||ce?Kt.BREAK:xt()?void pt(null):(pt({cause:"reset"}),Kt.BREAK)},"EditApplication.startSynchronizationProcessOT",{delay:0,repeatDelay:3e3,cycles:9})})))}function tt(){if(pn.log("Client supports synchronization - starting to sync with server"),_.isObject(L)&&(q?(L.setInternalError(nn.WARNING_SYNC_AFTER_OFFLINE,en.SYNCHRONIZATION),pn.log("Client is editor - synchronizing with server using current client state"),le="editSync",p&&0<p.length&&Tt()):(L.setInternalError(nn.WARNING_SYNC_FOR_VIEWER,en.SYNCHRONIZATION),pn.log("Client is viewer - waiting for server messages to unlock view"),le="viewSync"),L.executeDelayed(function(){!ce&&le&&(pn.log("Synchronization time out detected - no synchronization possible"),ft(0,null,null,{cause:"timeout"}))},"EditApplication.startSynchronizationProcess",3e4),le&&xt())){var n=-1,r=null,e=M.sync().then(function(e){if(pn.log("Sync response received ",e),e&&e.docStatus){var t=U.getOperationStateNumber();return r=Kt.getStringOption(e.docStatus,"editUserId",""),n=Kt.getIntegerOption(e.docStatus,"serverOSN",-1),ft(V=r,t,n,null),$.when()}throw new Error("sync response contains no mandatory data - synchronization impossible!")},function(){ft(0,null,null,{cause:"reset"})});(e=e.then(function(){if(le&&xt()){var e=M.syncStable();return e.done(function(e){if(pn.log("SyncStable response received ",e),e&&e.docStatus){var t=U.getOperationStateNumber();r=Kt.getStringOption(e.docStatus,"editUserId",""),ft(V=r,t,n,null)}else ft(0,null,null,{cause:"reset"})}),e.fail(function(){ft(0,null,null,{cause:"reset"})}),e}throw ft(0,null,null,{cause:"reset"}),new Error("synchronization not possible")},function(){ft(0,null,null,{cause:"reset"})})).done(function(){L.repeatDelayed(function(){if(!le||!xt())return ft(0,null,null,{cause:"reset"}),Kt.BREAK;var e=U.getOperationStateNumber();ft(_.isString(r),e,n,null)},"EditApplication.startSynchronizationProcess",{delay:0,repeatDelay:3e3,cycles:9})})}}function nt(){pn.log("NoResponseInTime notification received - Server has not responded in a certain time"),L.isLocked()||L.isInQuit()||L.setInternalError(nn.WARNING_CONNECTION_INSTABLE)}function rt(){if(pn.log("Shutdown notification received - Document middleware node is going down!"),!L.isLocked()&&!L.isInQuit()&&xt()){var e=M.hasPendingActions()||L.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}};N&&e?L.setInternalError(nn.ERROR_SERVER_SHUTDOWN_NO_RESCUE_POSSIBLE,en.CONNECTION,null,t):L.setInternalError(nn.ERROR_SERVER_GOING_TO_SHUTDOWN,en.CONNECTION,null,t)}}function it(){if(pn.log("Crashed node notification received - Document middleware node is not available anymore!"),!L.isLocked()&&!L.isInQuit()&&xt()){var e=M.hasPendingActions()||L.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}};N&&e?L.setInternalError(nn.ERROR_SERVER_NODE_UNAVAILABLE_NO_RESCUE_POSSIBLE,en.CONNECTION,null,t):L.setInternalError(nn.ERROR_SERVER_NODE_UNAVAILABLE,en.CONNECTION,null,t)}}function ot(e,t){if(pn.log("Hangup notification received - document cannot be edited anymore!"),!L.isLocked()&&!L.isInQuit()&&xt()){var n=M.hasPendingActions()||L.hasUnsavedChanges(),r=new Xt(t);r.isError()||(r=new Xt(nn.ERROR_SERVER_NOTIFIED_A_CRITICAL_DOC_PROBLEM)),Et()&&(n||function(e){var t=!1;if(Xt.isErrorCode(e)&&e.isError()){switch(e.getCodeAsConstant()){case"SAVEDOCUMENT_FILE_HAS_CHANGED_ERROR":case"GENERAL_FILE_NOT_FOUND_ERROR":case"GENERAL_PERMISSION_READ_MISSING_ERROR":case"GENERAL_PERMISSION_WRITE_MISSING_ERROR":case"LOADDOCUMENT_CANNOT_RETRIEVE_OPERATIONS_ERROR":t=!0}}return t}(r))?O?L.setInternalError(nn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,en.CONNECTION):L.restoreDocument(r):L.setInternalError(r,en.CONNECTION)}}function at(e,t){if(pn.log("OT reload notification received - client must reload the document"),!L.isInQuit()){var n=new Xt(t);n.isError()||(n=new Xt(nn.ERROR_SERVER_NOTIFIED_A_CRITICAL_DOC_PROBLEM)),st(n,en.CONNECTION)}}function st(e,t){L.trigger("docs:reload:prepare"),L.setInternalError(e,t),L.executeDelayed(function(){L.reloadDocument()},"EditApplication.handleOTReload",1500)}function lt(e,t){if(!L.isInQuit())if(new Xt(t).isError())_e&&_e.reject(t);else{var n=Kt.getStringOption(t,"fileId",null),r=Kt.getStringOption(t,"fileName",null);n&&r?(_e&&_e.resolve(t),L.updateFileDescriptor({id:n,filename:r,title:Jt.getFileBaseName(r)}),w.action="load",delete w.template,A=!1,L.reloadDocument()):_e&&_e.reject(t)}}function ct(e){if(qn.log("$back{lightgreen}handleEditRequestViaUpdate",e),!L.isInQuit()&&null===le&&!W&&V===k){var t=e&&_.isArray(e.activeUsers)?_.find(e.activeUsers,function(e){return e&&e.clientUID!==k&&e.requestsEditRights}):null,n=t?t.clientUID:null;if(n){if(qn.log("$back{lightgreen}__handleEditRequestViaUpdate - clientUIDRequesting ",Ae,ze(n)),Ae)return qn.log("$back{lightgreen}__handleEditRequestViaUpdate - BLOCK OTHER REQUESTS?",n),void(Ae.clientUID!==n&&xt()&&(qn.log("$back{lightgreen}__handleEditRequestViaUpdate - REQUEST BLOCKED!"),M.declineEditRights(n)));qn.log("$back{lightgreen}__handleEditRequestViaUpdate - Request edit rights",a);var r=function(e){if(qn.log("$back{MediumAquaMarine}handleEditRightsTransferRequest"),function(){var e=12e4,t=0<a,n=null,r=_.now()-De;qn.log("inactivCheck knownWhenLastOpWasSend",t),t?(n=Date.now()-a,qn.log("inactivCheck sendActionsTime",a,n)):(n=Date.now()-oe,qn.log("inactivCheck importFinishedTime",oe,n));return qn.log("inactivCheck User is inactive?",e<n,!Kt.wasKeyPressedWithinTime(e),"timeDeltaToLastTransfer",r,e<r),e<n&&!Kt.wasKeyPressedWithinTime(e)&&e<r}())return mn(Yn);var i=L.newDeferred("EditApplication.handleEditRightsTransferRequest"),t=L.createAbortablePromise(i);Ae={deferred:i,promise:t,clientUID:e},qn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest - callForUserInput"),x.yell({type:"question",message:hn("%1$s is asking for edit rights. This request will be accepted automatically in %2$d seconds.",_.noI18n(ze(e)),Math.floor(Un/1e3)),duration:Un,progress:!0,disableCloser:!0,restoreHidden:!0,priority:!0,renderFn:function(e){var t=$.button({label:hn("Decline")}).addClass("btn-default").css({marginRight:5});t.on("click tab",function(){qn.log("$back{Orchid}__handleEditRightsTransferRequest - DECLINE BUTTON PRESSED BY USER"),De=Date.now(),qn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest -> DECISION: declined"),i.resolve(Wn)});var n=$.button({label:hn("Accept")}).addClass("btn-primary");n.on("click tab",function(){qn.log("$back{Orchid}__handleEditRightsTransferRequest - ACCEPT BUTTON PRESSED BY USER"),qn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest -> DECISION: accepted"),i.resolve(Vn)});var r=$('<div class="button-area" style="text-align:center;margin-top:10px;">');e.append(r.append(t,n))}});var n=L.executeDelayed(function(){qn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest - DECISION: accepted automatically"),i.resolve(Vn)},"EditApplication.handleEditRightsTransferRequest.autoAcceptTimer",{delay:Un,background:!0});return t.always(function(){Ae=null,n.abort(),x&&x.hideYell({priority:!0})}),t}(n);r.done(function(e){if(qn.log("$back{lightgreen}__handleEditRequestViaUpdate - answer: "+e),e===Wn)return qn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer declined"),void(xt()&&M.declineEditRights(n));qn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer accepted"),je(!(W=!0)),L.setCurrentInfoState(rn.INFO_PREPARE_LOSING_EDIT_RIGHTS,{showMessage:e===Yn}),qe(),L.getController().update();var t=F&&F.prepareLoseEditRightsHandler;(t?Rn(t.bind(L)):mn()).always(function(){pn.log("handle PrepareLosingEditRights"),L.executeDelayed(function(){!function e(t){L.hasUnsavedChangesOffice()?L.executeDelayed(function(){e(t)},"EditApplication.checkForPendingOperations",2e3):Tt().then(function(){xt()&&M.canLoseEditRights(t),W=!1,L.getController().update(),pn.log("sent canLoseEditRights")})}(n)},"EditApplication.handlePrepareLosingEditRights",1e3)})}),r.fail(function(e){qn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer failure, reason:",e)})}}}function dt(){Ne.abort(),qn.log("$back{SandyBrown}abortPendingEditRightsRequest")}function ut(){Ae&&(Ae.promise.abort(),qn.log("abortPendingEditRightsTransfer"))}function gt(t){qn.log("$back{lightblue}applyEditState - DOC UPDATE",t);var e=O?null:Kt.getStringOption(t,"editUserId",""),n=O?null:ze(e),r=O?null:n||t.editUser,i=O?null:N,o=O?null:i,a=L.getFileDescriptor(),s=U.getOperationStateNumber(),l=O?null:Kt.getIntegerOption(t,"serverOSN",-1),c=new Xt(t),d=Kt.getIntegerOption(t,"lockedByUserId",-1),u=Kt.getBooleanOption(t,"writeProtected",null);if(O?pn.log("$badge{EditApp} applyEditState: clientOSN = "+s):pn.log("$badge{EditApp} applyEditState: clientOSN = "+s+", localServerOSN = "+l),!T&&Kn.some(function(e){return e in t})){if(O||e===V||(pn.log("Edit rights changed, new editing user id: "+e),o=k===e,L.setCurrentInfoState(rn.INFO_USER_IS_CURRENTLY_EDIT_DOC,{showMessage:!1}),qn.log("$back{lightblue}__applyEditState - EDITOR HAS BEEN CHANGED","|editClientId:",e,"|oldEditClientId:",V),Ne.running&&""!==e&&(qn.log("$back{lightblue}__applyEditState - FORCE TIMER ABORTED the editor has been changed"),dt())),Kt.getBooleanOption(t,"failSafeSaveDone",!1)&&Jt.propagateChangeFile(a),Kt.getBooleanOption(t,"hasErrors",!1))return L.setInternalError(nn.ERROR_GENERAL_SYNCHRONIZATION_ERROR,en.SYNCHRONIZATION),void pn.error("synchronization to the server has been lost.");G||(un.RESCUE_DOCUMENT_READONLY&&L.isRescueDocument()?(je(!(G=!0)),L.setInternalError(nn.WARNING_RESCUE_DOC_CANNOT_BE_CHANGED,en.READONLY)):_.isBoolean(u)&&u?(je(!(G=!0)),L.setInternalError(nn.WARNING_NO_PERMISSION_FOR_DOC,en.READONLY)):-1!==d&&ox.user_id!==d&&(je(!(G=!0)),L.setInternalError(nn.WARNING_DOC_IS_LOCKED,en.READONLY),C=Kt.getStringOption(t,"lockedByUser",""))),G||W||(O?je(!0):(pn.log("Edit mode: "+o),je(o),!o&&(!I||i||r!==R&&r.length)&&(R=r,L.setCurrentInfoState(rn.INFO_USER_IS_CURRENTLY_EDIT_DOC)),I&&e&&e!==V&&(function(e){var t=V,n=e,r=[n];_.isString(t)&&0<t.length&&r.push(t);V=n,ht(r)}(e),R=r),o&&!1===i&&L.setCurrentInfoState(rn.INFO_EDITRIGHTS_RECEIVED),I&&!o&&i&&-1!==l&&l<s&&(L.setInternalError(nn.ERROR_GENERAL_SYNCHRONIZATION_ERROR,en.SYNCHRONIZATION),pn.error("synchronization between client and server is broken. Switching editor into read-only mode. New edit mode: "+o+"Old edit mode: "+i+", local Server OSN: "+l+", Client OSN: "+s))),(c.isError()||c.isWarning())&&L.setInternalError(c,en.GENERAL)),I=!0,qe()}}function pt(e){var t=null,n=function(){if(0<p.length)return!0;var e=xt()?M.getPendingActions():null;return e&&_.isArray(e.actions)&&0<e.actions.length}();function r(){pn.log("logSynchronizationState... ","\n     localChanges = ",n,"\n     rtConnection.getPendingActions() = ",xt()&&JSON.stringify(M.getPendingActions()),"\n     actionsBuffer = ",JSON.stringify(p),"\n     mustSyncNowMode = ",le,"\n     failedData = ",JSON.stringify(e))}if(le){if(pn.log("Checking synchronization state with server"),e){switch(e.cause){case"timeout":pn.log("Synchronization not possible - maybe connection instance is gone"),(t=new Xt(nn.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(en.SYNCHRONIZATION),r(),le=null;break;case"notMember":case"reset":case"error:disposed":pn.log("Synchronization not possible - connection instance is gone or rt-state broken"),(t=new Xt(nn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(en.SYNCHRONIZATION),r(),le=null}Qe(t)}switch(le){case"editSync":if(n)return;pn.log("Synchronization successfully completed"),je(!(G=!1)),L.setCurrentInfoState(rn.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0});break;case"viewSync":pn.log("Synchronization for viewer completed"),L.setCurrentInfoState(rn.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})}r(),le=null}}function ft(e,t,n,r){var i=null,o=function(){if(0<p.length)return!0;var e=xt()?M.getPendingActions():null;return _.isObject(e)&&_.isArray(e.actions)&&0<e.actions.length}();function a(e,t){pn.log("logSynchronizationState... ","\n     localChanges = ",o,"\n     rtConnection.getPendingActions() = ",xt()&&JSON.stringify(M.getPendingActions()),"\n     actionsBuffer = ",JSON.stringify(p),"\n     mustSyncNowMode = ",le,"\n     clientOSN = ",e,"\n     serverOSN = ",t,"\n     oldEditUser = ",R,"\n     failedData = ",JSON.stringify(r))}if(le){if(pn.log("Checking synchronization state with server"),r){switch(r.cause){case"timeout":pn.log("Synchronization not possible - maybe connection instance is gone"),(i=new Xt(nn.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(en.SYNCHRONIZATION),a(t,n),le=null;break;case"notMember":case"reset":case"error:disposed":pn.log("Synchronization not possible - connection instance is gone or rt-state broken"),(i=new Xt(nn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(en.SYNCHRONIZATION),a(t,n),le=null}Qe(i)}switch(le){case"editSync":if(Et()){if(o)return;pn.log("Synchronization successfully completed"),je(!(G=!1)),L.setCurrentInfoState(rn.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0})}else o?(pn.log("Synchronization not possible - editor changed"),(i=new Xt(nn.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)).setErrorContext(en.SYNCHRONIZATION),L.restoreDocument(i)):n<=t?(pn.log("Synchronization possible - but we lost edit rights"),G=!1,L.setCurrentInfoState(rn.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(pn.log("Synchronization not possible - did not receive missing operations"),L.reloadDocument());break;case"viewSync":n<=t?(pn.log("Synchronization for viewer completed"),G=!1,L.setCurrentInfoState(rn.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(pn.log("Synchronization not possible - did not receive missing operations"),L.reloadDocument())}a(t,n),le=null}}function Et(){return O||k===V}this.getServerModuleDocUrl=function(e,t,n){if(!xt()||!ox.session||!this.hasFileDescriptor())return null;var r=this.getFileParameters(_.extend({},n,{encodeUrl:!0}));return t=_.extend({session:ox.session,uid:this.get("uniqueID"),docuid:M.getDocUID()},r,t),ox.apiRoot+"/"+e+"?"+_.map(t,function(e,t){return t+"="+e}).join("&")};var ht=this.createSynchronizedMethod("EditApplication.applyUserData",function(e){qn.log("$back{PaleGoldenRod}applyUserData - CLIENT UPDATE",e);var t=null;if(_.isArray(e)?(t={clients:{changed:[]}},_.each(e,function(e){t.clients.changed.push({clientUID:e})})):t=e,!_.isObject(t))return Cn.error("$badge{EditApp} applyUserData: called without valid data: "+JSON.stringify(t)),$.when();var a=ne,n=Kt.getObjectOption(t,"clients",{}),r=[],i=[];if(V===k&&_.isArray(n.changed)&&0<n.changed.length&&ct({activeUsers:n.changed}),_.isArray(n.list))i=n.list;else if(_.isArray(n.left)||_.isArray(n.joined)||_.isArray(n.changed)){var o={};ne.forEach(function(e){o[e.clientUID]=e}),_.isArray(n.left)&&n.left.forEach(function(e){delete o[e]}),_.isArray(n.joined)&&n.joined.forEach(function(e){o[e.clientUID]=e}),_.isArray(n.changed)&&n.changed.forEach(function(e){o[e.clientUID]=_.extend({},o[e.clientUID],e)}),Object.keys(o).forEach(function(e){i.push(o[e])})}return 0===i.length?$.when():(_.each(i,function(t){var e=_.isObject(t)&&_.isString(t.clientUID),n=e&&!_.isNumber(t.userId)&&_.isNumber(t.id);e?n?r.push(L.getUserInfo(t.id).then(function(e){return t.userDisplayName=e.displayName,t.userOperationName=e.operationName,t})):r.push($.when(t)):Cn.warn("$badge{EditApp} applyUserData: missing identifier")}),L.createResolvedPromise().then(function(){return $.when.apply($,r)}).done(function(){var e,t,n,r;if(te=_.map(arguments,function(e){var t=e;return _.isNumber(e.userId)||((t={}).clientUID=e.clientUID,t.userId=e.id,t.userName=e.userDisplayName,t.userOperationName=e.userOperationName,t.guest=e.guest),t.active=!0===e.active||_.isNumber(e.durationOfInactivity)&&e.durationOfInactivity<60,t.remote=k!==t.clientUID,t.editor=V===t.clientUID,_.isObject(e.userData)&&(t.userData=e.userData),t.clientUID in X||(X[t.clientUID]=ee,ee+=1),t.clientIndex=X[t.clientUID],t.colorIndex=L.getAuthorColorIndex(t.userOperationName),t}),ne=_.where(te,{active:!0}),ne=_.sortBy(ne,"clientIndex"),!_.isEqual(a,ne)){Cn.info("$badge{EditApp} applyUserData: activeClients=",ne),t=ne,(e=a).length===t.length&&(n=_.copy(e,!0),r=_.copy(t,!0),_.each(n,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.each(r,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.isEqual(n,r))||L.trigger("docs:users",ne),Ae&&!_.findWhere(ne,{clientUID:Ae.clientUID})&&ut();var i=_.first(_.pluck(_.where(a,{clientUID:k}),"requestsEditRights")),o=_.first(_.pluck(_.where(ne,{clientUID:k}),"requestsEditRights"));!0===i&&!1===o&&(qn.log("$back{PaleGoldenRod}__applyUserData - REQUEST_EDITRIGHTS FOR USER -> is false - > event spinner off",i,o,V!==k),dt(),V!==k?(qn.log("$back{PaleGoldenRod}__applyUserData - YOUR REQUEST WAS DECLINED"),x.yell({message:hn("Your request for edit rights has been declined.")})):De=_.now()),L.trigger("docs:users:selection",ne)}}))});function Ot(){O&&0<$e.length&&!U.isProcessingActions()&&!function e(t){St(t,!0).done(function(){$e.shift(),0<$e.length&&e($e[0])})}($e[0])}function _t(e,t){var n;Le<e?t?e===Le+1?(Le=e,xe=-1):(xe=e,Bn.info("$badge{EditApp} setServerOSN: Saving OSN from ack temporarily: "+xe)):(Le+1<e&&Bn.info("$badge{EditApp} setServerOSN: Setting server OSN. Info: Increasing OSN by more than 1. Increasing from: "+Le+" to "+e),n=Le,xe===(Le=e)+1?(Bn.info("$badge{EditApp} setServerOSN: Updating server OSN with saved ack osn: "+xe+". Triggering event: docs:ackosn:updated."),Le=xe,xe=-1,L.trigger("docs:ackosn:updated")):0<=xe&&xe<Le&&(Bn.error("$badge{EditApp} setServerOSN: ERROR: Setting server OSN. Receiving OSN from external operation: "+e+". But still have temporary OSN from acknowledge: "+xe),Bn.error("$badge{EditApp} setServerOSN: ERROR: Current locally used server OSN is: "+n),xe=-1,L.trigger("docs:ackosn:updated"))):Bn.info("$badge{EditApp} setServerOSN: Setting server OSN. Avoiding to set server OSN to: "+e+". Current OSN is already: "+Le),Bn.info("$badge{EditApp} setServerOSN: Setting server OSN to: "+Le),U.trigger("change:osn",Le)}function St(e,t){if(T)return pn.error("$badge{EditApp} applyRemoteOperations: failed due to internal error"),$.Deferred().reject();var n=O?_n(e.docStatus,"serverOSN",-1):0;if(n<0)return Cn.error("$badge{EditApp} applyRemoteActions: missing server OSN in external operations"),$.Deferred().reject();var r=Zn(e);if(0===r.length)return O&&_t(n),$.when();if(gn.handleMinifiedActions([{operations:r}],!0),O||U.undoManager.clearUndoActions(),pn.log("$badge{EditApp} applyRemoteOperations: last remote operation: "+JSON.stringify(_.last(r))),O){if(U.isProcessingInternalOperations()||0<$e.length&&!t)return t||$e.push(e),L.createResolvedPromise({cached:!0});if(Bn.info("$badge{EditApp} applyRemoteOperations: received external operations with server OSN "+n),_t(n),0<Fe.length)try{ke+=r.length,r=L.otManager.transformOperations(r,Fe)}catch(e){return"OTError"===e.name?(p=[],st(new Xt(nn.ERROR_CLIENT_OT_UNRESOLVABLE_OP_CONFLICT_ERROR))):Bn.exception(e,"$badge{EditApp} applyRemoteOperations: operation transformation failed"),$.Deferred().reject({cause:"operation"})}else Bn.trace("$badge{EditApp} applyRemoteOperations: external operations not transformed:",r)}var i=U.applyExternalOperations(r);return i.done(function(){D=!0}),i.fail(function(){L&&!L.isInQuit()&&pn.error("$badge{EditApp} applyRemoteOperations: failed")}),i}var mt=this.createSynchronizedMethod("EditApplication.applyUpdateMessageData",function(s){if(function(e){if(!O){var t=!1,n=U.getOperationStateNumber();return un.RESTORE_DOCUMENT_ENABLED&&0<e.length&&(t=!("editSync"!==le||!xt()||!M.hasPendingActions())||n!==e[0].osn),t}}(Zn(s)))return O?L.setInternalError(nn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,en.CONNECTION):le||Et()?L.restoreDocument(new Xt(nn.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)):L.setInternalError(nn.ERROR_GENERAL_SYNCHRONIZATION_ERROR,en.CONNECTION),$.when();var e=St(s);return e.done(function(e){var t,n,r,i,o,a;_.isObject(s)&&!_.isObject(s.docStatus)&&Cn.error("$badge{EditApp} broadcast_update sent bad data "+JSON.stringify(s)),O&&e&&e.cached||(gt(s.docStatus),t=s,n=L.getFileDescriptor(),r=Kt.getStringOption(t,"fileName",""),i=Kt.getStringOption(t,"com.openexchange.file.sanitizedFilename",""),o=Kt.getStringOption(t,"fileVersion",""),a={},0<r.length&&r!==Kt.getStringOption(n,"filename")&&(a.filename=r),0<i.length&&i!==Kt.getStringOption(n,"com.openexchange.file.sanitizedFilename")&&(a["com.openexchange.file.sanitizedFilename"]=i),0<o.length&&o!==Kt.getStringOption(n,"version")&&(a.version=o),T||_.isEmpty(a)||(L.updateFileDescriptor(a),L.getController().update(),qe()))}),e});function It(e){if(!_.isObject(e))return Cn.error("$badge{EditApp} registerUpdateMessageData: invalid response (object expected):",e),this.setInternalError(nn.ERROR_WHILE_MODIFYING_DOCUMENT,en.GENERAL),$.Deferred().reject();if(pn.log("$badge{EditApp} registerUpdateMessageData: received update message:",e),0<re.length&&k!==e.editUserId){pn.log(" "+re.length+' existing pending updates must be changed to user "'+e.editUserId+'"');var t={editUser:e.editUser,editUserId:e.editUserId};re.forEach(function(e){_.extend(e,t)})}re.push(e);var n=mt(e);return n.always(function(){re.shift(),pn.log("$badge{EditApp} registerUpdateMessageData: update processed, "+re.length+" pending messages left")}),n}function Rt(e,t,n){if(!e)return mn();var r=Rn(e.bind(L)).fail(function(){Cn.warn("$badge{EditApp} failed initialization step: "+n)});return r=r.then(function(e){return L.isInQuit()?In({cause:"closing"}):e}),L.launchTracker.asyncStep(r,t,"$badge{EditApp} "+n)}function Nt(e){if(_.isObject(L)&&!L.isInQuit()||(e={cause:"quit"}),de)return{cause:""};var t,n=new Xt(e),r=n.getCodeAsConstant();switch(T=!0,s.call(L,e),e=_.clone(e),r){case"GENERAL_FILE_NOT_FOUND_ERROR":b=!0}return n.isError()||(n=(t=e)&&t.error_desc&&t.error_id&&_.isString(t.error_desc)&&_.isString(t.error_id)?function(e){if(n=new Xt(Xt.GENERAL_ERROR),e&&e.error_desc){var t=e.error_desc;n.setDescription(t)}return n}(e):new Xt(nn.ERROR_UNKNOWN_REALTIME_FAILURE)),L.isInQuit()||L.setInternalError(n,en.LOAD,null,{showMessage:!1}),e=_.extend({},e,{errorForErrorCode:L.isViewerMode()}),de=!0,e}function At(e,t){var n={operations:e||[]};return t&&(n.userData=t),n}function Dt(){return i&&i.operations&&0<i.operations.length}function vt(){return r||0<p.length||Dt()}function yt(t){vn(Fe,function(e){return!e[t]})}var bt,Ct,Tt=(bt=null,function(){if(pn.log("$badge{EditApp} sendActions: entered"),r)return pn.log("$badge{EditApp} sendActions: sending in progress - using current promise"),bt.promise();if(T)return pn.error("$badge{EditApp} sendActions: internal error detected - promise rejected!"),$.Deferred().reject();if(O&&(vn(p,function(e){return 0<e.operations.length}),vn(Fe,function(e){return 0<e.operations.length})),0===p.length)return pn.log("$badge{EditApp} sendActions: no need to send action buffer empty"),$.when();if(O){if(0<=xe)return Bn.info("$badge{EditApp} sendActions: Not all external operations are currently applied. Coming back later, when all external ops are applied!"),L.once("docs:ackosn:updated",jt),bt.promise();if(U.isProcessingExternalOperations())return Bn.info("$badge{EditApp} sendActions: External operations are currently applied. Coming back later in operations:after handler!"),U.one("operations:after",qt),bt.promise()}return bt=L.createDeferred("EditApplication.sendActions").always(function(){pn.log("$badge{EditApp} sendActions: current send promise resolved - sendingActions = false"),r=!1,a=_.now(),qe()}),r=!0,qe(),function t(){if(un.REALTIME_DEBUGGING&&W&&p&&0<p.length){var e=p[p.length-1].operations;e&&0<e.length&&Cn.log("$badge{EditApp} sendActionsBuffer: last action:",_.last(e))}if(O&&we)return L.executeDelayed(function(){t()},"sendActionsBuffer",1e3),void bt.resolve();if(l&&c){var n=O?p.length:0;p=l.call(L,p),O&&p.length!==n&&yt("_OPTIMIZED_OPERATION_")}Hn("$badge{EditApp} sendActions: sending local actions, serverOSN="+Le,p),p=gn.handleMinifiedActions(p),O&&Fe.forEach(function(e){e.sentToServer=!0});var r=p.map(function(e){return{operations:e.operations}}),i=O?Le:void 0,o=xt()?M.sendActions(r,i):L.createRejectedPromise();o.done(function(e){O&&(Bn.info("$badge{EditApp} sendActions: Receiving acknowledge with new OSN sent from server: "+e.body.serverOSN),_t(e.body.serverOSN,!0),Bn.info("$badge{EditApp} sendActions: Trying to clear local operation cache after receiving acknowledge"),Gt()),T?(pn.error("$badge{EditApp} sendActionsBuffer: sent successfully, but internal error detected!"),bt.reject()):0===p.length?bt.resolve():O&&U.isProcessingExternalOperations()?(Bn.info("$badge{EditApp} sendActions: External operations are currently applied. Calling sendActions later in operations:after handler!"),U.one("operations:after",qt),bt.resolve()):O&&0<xe?(Bn.info("$badge{EditApp} sendActions: External operations are still missing. Calling sendActions later in operations:after handler!"),U.one("operations:after",qt),bt.resolve()):t()}),o.fail(function(e){pn.error("$badge{EditApp} sendActionsBuffer: rtConnection.sendActions promise failed!"),bt.reject(e)}),p=[]}(),bt.promise()}),wt=(Ct=L.createDebouncedMethod("EditApplication.storeAndSendDebounced",function(t){var e=!1;pn.log(function(){var e=0<t.operations.length?JSON.stringify(_.last(t.operations)):null;return"$badge{EditApp} storeAction: "+(e?"last operation: "+e:"no operations provided")}),h&&0<Oe.length&&(p=h.call(L,p,Oe),Oe=[],e=!(h=null)),!T&&(0<t.operations.length||e)&&(0<t.operations.length&&(p.push(t),O&&(Fe.push(t),Hn("$badge{EditApp} registerAction: added local action without ACK to cache",Fe))),o=A=!0,qe())},Tt,{delay:d,maxDelay:d}),function(e){Ee?Ct(e):(pn.log("$badge{EditApp} registerAction: cached action during non-distribution mode"),Oe.push(e))});function Ft(t){var e=x.processUnsavedComment(t===$n.QUIT);return e=(e=(e=e.then(function(){return v})).then(function(){var e=F&&F.prepareFlushHandler;return e?e.call(L,t):null})).then(function(){var e=Tt();return t===$n.QUIT&&(e=Jn(e,5e3,"EditApplication.prepareFlushDocument")),e})}var Lt,Ut=_.once(function(){if(je(!1),xt()){var e=F&&F.prepareLeaveDataHandler,t=e?e.call(L):null;M.emergencyLeave(t)}});function xt(){return!(!M||M.destroyed)}function kt(){M&&(dt(),ut(),M.destroy(),L.rtConnection=M=null)}function $t(e,t,n){if(!xt())return In();var r=null,i=M.getConnectOpenState();if(pn.log("$badge{EditApp} executeShutdownStep: - silentShutdownEntered:",Pt()," connectionOpenState:",i," action:",e),!Pt()){var o=!1,a=!1,s=!1;switch(i){case"unknown":case"joining":s=a=o=!1;break;case"joined":s=!(a=o=!1);break;case"opening":s=!(a=!(o=!0));break;case"opened":s=a=!(o=!1)}r=function(){switch(e){case".abortOpen":return o?M.abortOpen():null;case".closeDocument":return a?M.closeDocument(t):null;case".disconnect":return s?M.disconnect(t):null}}()}return Pt()&&(r=function(){switch(e){case".closeDocument:force":return M.closeDocument(t);case".disconnect:force":return M.disconnect(t)}}()),r?n?Jn(r,n,'EditApplication.executeShutdownStep("'+e+'")'):r:In()}function Pt(){return!(null===be)}function Mt(e){var o=Kt.getBooleanOption(e,"skipCloseDoc",!1),a=Kt.getBooleanOption(e,"skipDisconnect",!1);if(pn.log("$badge{EditApp} silentShutdownConnection entered! - silentShutdownConfig:",e,"silentShutdownConnectionEntered",Pt()),!Pt()){je(!(G=!0)),O&&Ue.abort();var s,l=$.Deferred();be=l.promise(),xt()&&M.off(),(s=o?$.when():$t(".closeDocument:force",{no_restore:ve},500)).always(function(e){var t;if(a)t=$.when();else{var n="timeout"===e,r="rejected"===s.state(),i=n||Boolean(o)||r;pn.log("$badge{EditApp} silentShutdownConnection: closeDocument rejected by timeout?:",n),t=$t(".disconnect:force",i,500)}t.always(function(){kt(),pn.log("$badge{EditApp} silentShutdownConnection is finished"),l.resolve()})})}}function Bt(c,e){var d=L.getWindow();function t(e){var t,n,r,i,o=L.createDeferred("EditApplication.checkCloseDocumentResult"),a=new Xt(e),s={},l=null;return a.isError()||a.isWarning()?(t=Kt.getStringOption(e,tn.RESTORED_FILEID,null),n=Kt.getStringOption(e,tn.RESTORED_FILENAME,null),r=Kt.getStringOption(e,tn.RESTORED_FOLDERID,null),l=Kt.getStringOption(e,tn.RESTORED_ERRORCODE,"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"),_.isString(t)&&_.isString(n)&&_.isString(r)?(l=l===Xt.CONSTANT_NO_ERROR?new Xt({errorClass:Xt.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"}):new Xt({errorClass:Xt.ERRORCLASS_ERROR,error:l}),s[tn.RESTORED_FILENAME]=n,Jt.getPath(r).always(function(e){s[tn.RESTORED_PATHNAME]=Jt.preparePath(e),s[tn.ORIGINAL_FILEID]=L.getFileDescriptor().id,L.updateFileDescriptor({id:t,folder_id:r}),L.setInternalError(l,en.CLOSE,a,{additionalData:s})})):L.setInternalError(a,en.CLOSE,null,{additionalData:s}),U&&x?(L.registerQuitHandler(function(){o.reject()}),L.quit=(i=L.quit,function(){return o.reject(),i.call(L)}),d.idle(),o.always(function(){d.busy()}),c===Pn.LOGOUT&&o.reject()):o.reject(),a.getDescription()&&Cn.log(a.getDescription()),o.promise()):e}return $t(".closeDocument",e=e||null,8e3).then(t,function(e){return"timeout"===e?L.createRejectedPromise(e):t(e)})}function Ht(){Bn.info("$badge{EditApp} clearLocalActionsWithoutAckAfterEvent: Clearing the local actions!"),Gt()}function Gt(){U.isProcessingExternalOperations()?(U.off("operations:after",Ht),Bn.info("$badge{EditApp} clearLocalActionsWithoutAck: External operations are currently applied. Coming back later after event operations:after!"),U.on("operations:after",Ht)):0<xe?(L.off("docs:ackosn:updated",Ht),U.off("operations:after",Ht),Bn.info("$badge{EditApp} clearLocalActionsWithoutAck: External operations are still missing. Coming back later after event docs:ackosn:updated or operations:after!"),L.on("docs:ackosn:updated",Ht),U.on("operations:after",Ht)):(Bn.info("$badge{EditApp} clearLocalActionsWithoutAck: Clearing local cache. Before: "+JSON.stringify(Fe)),U.off("operations:after",Ht),L.off("docs:ackosn:updated",Ht),yt("sentToServer"),Bn.info("$badge{EditApp} clearLocalActionsWithoutAck: Clearing local cache. After: "+JSON.stringify(Fe)))}function qt(){Bn.info("$badge{EditApp} sendActionsAfterApplyingExternalOperations: Sending actions after receiving operations:after event!"),Tt()}function jt(){Bn.info("$badge{EditApp} sendActionsAfterReceivingRequiredExternalOperations: Sending actions after receiving docs:ackosn:updated event!"),Tt()}function Vt(){L.isOnline()&&Qt.isTabVisible()&&Ue.start()}this.leaveBusyDuringImport=_.once(function(e,t){return ie=L.launchTracker.step("previewStart","$badge{EditApp} Busy state during import process left"),qe(),x.showAfterImport(e,t)}),this.createDebouncedActionsMethodFor=function(t,e,n,r,i){var o=!1;return t.createDebouncedMethod(e,n,function(){if(!o){if(!L.isImportFinished()||!U.isProcessingActions())return r.call(t);var e=U.waitForActionsProcessed();o=!0,t.await(e,function(){o=!1,r.call(t)})}},i)},this.checkStartOfExternalOperations=function(){!O||i||U.isProcessingInternalOperations()||L.trigger("docs:operations:completed")},this.isRemovalOfInternalBlockerPossible=function(){return O&&!i&&!U.isDrawingChangeActive()},this.getFileFormat=function(){var e;return null===n&&(e=this.hasFileDescriptor()?this.getFullFileName():w&&w.templateFile?w.templateFile.filename:"",n=e?ln.getFileFormat(e):null),n||"ooxml"},this.isOOXML=function(){return"ooxml"===this.getFileFormat()},this.isODF=function(){return"odf"===this.getFileFormat()},this.isTemplateFile=function(){return this.hasFileDescriptor()&&ln.isTemplate(this.getFullFileName())},this.isScriptable=function(){return this.hasFileDescriptor()&&ln.isScriptable(this.getFullFileName())},this.isShutdownReceived=function(){return!1},this.getClientId=function(){return k},this.getShortClientId=function(){return k.slice(0,4)},this.getDocUID=function(){return xt()?M.getDocUID():null},this.getLoadMode=function(){return Te},this.getEditClientId=function(){return V},this.getEditClientUserName=function(){return ze(V)},this.getClientOperationName=function(){return P},this.getActiveClients=function(){return ne},this.isLocallyModified=function(){return A},this.isPrepareLosingEditRights=function(){return W},this.sendActionRequest=function(t,n,r){if(!xt())return L.createRejectedPromise();var e={action:t,docuid:M.getDocUID(),requestdata:JSON.stringify(n)};r=_.extend({method:"POST"},r);var i=this.sendFileRequest(yn,e,r);return i.fail(function(e){Cn.warn("$badge{EditApp} sendActionRequest: failed: ",t,n,r,e)}),i},this.sendAddImageIdRequest=function(e){return xt()?M.addImageId(e).then(_.constant(e)):mn(e)},this.sendLogMessage=un.LOG_ERROR_DATA?function(e){return L&&L.allowStoreLogFile()&&L.sendLogErrorData({errorCode:e}),this}:Kt.NOOP,this.isRenameEnabled=function(){return!Ln&&(!Z&&!un.getDebugFlag("office:simple-filestore")||!this.isDocumentEncrypted()&&!O)},this.rename=function(e){var t=this.getFileDescriptor(),r=Kt.getStringOption(t,"filename",this.getFullFileName()),n=Kt.getStringOption(t,"com.openexchange.file.sanitizedFilename",r),i=An(e);if(this.setUnsavedFileName(null),v)return Cn.warn("$badge{EditApp} rename: multiple calls, ignoring subsequent call"),v;if(0===i.length)return $.Deferred().reject();if(i===this.getShortFileName())return $.when();i+="."+this.getFileExtension(),this.isDocumentEncrypted()&&(i+=Jt.GUARD_EXT),this.updateFileDescriptor({filename:i}),_e=this.createDeferred("EditApplication.renameAndReload",{background:!0});var o=F&&F.prepareRenameHandler;return(v=(v=(v=(v=o?Rn(o.bind(L)):mn()).then(Tt)).then(function(){return xt()?M.renameDocument({target_filename:i}):In()})).then(function(e){var t=new Xt(e);return t.isWarning()&&"RENAMEDOCUMENT_SAVE_IN_PROGRESS_WARNING"===t.getCodeAsConstant()?_e.promise():t.isError()?In(t):e})).done(function(e){y=!0,L.updateFileDescriptor({filename:Kt.getStringOption(e,"fileName",r),"com.openexchange.file.sanitizedFilename":Kt.getStringOption(e,"com.openexchange.file.sanitizedFilename",n)})}),v.fail(function(e){if("abort"!==e){var t=Xt.isErrorCode(e)?e:new Xt(e);t.setErrorContext(en.RENAME);var n=on.getMessageData(t);n.restoreHidden=!1,Cn.warn("$badge{EditApp} rename: error: "+t.getErrorText()),x.yell(n)}L.updateFileDescriptor({filename:r})}),v.always(function(){v=null})},this.getCurrentFileName=function(){return v?x.getToolbarFileNameFieldValue():L.getShortFileName()},this.hasUnsavedChangesOffice=function(){return vt()||!!v||this.hasUnsavedFileName()||!!U&&U.hasUnsavedComments()},this.hasUnsavedChanges=function(){return(!ox.tabHandlingEnabled||zt.getLoggingOutState()!==zt.LOGGING_OUT_STATE.FOLLOWER)&&(!(!xt()||!M.isConnected())&&(this.hasUnsavedChangesOffice()||M.hasPendingActions()))},this.setUserState=function(e){return this.isInternalError()||m===e||(m=e,Ge()),this},this.getState=function(){return m&&!this.isInternalError()?m:S},this.isEditable=function(){return N},this.isOnline=function(){return"offline"!==S},this.isInternalError=function(){return"error"===S},this.setInternalError=function(e,t,n,r){var i,o=Xt.isErrorCode(e)?e:new Xt(e),a=null,s=null,l=null,c=!0,d=Kt.getObjectOption(r,"additionalData",{}),u=Xt.isErrorCode(n)?n:o,g=!1,p=Kt.getObjectOption(r,"silentShutdownConfig",{}),f=o.isError();if(L.isReloading()&&L.setAppReloadDone(L),_.isString(t)&&o.setErrorContext(t),a=L.getErrorState(),(i=!_.isObject(a)||!a.isError())?(L.setErrorState(o),g=!0):_.isObject(a)&&(o=a,s=ye),l=L.getErrorState(),Xt.isErrorCode(l)&&Cn.error("$badge{EditApp} Internal error: "+l.getErrorText()),f)je(!(G=!(I=!(T=!0)))),Mt(p);else{var E=!_.has(ue,o.getCodeAsConstant()),h=ge!==o.getCodeAsConstant();c=E&&h,on.isOnceWarning(o.getCodeAsConstant())&&(ue[o.getCodeAsConstant()]=!0),ge=o.getCodeAsConstant()}qe(o),_.isObject(s)&&!g||(s=on.getMessageData(o,_.extend({causeError:u,viewerMode:L.isViewerMode()},Ve(),d)),L.extendMessageData(s),Ie="document/reload"===Kt.getStringOption(s.action,"itemKey"),ye=s),Kt.getBooleanOption(r,"showMessage",!0)&&c&&x&&x.yell&&x.yell(s),f&&i&&(L.sendLogErrorData({errorCode:o.getCodeAsConstant()}),L.allowStoreLogFile()&&on.createCrashDataForError(o.getCodeAsConstant())&&L.createLogFileInDrive())},this.createLogFileInDrive=function(){var e=L.generateLogData();if(e){var t=hn("A debug report is uploaded to Drive/myFiles/crashdata. This can take a while. Closing the browser tab cancels the upload. The report may contain content of previously opened documents."),n=new kn(t,{title:hn("Generating debug report"),classes:"generate-log-dialog",okLabel:En.CLOSE_LABEL,showReadOnly:!0}),r=hn("Finished upload"),i=hn("Could not upload file"),o=$('<div style="padding: 10px 0; text-align: center; font-weight: 400; font-size: 14px" class="result"><div class="busy-indicator io-ox-busy"></div></div>');n.append(o),n.show(),L.sendLogErrorData({logData:e}).done(function(){o.html('<i class="fa fa-check" aria-hidden="true"></i><span <div style="padding: 0px 5px">'+r+"</span>")}).fail(function(){o.html('<i class="fa fa-exclamation-circle" aria-hidden="true"></i><span style="padding: 0px 5px">'+i+"</span>")})}},this.allowStoreLogFile=function(){return un.LOG_ERROR_DATA&&!!L&&!L.isDocumentEncrypted()},this.sendLogErrorData=function(e){var t=_.has(e,"errorCode"),n=_.has(e,"logData");if(!t&&!n)return L.createRejectedPromise();function r(e){return a?"hidden":e}var i,o,a=!un.LOG_ERROR_DATA,s=L.getFileDescriptor(),l={action:"logclientdata",logAnonymous:String(a),fileId:String(r(s&&s.id)),folderId:String(r(s&&s.folder_id)),fileName:String(r(L.getFullFileName())),userId:String(ox&&ox.user_id),docUid:String(Me),errorCode:t?(o=e&&e.errorCode,String(o||"unknownError")):"",logData:n&&L.allowStoreLogFile()?(i=e&&e.logData,String(i)):""};return L.sendRequest(yn,l,{method:"POST",dataType:"xml"})},this.setCurrentInfoState=function(e,t){var n=null,r=Kt.getBooleanOption(t,"showMessage",!0),i=null;Kt.getBooleanOption(t,"resetWarning",!1)&&(i=L.getErrorState(),_.isObject(i)&&i.isError()||L.setErrorState(new Xt)),L.setInfoState(e),r&&(n=an.getMessageData(e,_.extend({},Ve(),t)),L.extendMessageData(n),_.isObject(n)&&x.yell(n))},this.isLocked=function(){return T||G},this.isAcquireEditRightsEnabled=function(){return!O&&xt()&&!this.isLocked()&&this.isOnline()&&!N},this.isAcquireEditRightsEnabledPendingUpdates=function(){return this.isAcquireEditRightsEnabled()&&re.length<=1},this.acquireEditRights=function(){if(qn.log("$back{Orchid}acquireEditRights - User wants to acquireEditRights -> Button pressed  "),this.isAcquireEditRightsEnabled())return Ne.start();dt()},this.saveDocumentAs=function(n,e,r,i){var o=e,a=null,s=L.getFileDescriptor(),t=null,l=!1;switch(r){case wn.NATIVE:if(i&&i.encrypted){o+="."+L.getFileExtension()+Jt.GUARD_EXT,t=(t=Jt.authorizeGuard().then(function(e){return w.auth_code=e,L.flushDocument($n.DOWNLOAD)},function(){return l=!0,In()})).then(function(){var e=s.file_options||{},t=e.params||{};return _.extend(t,{cryptoAction:"Encrypt",filedisplay:o,ignoreWarnings:!1}),s.file_options=_.extend(e,{params:t}),Jt.copyFile(s,n)});break}case wn.TEMPLATE:o+="."+L.getFileExtension(),t=(t=L.createResolvedPromise()).then(function(){return xt()?M.copyDocument({file_id:L.getFileParameters().id,target_filename:e,asTemplate:r===wn.TEMPLATE,target_folder_id:n}):In()});break;case wn.PDF:o+=".pdf",t=(t=(t=L.flushDocument($n.DOWNLOAD)).then(function(){return Jt.propagateChangeFile(s)})).then(function(){return Jt.getFileModelFromDescriptor(s).then(function(e){return Wt.sendConverterRequest(e,{documentformat:"pdf",saveas_filename:o,saveas_folder_id:n})})});break;default:return Cn.error('$badge{EditApp} saveDocumentAs: unknown file type "'+r+'"'),In()}return(t=(t=(t=t.then(function(e){var t=new Xt(e);return t.isError()?In(t):e})).then(function(t){return o=Kt.getStringOption(t,"filename")||o,Jt.deleteFromCache(n),Jt.getPath(n).then(function(e){return a=Jt.preparePath(e),t})})).then(function(e){if(r!==wn.PDF){r===wn.TEMPLATE&&L.setCurrentInfoState(rn.INFO_DOC_SAVED_AS_TEMPLATE,{fullFileName:o,fullPathName:a,type:"success",duration:1e4});var t=Kt.getStringOption(e,"id",null);return!t&&i&&i.encrypted&&(t=_.isArray(e)?Kt.getStringOption(_.first(e),"data",null):e),n=n||Kt.getStringOption(e,"folder_id",null),Jt.getFile({id:t,folder_id:n}).then(function(e){e.title=Jt.getFileBaseName(e.filename),L.updateFileDescriptor(e),w.action="load",delete w.template,L.reloadDocument();var t=L.newDeferred("EditApplication.saveDocumentAs.keepBusyScreenOpen");return L.createAbortablePromise(t)})}L.setCurrentInfoState(rn.INFO_DOC_SAVED_IN_FOLDER,{fullFileName:o,fullPathName:a,type:"success",duration:1e4})})).fail(function(e){"destroy"!==e&&("cancel"===e||l||(Wt.isDocConverterError(e)?x.yell({type:"error",message:Wt.getErrorTextFromResponse(e)}):((e=Xt.isErrorCode(e)?e:new Xt(Xt.GENERAL_ERROR)).setErrorContext(en.SAVEAS),Cn.warn('$badge{EditApp} saveDocumentAs: Error code "'+e.getCodeAsConstant()+'"'),x.yell(on.getMessageData(e,Ve())))))}),t},this.isReloadEnabled=function(){return Ie},this.reloadDocument=function(e,t){this.trigger("docs:reload:prepare");var n=this.getFileDescriptor(),r=this.getFullFileName(),i=ln.getEditModule(r);if(!i)return Cn.error("$badge{EditApp} reloadDocument: unknown application type"),In();if(!ln.isNative(r))return Cn.error("$badge{EditApp} reloadDocument: unsupported document type"),In();e=_.extend({},e,{action:"load",file:n}),w.auth_code&&(e.auth_code=w.auth_code),e.activeTabId=x.getToolBarTabs().getActiveTabId(),e.commentsPaneVisible=x.commentsPane&&x.commentsPane.isVisible();var o=F&&F.prepareReloadHandler;return o&&_.extend(e,o.call(this)),x.isBusy()||t||x.enterBusy(),Cn.info("$badge{EditApp} reloadDocument: start reloading the document",e),this.quit(Pn.RELOAD,{editModule:i+"/main",reloadLaunchOptions:e})},this.restoreDocument=function(l,e){var t=Kt.getArrayOption(e,"actions",null),n=L.getFileDescriptor(),r=null;if(un.RESTORE_DOCUMENT_ENABLED){if(!me){if(ve=!(me=!0),_.isNull(t)){var i=gn.handleMinifiedActions(p);r=xt()?(o=M.getPendingActions(),a=i,s=gn.getActionsArray(o),c=gn.getActionsArray(a),_.isArray(s)&&_.isArray(c)?s.concat(c):s):i}else r=t;var o,a,s,c;je(!(G=!0)),qe(),T=!0;var d={action:"saveaswithbackup",file_id:n.id,target_filename:n.filename,target_folder_id:n.folder_id,restore_id:Se,operations:_.isNull(r)?r:JSON.stringify(r)};L.sendFileRequest(yn,d,{method:"POST"}).then(function(e){var n=new Xt(e),t=L.newDeferred("EditApplication.restoreDocument"),r=Kt.getStringOption(e,tn.RESTORED_FILEID,null),i=Kt.getStringOption(e,tn.RESTORED_FILENAME,null),o=Kt.getStringOption(e,tn.RESTORED_FOLDERID,null),a=null,s={};_.isObject(e)&&_.isString(i)&&_.isString(o)?Jt.getPath(o).always(function(e){a=Jt.preparePath(e),t.resolve(a)}):t.resolve(null),t.always(function(e){var t=_.isString(e);n.isError()||(n=new Xt({errorClass:Xt.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"})),s[tn.RESTORED_FILENAME]=i,s[tn.RESTORED_PATHNAME]=a,s[tn.ORIGINAL_FILEID]=L.getFileDescriptor().id,t&&L.updateFileDescriptor({id:r,folder_id:o}),L.setInternalError(n,l.getErrorContext(),l,{additionalData:s})})},function(){L.setInternalError(l)})}}else L.setInternalError(l)},this.rejectEditAttempt=function(e){if(L.isViewerMode())return this;switch(e){case"image":x.yell({message:hn("The image could not be inserted.")});break;case"siri":L.setInternalError(nn.ERROR_SIRI_NOT_SUPPORTED,en.GENERAL);break;case"loadingInProgress":L.setCurrentInfoState(rn.INFO_LOADING_IN_PROGRESS);break;default:L.isImportFinished()?We():L.setCurrentInfoState(rn.INFO_LOADING_IN_PROGRESS)}return this},this.getUserInfo=function(e){return this.createResolvedPromise().then(function(){return Yt.get({id:e})}).then(function(e){var t=!!e.guest_created_by,n=_.noI18n(e.display_name||e.email1||""),r=t?"User "+e.user_id:e.first_name&&e.last_name?_.noI18n(e.first_name+" "+e.last_name):e.last_name?_.noI18n(e.last_name):e.first_name?_.noI18n(e.first_name):n;return{id:e.user_id,displayName:n,operationName:r,guest:t}})},this.updateUserData=(Lt=null,L.createDebouncedMethod("EditApplication.updateUserData",function(e){return Lt=e,this},function(){!xt()||"resolved"!==L.getImportFinishPromise().state()||T||L.isInQuit()||M.updateUserData("updateuserdata",Lt)},{delay:500,maxDelay:1e3})),this.registerAuthorItem=function(e){if("authorId"in e&&"authorName"in e){var t=e.authorId,n=(_.isFinite(t)||_.isString(t))&&Kt.getStringOption(e,"authorName","").trim()||"";n&&(pe[t]={id:t,name:n,initials:Kt.getStringOption(e,"initials","").trim()||null,providerId:Kt.getStringOption(e,"providerId","").trim()||null,userId:Kt.getStringOption(e,"userId","").trim()||null})}},this.getRegisteredAuthorItemById=function(e){return pe[e]},this.getAuthorColorIndex=function(e){return Zt.getSchemeColor((t=e,(n=_.indexOf(fe,t))<0&&(n=fe.length,fe.push(t)),n));var t,n},this.addAuthors=function(e){return fe=_.union(fe,e),this},this.stopOperationDistribution=function(e){return Ee=!1,L.convertToPromise(e.call(L)).always(function(){Ee=!0})},this.isOperationsBlockActive=function(){return he},this.enterBlockOperationsMode=function(e){he=!0,Dt()&&(L.trigger("docs:operations:remove",i.operations.length),i=At(null,i.userData)),e.call(L),he=!1},this.isMultiSelectionApplication=function(){return u},this.isSnapshotApp=function(){return g},this.isFirstTabActivated=function(){return Re},this.getLoadDocInfo=function(){return Pe},this.isOTEnabled=function(){return O},Object.defineProperty(this,"otManager",{get:function(){return t=t||e.createOTManager(this.docModel)},configurable:!0,enumerable:!0}),this.transformPositionWithLocalActions=function(e,t){return this.otManager.transformPosition(e,Fe,t)},this.getOTStatistics=function(){return{extOpCount:ke,otCount:t?t.getStatistics().otCount:0}},this.setOTBlockingOpsMode=function(e){we=e},this.isOTBlockingOpsMode=function(){return we},this.hasLocalActionsWithoutAck=function(){return O&&0<Fe.length},this.getServerOSN=function(){return Le},this.isRescueDocument=function(){return He},this.isRescueDocMode=function(){return un.DEBUG&&He},this.generateLogData=function(){var e=Tn();if(!e)return"";var t=navigator.userAgent,n=Me,r=Be,i=this.getFullFileName();return t+"\ndoc_uid: "+n+"\nclient_uid: "+r+"\napp: "+this.appType+"\nfileName: "+i+"\n \n"+e},this.useOperationOptimization=function(e){c=e},this.showEditToolbarAtStart=function(){return L.getUserSettingsValue("showToolbars",!0)||_.device("!desktop")},this.debugTypeError=un.DEBUG?{testPlace:null,activateTestPlace:function(e){this.testPlace=e},test:function(e){this.testPlace===e&&(Cn.info("You should see a typeError now at",e),this.debugxyz.debugTypeErrorXYZ())}}:$.noop,(Ne=new jn(this)).startHook.on(function(){L.trigger("docs:acquireeditrights:start")}),Ne.finishHook.on(function(){L.trigger("docs:acquireeditrights:end")}),Ue=new xn(function(){return xt()?M.syncStable().catch(_.noop):mn()},{delay:3e4,interval:3e4,windowId:this.getWindowId(),contextMsg:"EditApplication.osnBeacon",background:!0}),this.onInit(function(){U=this.docModel,x=this.docView,this.waitForImport(function(){oe=L.launchTracker.step("triggerImportSuccess","$badge{EditApp} End of import process notified"),De=oe,pn.log("Load-mode:",Te)}),qe(),Ke(),Ze(),this.listenTo(U,"operations:error",function(){je(!1)}),this.on("docs:operations:completed",Ot),ln.supportsEditMode(L.appType)||(je(!(G=!0)),qe(),We(ln.DOM_TEXT_EDIT_ALERT,-1)),Y&&Q&&(Cn.info("$badge{EditApp} onInit(): saving document to local storage is active"),Fn?Cn.info("$badge{EditApp} onInit: current browser supports local storage"):Cn.warn("$badge{EditApp} onInit: current browser does not support local storage")),this.on("docs:flush:success",function(){o=!1}),U.listenTo(Qt.hideTabHook,function(){Qt.BROWSER_TAB_SUPPORT&&o&&L.flushDocument($n.USER),O&&Ue.abort()}),U.listenTo(Qt.showTabHook,function(){O&&Vt()})},this),this.registerBeforeUnloadHandler(function(e){e||Ut()}),this.registerUnloadHandler(function(){Ut()}),this.registerBeforeQuitHandler(function(){if(un.DEBUG&&L.debugTypeError.test("sync-beforeQuitHandler"),T)return mn();var e=L.isOnline()&&L.hasUnsavedFileName()?L.rename(L.getUnsavedFileName()):mn();return e=(e=e.then(function(){return L.isOnline()?Ft($n.QUIT):null})).then(function(){return Et()&&L.hasUnsavedChangesOffice()?x.showQueryDialog(null,hn("This document contains unsaved changes. Do you really want to close?")):void 0})}),this.registerQuitHandler(function(e){function t(){return $.when(be).always(function(){pn.log("$badge{EditApp} quitHandler.finalizeRTConnection called"),kt()})}function n(){try{if(pn.log("$badge{EditApp} quitHandler.connectionGateKeeper entered"),!xt())return;if(Pt())return;var e=M.getCloseLeaveState();switch(pn.log("$badge{EditApp} quitHandler.connectionGateKeeper - connectionOpenState:",e),e){case"unknown":return void Mt();case"closing":case"closed":return void Mt({skipCloseDoc:!0});case"disconnecting":case"disconnected":return;default:return void Mt()}}catch(e){Mt(),Cn.warn("$badge{EditApp} quitHandler.connectionGateKeeper: Error caught:",e)}}var r=null;try{pn.log("$badge{EditApp} quitHandler: reason",e),un.DEBUG&&L.debugTypeError.test("sync-quithandler"),r=e===Pn.RELOAD?(Mt(),$.when()):function(e){var t=null,n=L.getWindow(),r=L.getFileDescriptor(),o=!1,i=null,a=["_OSN","_FILEVERSION","_STORAGEVERSION","_OPERATIONS"],s=e===Pn.LOGOUT,l=L.launchTracker;function c(e){o&&x.updateBusyProgress(e)}function O(r){var e="appsuiteDocsExpiryDates",i=localStorage.getItem(e),o=_.now();i&&(i=JSON.parse(i),_.isObject(i)?_.each(i,function(e,n){if(n!==r&&e<o){var t=t||_.pluck(U.getSupportedStorageExtensions({allApps:!0}),"extension").concat(a);_.each(t,function(e){var t=n+e;localStorage.removeItem(t)}),delete i[n]}}):i=null),(i=i||{})[r]=o+6048e5,localStorage.setItem(e,JSON.stringify(i))}function d(){return Jt.propagateChangeFile(r)}n&&n.busy();var u=A||y||D||b,g="new"===w.action||w.template;r&&(u||un.LOG_PERFORMANCE_DATA||!g&&te.length<=1)&&(i={file:_.extend({last_opened:Date.now()},r),app:L.appType},l.setItem("LocalStorage",J),l.setItem("FastEmptyLoad",ae),l.sendData());var p=xt()&&M.isConnected()&&!L.isShutdownReceived();t=r&&p?(i=ve?i:_.extend({no_restore:ve},i),Qt.BROWSER_TAB_SUPPORT?Bt(e,i).progress(c):Bt(e,i).then(function(c){var d=null,u=null,g=null,p=null,f=null,E=null,e=null,t=A||y||D,n=U.getOperationStateNumber(),h=0,r=20;function i(e){var t=Kt.getBooleanOption(e,"migration",!1);_.each(a,function(e){localStorage.removeItem(u+e)}),t&&(On(c.syncInfo.fileVersion)?_.each(_.range(c.syncInfo.fileVersion>r?c.syncInfo.fileVersion-r:0,c.syncInfo.fileVersion),function(t){_.each(a,function(e){localStorage.removeItem(u+"_"+t+e)})}):(localStorage.removeItem(u+"_"+c.syncInfo.fileVersion),localStorage.removeItem(u+"_CURRENTVERSION")))}return Ye(),(t||!J)&&c&&c.syncInfo&&!s&&!L.isDocumentEncrypted()&&Fn&&Y&&Q&&_.isFunction(U.getFullModelDescription)&&c.syncInfo.fileVersion&&c.syncInfo.fileId&&c.syncInfo.folderId&&On(c.syncInfo["document-osn"])&&n===c.syncInfo["document-osn"]&&(O(u=c.syncInfo.fileId+"_"+c.syncInfo.folderId),e=L.newDeferred("EditApplication.saveLocalStorage"),L.executeDelayed(function(){o=!0},"EditApplication.saveFileInStorage",1500),L.executeDelayed(function(){e.notify(.1),d=_.now(),U.getFullModelDescription(e,.1,.9).always(function(){_.isFunction(U.getSupportedStorageExtensions)&&_.each(U.getSupportedStorageExtensions(),function(e){e&&_.isString(e.extension)&&a.push(e.extension)}),i({migration:!0})}).done(function(e){function l(e){return i(),Cn.info("$badge{EditApp} quitHandler: "+e),!1}e.every(function(e){var t=e.htmlString,n=u+e.extension,r=null,i=null;Cn.info("$badge{EditApp} quitHandler: created document string with size: "+t.length+". Time for conversion: "+(_.now()-d)+" ms.");try{if(0===h){if(g=u+"_OSN",p=u+"_FILEVERSION",f=u+"_STORAGEVERSION",E=u+"_OPERATIONS",localStorage.setItem(g,c.syncInfo["document-osn"]),localStorage.setItem(f,K),localStorage.setItem(p,c.syncInfo.fileVersion),r=U.getStorageOperationCollector(),_.each(r,function(e){delete e.osn,delete e.opl}),i=JSON.stringify(r),localStorage.setItem(E,i),!localStorage.getItem(E)||localStorage.getItem(E).length!==i.length)return l("failed to save document operations in local storage");Cn.info("$badge{EditApp} quitHandler: successfully saved document operations in local storage with key: "+E)}localStorage.setItem(n,t);var o=localStorage.getItem(n);if(!o||o.length!==t.length)return l("failed to save document in local storage");if(Cn.info("$badge{EditApp} quitHandler: successfully saved document in local storage with key: "+n),0===h){var a=localStorage.getItem(g),s=a?parseInt(a,10):-1;if(s!==c.syncInfo["document-osn"])return l("failed to save OSN for document in local storage");Cn.info("$badge{EditApp} quitHandler: successfully saved OSN for document in local storage with key: "+g+" : "+s)}return h++,!0}catch(e){return l("failed to save document and/or document OSN in local storage")}})}).always(function(){e.notify(1),e.resolve(c)})},"EditApplication.saveFileInStorage")),null===e?c:e.promise()}).progress(c)):$.when();p&&(t=t.then(function(){return un.DEBUG&&L.debugTypeError.test("async-quithandler"),$t(".disconnect",null,2e3)}));r&&(u?t=t.then(d,d):"reload"!==e&&("new"===w.action||w.template)&&te.length<=1&&!w.keepFile&&(t=t.then(function(){return Jt.purgeFile(r)})));return t}(e)}catch(e){r=$.when(),Cn.warn("$badge{EditApp} quitHander: Error caught:",e)}return r=(r=r.then(n,n)).then(t,t)}),this.waitForImportStart(function(){sn.logState("import","app/loading","pending")}),this.once("docs:state:preview",function(){sn.logState("import","app/preview","pending")}),this.waitForImport(function(){sn.logState("import","app/preview","resolved"),sn.logState("import","app/loading","resolved")}),this.waitForImportSuccess(function(){O&&Vt()}),this.registerDestructor(function(){Ue.destroy(),Ne.destroy(),w=F=L=U=x=null,M=p=i=Oe=null,B=H=null,f=E=s=null,l=h=null,v=X=te=ne=null,re=Ue=null,Ne=Ae=null})})});