define("io.ox/office/editframework/app/editcontroller",["io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/tabutils","io.ox/office/tk/utils/driveutils","io.ox/office/baseframework/app/basecontroller","io.ox/office/baseframework/app/extensionregistry","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/view/editdialogs","gettext!io.ox/office/editframework/actions"],function(e,t,n,s,l,r,d,o,a,p){"use strict";var f=e.newRejected,m=t.trimAndCleanString,g=n.globalLogger,h=o.SaveAsType,v=o.GUARD_AVAILABLE,b=o.CONVERTER_AVAILABLE,y=a.SaveAsFileDialog,E=a.SaveAsTemplateDialog,T=r.BaseController,w={query:"",regexp:!1,replace:""};return T.extend({constructor:function(o,e,t,a,n){var r=null,u=_.clone(w);function i(n,r){var e=t.processUnsavedComment();return e=(e=(e=e.then(function(){switch(n){case h.NATIVE:return new y(t,r&&r.encrypted?p("Save as (encrypted)"):p("Save as"),_.noI18n.fix(p("Copy of %1$s",_.noI18n(o.getShortFileName()))));case h.TEMPLATE:return new E(t,p("Save as template (%1$s)",_.noI18n(d.getTemplateExtension(o.getFullFileName()))),o.getShortFileName());case h.PDF:return new y(t,p("Export as PDF"),o.getShortFileName());default:return g.error('EditController.showSaveAsDialog - unknown file type "'+n+'"'),f()}})).then(function(e){return e.show()})).then(function(e){var t=_.isString(e.fileName)?m(e.fileName):null;return t?o.saveDocumentAs(e.folderId,t,n,r):(g.error("EditController.showSaveAsDialog - missing file name"),f())})}function c(e,t){_.extend(u,t);var n=a.call(this,e,_.clone(u)),r=_.isString(n)&&n?$.Deferred().reject(n):$.when(n);return r.fail(function(e){g.error("EditController.executeSearch failed",e)}),r}T.call(this,o,e,t,n),this.registerUndoManager=function(e){r!==e&&(this.stopListeningTo(r),r=e,this.updateOnEvent(r),this.update())},this.restoreUndoManager=function(){this.registerUndoManager(e.undoManager)},this.registerItems({"app/valid":{parent:"app/imported",enable:function(){return!o.isInternalError()}},"view/toolbars/show":{get:function(){return t.getToolPane().isVisible()},set:function(e){o.setUserSettingsValue("showToolbars",e),t.getToolPane().toggle(e)}},"view/toolbars/tab":{get:function(){return t.getToolBarTabs().getActiveTabId()},set:function(e){t.getToolBarTabs().activateTab(e)},focusTarget:function(e){return"keyboard"===e?t.getToolPane():null}},"view/new/menu":{parent:"app/valid",enable:function(){return s.BROWSER_TAB_SUPPORT}},"view/saveas/menu":{parent:"app/valid",enable:function(){return!o.getLaunchOption("disableSaveAs")}},"view/searchgroup":{parent:"app/valid",get:function(){return t.getSearchGroup().isVisible()},set:function(e){t.getSearchGroup().toggle(e)},focusTarget:function(){return t.getSearchGroup()},shortcut:{keyCode:"F",ctrlOrMeta:!0,value:!0}},"document/ooxml":{enable:function(){return o.isOOXML()}},"document/odf":{enable:function(){return o.isODF()}},"document/acquireedit":{parent:"app/valid",enable:function(){return o.isAcquireEditRightsEnabled()}},"document/acquireeditOrPending":{parent:"app/valid",enable:function(){return o.isAcquireEditRightsEnabledPendingUpdates()},set:function(){o.acquireEditRights()}},"document/ot/enabled":{parent:"app/imported",enable:function(){return o.isOTEnabled()}},"document/reload":{parent:"app/imported",enable:function(){return o.isReloadEnabled()},set:function(){o.reloadDocument()}},"document/editable":{parent:"app/valid",enable:function(){return o.isEditable()}},"document/readonly":{parent:"app/valid",enable:function(){return!o.isEditable()}},"document/fullname":{get:function(){return o.getFullFileName()}},"document/rename":{parent:["document/editable","app/bundled"],enable:function(){return o.isRenameEnabled()},get:function(){return o.getCurrentFileName()},set:function(e){return o.rename(e)},async:"background"},"document/rename/dialog":{parent:"document/rename",set:function(){return t.showRenameDialog()}},"document/undo":{parent:"document/editable",enable:function(){return 0<this.getValue()},get:function(){return r.getUndoCount()},set:function(){return r.undo()},shortcut:[{keyCode:"Z",ctrlOrMeta:!0,selector:".app-pane"},{keyCode:"BACKSPACE",alt:!0,selector:".app-pane"}]},"document/redo":{parent:"document/editable",enable:function(){return 0<this.getValue()},get:function(){return r.getRedoCount()},set:function(){return r.redo()},shortcut:[{keyCode:"Y",ctrlOrMeta:!0,selector:".app-pane"},{keyCode:"BACKSPACE",shift:!0,alt:!0,selector:".app-pane"}]},"document/saveas/unencrypted":{parent:["app/valid","app/unencrypted"]},"document/saveas/native/dialog":{parent:"document/saveas/unencrypted",set:function(){return i(h.NATIVE)}},"document/saveas/template/dialog":{parent:"document/saveas/unencrypted",enable:function(){return!o.isRescueDocument()},set:function(){return i(h.TEMPLATE)}},"document/saveas/encrypted/dialog":{parent:"app/valid",enable:function(){return v&&!o.isExternalStorage()&&!o.isRescueDocument()},set:function(){return i(h.NATIVE,{encrypted:!0})}},"document/saveas/pdf/dialog":{parent:"document/saveas/unencrypted",enable:function(){return b&&!o.isRescueDocument()},set:function(){return i(h.PDF)}},"document/autosave":{parent:"document/editable",get:function(){return!0},set:function(){t.yell({headline:p("What is AutoSave?"),message:p("In OX Documents all your changes are saved automatically through AutoSave. It is not necessary to save your work manually.")})}},"document/users":{parent:"app/valid",enable:function(){return 1<o.getActiveClients().length},get:function(){return t.getCollaboratorMenu().isVisible()},set:function(e){t.getCollaboratorMenu().toggle(e)}},"document/search":{parent:"app/valid"},"document/search/text":{parent:"document/search",get:function(){return u.query},set:function(e,t){if(!t||!t.commitEvent||"custom"!==t.commitEvent.sourceType)return c("search:start",{query:e,evt:t});u.query=e}},"document/search/regexp":{parent:"document/search",get:function(){return u.regexp},set:function(e){return c("search:start",{regexp:e})}},"document/search/start":{parent:"document/search",set:function(){return c("search:start")}},"document/search/prev":{parent:"document/search",set:function(){return c("search:prev")},shortcut:[{keyCode:"G",ctrlOrMeta:!0,shift:!0},{keyCode:"F3",shift:!0}]},"document/search/next":{parent:"document/search",set:function(){return c("search:next")},shortcut:[{keyCode:"G",ctrlOrMeta:!0},{keyCode:"F3"}]},"document/search/end":{parent:"document/search",set:function(){return c("search:end",{query:"",replace:""})}},"document/search/close":{parent:"document/search",set:function(){return t.getSearchGroup().hide()}},"document/replace":{parent:["document/search","document/editable"]},"document/replace/text":{parent:"document/replace",get:function(){return u.replace},set:function(e){u.replace=e}},"document/replace/next":{parent:"document/replace",set:function(){return c("replace:next")}},"document/replace/all":{parent:"document/replace",set:function(){return c("replace:all")}},"document/new":{parent:"app/valid",set:function(e){s.openEditorChildTab(e,{target_folder_id:l.getStandardDocumentsFolderId(),target_filename:p("unnamed"),new:!0})}},"document/new/encrypted":{parent:"app/valid",enable:function(){return v},set:function(t){return l.authorizeGuardWithTab().then(function(e){s.openEditorChildTab(t,{target_folder_id:l.getStandardDocumentsFolderId(),target_filename:p("unnamed"),crypto_action:"Encrypt",auth_code:e.authCode,new:!0},e.targetTab)})}},"document/new/fromTemplate":{parent:"app/valid",set:function(){s.openPortalChildTab(o.appType)}},"document/open":{parent:"app/valid",enable:function(){return s.BROWSER_TAB_SUPPORT},set:function(){return t.showOpenDocumentDialog()}}}),o.onInit(function(){r=e.undoManager,this.updateOnEvent(r)},this),this.waitForImport(function(){this.updateOnEvent(o,"docs:state:error docs:users docs:editmode")},this),this.listenTo(o,"docs:dialog:show",function(e,t){t&&t.showReadOnly||e.listenTo(o,"docs:editmode:leave",e.close)}),this.registerDestructor(function(){o=n=e=t=null})}})});