define("io.ox/office/editframework/model/editmodel",["static/3rd.party/crypto-js/crypto-js.js","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/utils/logger","io.ox/office/baseframework/model/basemodel","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/utils/operations","io.ox/office/editframework/utils/operationutils","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/model/operationcontext","io.ox/office/editframework/model/operationgenerator","io.ox/office/editframework/model/modelattributesmixin","io.ox/office/editframework/model/undomanager"],function(A,w,e,t,n,o,P,k,C,D,r,i,a,I,s){"use strict";var N=e.isPromise,R=e.newRejected,U=t.fastThen,j=n.TMap,c=o.Logger,T=o.globalLogger,H=r.otLogger,B=r.isOperationRemoved,F=i.OperationContext,G=a.resolveOperations,J=a.OperationGenerator,L=s.UndoManager,z=new c("office:log-ops",{tag:"OP",tagColor:16711935});return P.extend({constructor:function(u,p){var f=p&&p.contextClass||F,g=this,i=null,o=new j,a=!1,s=!1,c=!1,t=!1,h=0,O=-1,m=null,M=u.isOTEnabled(),e=!(!p||!p.slideMode),n=e&&(w.IOS||w.CHROME_ON_ANDROID),l=null;function r(e,t){var n=t&&t.async;if(g.isProcessingActions()){if(M){a&&(c?(H.info("$badge{EditModel} enterProcessActionsMode: Collision! External operations are currently applied"),g.trigger("docs:ot:collision")):s&&H.info("$badge{EditModel} enterProcessActionsMode: Internal operations are currently applied"));var o=null;t&&t.operations&&(o=t.operations._docOperations?t.operations._docOperations:t.operations),H.info("$badge{EditModel} enterProcessActionsMode: New failing operations: ",o),H.info("$badge{EditModel} enterProcessActionsMode: Failing operations async state: "+!!n),H.info("$badge{EditModel} enterProcessActionsMode: Currently applied operations: ",l)}return T.error("$badge{EditModel} enterProcessActionsMode: recursive call"),!!n&&g.createRejectedPromise({cause:"recursive"})}i=g.newDeferred("EditModel.enterProcessActionsMode").always(function(){var e=i?i.state().replace(/ed$/,"ing"):"destructed";z.log("$badge{EditModel} enterProcessActionsMode: "+e+" promise...")}),l=null,t&&t.operations&&(l=t.operations._docOperations?t.operations._docOperations:t.operations),H.info("$badge{EditModel} enterProcessActionsMode: Starting to process operations: ",l);var r=H.takeTime("$badge{EditModel} enterProcessActionsMode",e.bind(g));return N(r)?(r.progress(i.notify.bind(i)),r.done(i.resolve.bind(i)),r.fail(i.reject.bind(i)),r):(!0===r?i.resolve():i.reject(),n?i.promise():r)}function d(e,t){return a?(M&&(c&&!t?H.info("$badge{EditModel} beginProcessOperations: Collision! Receiving internal operation during applying external operations"):s&&t?H.info("$badge{EditModel} beginProcessOperations: Collision! Receiving external operation during applying internal operations"):H.info("$badge{EditModel} beginProcessOperations: Collision! State of external: "+t+", processingExternalOperations: "+c+", processingInternalOperations: "+s)),void T.error("$badge{EditModel} beginProcessOperations: recursive call - currently processing operations.")):u.isInternalError()?void T.error("$badge{EditModel} beginProcessOperations: illegal call - application is in error state."):(g.trigger("operations:before",e,t),a=!0,M&&(t?c=!0:g.setInternalOperationBlocker(!0)),1)}function b(e,t,n,o){a=!1,M&&(c=!1),g.trigger("operations:after",t,n,o),g.trigger(e?"operations:success":"operations:error",t,n,o)}function v(e){var t=e.getStr("name"),n=o.get(t,null);return e.ensure(n,"unknown operation %s",t),n}function y(e){return e||u.isEditable()||u.isRescueDocMode()}function S(t,n,e,o){function r(){var e="$badge{EditModel} applyOperation: "+_.printf.apply(_,arguments);return z.error(e),u.sendLogMessage(e),!1}if(z.log("i="+h+", op=",t),!_.isObject(t))return r("Expecting operation object.");try{var i=new f(g,t,n,o),a=v(i);if(n&&i.has("osn")){var s=i.getInt("osn");if(i.ensure(0<=s,"invalid OSN: %d",s),-1===O&&g.setOperationStateNumber(s),!M&&O!==s)return r("Wrong operation state number. current=%d operation=%d",O,t.osn)}n||(t.osn=M?u.getServerOSN():O,t.opl=1,k.DEBUG&&(t.dbg_user_id=ox.user_id)),0<=O&&g.setOperationStateNumber(O+i.optInt("opl",1));var c=p&&p.storageOperationCollector;c&&c.call(g,t);var l=i.optStr("scope");if(!(e||"filter"===l||M&&B(t))&&(a.call(g,i),m=t,M&&!o)){var d=n?"operation:external":"operation:internal";g.trigger(d,t)}}catch(e){return r('Operation failed. name="%s" msg="%s" osn=%d source=%s op=%s',t.name,e.message,h+1,n?"ext":"int",JSON.stringify(t))}return h+=1,!0}function x(e,t,n){var o=n&&n.sendOnly,r=n&&n.userData,i=!g.isImportFinished(),a=!1;if(e=G(e,n),!y(t)||0===e.length)return!0;var s=!t&&p&&p.operationsFinalizer;return s&&(e=s.call(g,e)),d(e,t)&&g.undoManager.enterUndoGroup(function(){a=e.every(function(e){return S(e,t,o,i)})}),b(a,e,t,r),a}function E(n,o,e){var r=e&&e.sendOnly,t=e&&e.userData,i=!g.isImportFinished(),a=null,s=h;return 0===(n=G(n,e)).length?g.createResolvedPromise(null):(a=d(n,o)?g.undoManager.enterUndoGroup(function(){return g.iterateArraySliced(n,function(e,t){return y(o)?S(e,o,r,i)?void 0:g.createRejectedPromise({cause:"operation"}):(n=n.slice(0,t),w.BREAK)},"EditModel.applyOperationsAsync")}):g.createRejectedPromise({cause:"recursive"}),g.await(a,function(){b(!0,n,o,t)}),g.catch(a,function(e){"abort"===e?b(!0,n.slice(0,h-s),o,t):b(!1,n,o,t)}),a)}P.call(this,u),this.registerContextOperationHandler=function(e,t){return o.insert(e,t),this},this.registerOperationHandler=function(e,n){return this.registerContextOperationHandler(e,function(e){var t=n.call(this,e.operation,e.external);e.ensure(!1!==t,"operation handler failed")})},this.serializeToJSON=function(){return T.warn("$badge{EditModel} serializeToJSON: not implemented"),{}},this.getSelectionState=function(){},this.setSelectionState=function(){T.error("$badge{EditModel} setSelectionState: missing implementation")},this.isProcessingActions=function(){return!!i&&"pending"===i.state()},this.waitForActionsProcessed=function(){return i?U(i,_.noop,_.noop):this.createResolvedPromise()},this.isProcessingOperations=function(){return a},this.isProcessingExternalOperations=function(){return c},this.isProcessingInternalOperations=function(){return s},this.setInternalOperationBlocker=function(e){M&&(e?s=e:s&&g.isProcessingActions()?i.always(function(){g.setInternalOperationBlocker(e)}):s&&!u.isRemovalOfInternalBlockerPossible()||(s=e,u.checkStartOfExternalOperations()))},this.setDrawingChangeActive=function(e){t=e},this.isDrawingChangeActive=function(){return t},this.sendOperations=z.profileMethod("$badge{EditModel} sendOperations",function(e,t){return x(e,!1,_.extend({},t,{sendOnly:!0}))}),this.applyOperationsAsync=z.profileMethod("$badge{EditModel} applyOperationsAsync",function(e,t){return r(function(){return E(e,!1,t)},{async:!0,operations:e})}),this.applyOperations=z.profileMethod("$badge{EditModel} applyOperations",function(e,t){return r(function(){return x(e,!1,t)},{operations:e})}),this.applyExternalOperations=z.profileMethod("$badge{EditModel} applyExternalOperations",function(e,t){return 0===e.length?$.when():(t&&t.expand&&D.handleMinifiedActions([{operations:e}],!0),r(function(){return E(e,!0)},{async:!0,operations:e}))}),this.invokeOperationHandler=function(e){var t=new f(this,e,!1),n=v(t);return this.undoManager.disableUndoSync(n.bind(this,t)),this},this.createOperationGenerator=function(e){return new(p&&p.generatorClass||J)(this,e)},this.createAndApplyOperations=z.profileMethod("$badge{EditModel} createAndApplyOperations",function(i,a){var e=a&&a.generatorClass,s=e?new e(this,a):this.createOperationGenerator(),c=!0===(a&&a.storeSelection)?_.noop:w.getFunctionOption(a,"storeSelection",null),l=s.isImmediateApplyMode();return r(function(){var t={preventSelectionChange:!(!a||!a.preventSelectionChange)};c&&(t.undoSelectionState=a&&a.undoSelectionState||g.getSelectionState());var n=!1;function e(){n=!0}this.on("operations:immediate",e);var o,r=null;try{r=g.convertToPromise(i.call(g,s))}catch(e){r=g.createRejectedPromise(e)}return r.done(function(e){o=e}),r.always(function(){g.off("operations:immediate",e)}),r.fail(function(e){l&&n&&(z.error("$badge{EditModel} createAndApplyOperations: failure with immediate operations, reloading...",e),u.reloadDocument())}),r=U(r,function(){var e=s.getUserData(),t=e?{userData:e}:void 0;return l?g.sendOperations(s,t)?null:R({cause:"operation"}):E(s,!1,t)}),r=U(r,function(){c&&(c.call(g),t.redoSelectionState=a&&a.redoSelectionState||g.getSelectionState()),a&&a.afterApplyHandler&&a.afterApplyHandler.call(g,s);var e=g.undoManager;switch(a&&a.undoMode||"generate"){case"generate":t.undoUserData=s.getUserData({undo:!0}),t.redoUserData=s.getUserData(),e.addUndo(s.getOperations({undo:!0}),s.getOperations(),t);break;case"clear":e.clearUndoActions();break;case"skip":break;default:T.error("$badge{EditModel} createAndApplyOperations: unknown undo mode")}return o})},{async:!0})}),this.getOperationsCount=function(){return h},this.getOperationStateNumber=function(){return O},this.setOperationStateNumber=function(e){return O!==e&&(O=e,M||this.trigger("change:osn",e)),this},this.getLastOperation=function(){return m},this.getUndoManager=function(){return this.undoManager},this.useSlideMode=function(){return e},this.getSlideTouchMode=function(){return n},this.getDocumentChecksum=function(){var e=this.serializeToJSON(),t=A.MD5(JSON.stringify(e)).toString();return g.trigger("update:checksum",t),t},this.hasUnsavedComments=function(){return!1},this.discardUnsavedComments=function(){},this.undoManager=new L(this,p),I.call(this,p),this.registerContextOperationHandler(C.NOOP,_.noop),this.registerDestructor(function(){this.undoManager.destroy(),o.clear(),g=p=i=null,f=o=null})}})});