define("io.ox/office/editframework/model/undomanager",["exports","io.ox/office/tk/utils/logger","io.ox/office/baseframework/model/modelobject","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/model/operationcontext"],function(e,t,o,n,r){"use strict";var k=t.globalLogger,w=n.otLogger,i=r.OperationContext,M=1,A=2;function a(e,t,n){return t?0<e.length&&_.isFunction(t)!==_.isFunction(e[0])?(k.error("$badge{UndoManager} callback function and JSON operations cannot be mixed!"),e):(_.isFunction(t)?t=[t]:(t=_.getArray(_.copy(t instanceof i?t.operation:t,!0)),n===A&&(t=t.filter(function(e){return!e._SKIP_REDO_}))),n===M?t.concat(e):e.concat(t)):e}function D(e,t,n){this.undoOperations=[],this.redoOperations=[],this.preventSelectionChange=!(!n||!n.preventSelectionChange),this.undoSelectionState=n&&n.undoSelectionState,this.redoSelectionState=n&&n.redoSelectionState,this.undoUserData=n&&n.undoUserData,this.redoUserData=n&&n.redoUserData,this.restoreActions=null,this.otMarker=void 0,this.appendOperations(e,t)}D.prototype.empty=function(){return 0===this.undoOperations.length&&0===this.redoOperations.length},D.prototype.appendOperations=function(e,t){this.undoOperations=a(this.undoOperations,e,M),this.redoOperations=a(this.redoOperations,t,A)},e.UndoManager=o.extend({constructor:function(i,e){var s=this,c=i.docApp,r=e&&e.mergeUndoActionHandler,a=e&&e.updateSelectionInUndo,l=e&&e.disableRedoWithOT,u=c.isOTEnabled(),d=[],f=null,p=0,n=0,g=0,h=null,S=null;function v(){0===p&&(f=null),p<d.length&&(d.splice(p),s.trigger("change:stack"))}function O(e){var t=null,n=d.length;if(p<n){if(S){if(!u)return void k.error("$badge{UndoManager} pushAction: OT must be enabled if processing is true in function pushAction!");var o=d[p];return void(S===M&&(o.redoOperations=e.undoOperations,m(o)))}v()}else if(r&&0<n&&(t=_.last(d),!0===r.call(s,t,e)))return void(t.redoSelectionState=e.redoSelectionState);d.push(e),p=d.length,u&&m(e),s.trigger("change:stack")}function m(e){e.otMarker=f?f.length:0}function b(){return d[p].otMarker}function U(e,t,n,o){S=e,i.setInternalOperationBlocker(!0);var r=_.isFunction(t[0])?t.reduce(function(e,t){return e.then(function(){var e=t.call(s);return!1===e?$.Deferred().reject():e})},s.createResolvedPromise()):i.applyOperationsAsync(_.copy(t,!0),{userData:o});return s.await(r,function(){_.isObject(n)&&i.setSelectionState(n)}),s.finally(r,function(){S=null,i.setInternalOperationBlocker(!1)}),r}function y(e,t,n,o){var r,i=f.slice(b());e===M?(r=i,d[p].restoreActions=0<r.length?_.copy(r,!0):null):function(){var e=d[p].restoreActions;if(d[p].restoreActions=null,e){var t=e.length,n=b()-t;f.splice.apply(f,[n,t].concat(e))}}();var a={operations:t,selection:!0};if(0===i.length)return a;l&&e===M&&(w.info("$badge{UndoManager} transformOperations: dropping untransformable redo actions"),v());try{w.info("$badge{UndoManager} transformOperations: stackIndex="+p+", transforming operations..."),a.operations=c.otManager.transformOperations(t,i,{swapped:!0,userData:o}),n&&(a.selection=c.otManager.transformSelectionState(n,i),a.selection&&s.trigger("transform:selectionstate",n,i))}catch(e){"OTError"===e.name?w.warn("$badge{UndoManager} transformOperations: transformation failed"):w.exception(e,"$badge{UndoManager} transformOperations: transformation failed"),w.warn("$badge{UndoManager} transformOperations: clearing undo stack"),s.clearUndoActions(),delete a.operations}return a}o.call(this,i),this.isUndoEnabled=function(){return(!S||u)&&0===n&&this.isImportFinished()},this.clearUndoActions=function(){p=0,v()},this.enterUndoGroup=function(e,t,n){this.isUndoEnabled()&&0===g&&(h=new D(null,null,n),a&&!h.undoSelectionState&&(h.undoSelectionState=i.getSelectionState()),s.trigger("undogroup:open")),g+=1;var o=null;try{o=this.convertToPromise(e.call(t))}catch(e){o=this.createRejectedPromise(e)}return this.finally(o,function(){--g,h&&0===g&&(h.empty()||c.isOperationsBlockActive()||(a&&!h.redoSelectionState&&(h.redoSelectionState=i.getSelectionState()),O(h)),h=null,s.trigger("undogroup:close"))}),o},this.disableUndoSync=function(e,t){try{return n+=1,e.call(t)}finally{--n}},this.addUndo=function(e,t,n){c.isEditable()&&this.isUndoEnabled()&&(e||t)&&(h?h.appendOperations(e,t):(a&&((n=n||{}).undoSelectionState||(n.undoSelectionState=i.getSelectionState())),O(new D(e,t,n))))},this.getUndoCount=function(){return p},this.undo=function(){if(0===p)return $.when();var e=d[--p],t=e.undoOperations,n=e.undoUserData;if(u&&f&&!_.isFunction(t[0])){var o=y(M,t,e.undoSelectionState,n);if(!o.operations)return $.when();t=o.operations,o.selection||delete e.undoSelectionState}var r=_.isFunction(t[0])?[]:t,i={preventSelectionChange:e.preventSelectionChange},a=e.undoSelectionState;a&&(i.selectionState=a),n&&(i.userData=n),this.trigger("undo:before",r,i),u&&0===t.length&&(e.redoOperations=[],m(e));var s=U(M,t,a,n);return this.finally(s,function(){this.trigger("undo:after",r,i)}),s},this.getRedoCount=function(){return d.length-p},this.redo=function(){if(p===d.length)return $.when();var e=d[p],t=e.redoOperations,n=e.redoUserData;if(u&&f&&!_.isFunction(t[0])){var o=y(A,t,e.redoSelectionState,n);if(!o.operations)return $.when();t=o.operations,o.selection||delete e.redoSelectionState}var r=_.isFunction(t[0])?[]:t,i={preventSelectionChange:e.preventSelectionChange},a=e.redoSelectionState;a&&(i.selectionState=a),n&&(i.userData=n),this.trigger("redo:before",r,i);var s=U(A,t,a,n);return this.finally(s,function(){p+=1,this.trigger("redo:after",r,i)}),s},u&&this.listenTo(i,"operations:success",function(e,t,n){n&&0<d.length&&((f=f||[]).push({operations:t,sentToServer:!0}),l&&(w.info('$badge{UndoManager} event "operations:success": dropping untransformable redo actions'),v()))}),this.registerDestructor(function(){s=e=null,c=i=r=d=null})}})});