define("io.ox/office/presentation/utils/presentationutils",["io.ox/office/tk/utils","io.ox/office/tk/render/rectangle","io.ox/office/drawinglayer/utils/drawingutils","io.ox/office/drawinglayer/view/drawingframe","io.ox/office/editframework/utils/attributeutils","io.ox/office/textframework/utils/dom","io.ox/office/textframework/utils/position","gettext!io.ox/office/presentation/main"],function(O,t,y,R,v,x,s,e){"use strict";var N=t.Rectangle,b={PLACEHOLDER_DRAWING_IMPORTANT_ATTRS:["left","top","width","height","rotation","flipH","flipV"],DEFAULT_PLACEHOLDER_TYPE:"body",TABLE_PLACEHOLDER_TYPE:"tbl",IMAGE_PLACEHOLDER_TYPE:"pic",CONTENTBODY:"contentbody",TITLE_PLACEHOLDER_TYPES:{title:1,ctrTitle:1},TITLE_OR_SUBTITLE_PLACEHOLDER_TYPES:{title:1,ctrTitle:1,subTitle:1},ODF_MASTER_READONLY_TYPES:{title:1,body:1},NO_TEXT_PLACEHOLDER_TYPE:{media:1,clipArt:1,chart:1,dgm:1,tbl:1,pic:1},NO_TEXT_PLACEHOLDER_CONTENT_PROPERTY:{media:null,clipArt:"image",chart:null,dgm:null,tbl:"table",pic:"image"}};return b.PLACEHOLDER_TEMPLATE_TEXTS={body:e("Click to add text"),title:e("Click to add title"),ctrTitle:e("Click to add title"),subTitle:e("Click to add subtitle"),media:e("Media clip"),clipArt:e("Online image"),chart:e("Chart"),dgm:e("Smart Art"),tbl:e("Click to add table"),pic:e("Click to add image"),sldNum:e("Slide Number"),ftr:e("Footer"),dt:e("Date")},b.PLACEHOLDER_TEMPLATE_TEXTS_ODF={body:e("Click to add text"),title:e("Click to add title"),ctrTitle:e("Click to add title"),subTitle:e("Click to add text"),media:e("Media clip"),clipArt:e("Online image"),chart:e("Chart"),dgm:e("Smart Art"),tbl:e("Click to add table"),pic:e("Click to add image"),sldNum:e("Slide Number"),ftr:e("Footer"),dt:e("Date")},b.PLACEHOLDER_TEMPLATE_TEXTS_CLICK={pic:e("Click icon to add image"),tbl:e("Click icon to add table"),chart:e("Click icon to add chart"),dgm:e("Click icon to add smart art graphic"),clipArt:e("Click icon to add clip art"),media:e("Click icon to add media")},b.PLACEHOLDER_TEMPLATE_BUTTONS={contentBody:["picture","table"],body:null,title:null,ctrTitle:null,subTitle:null,media:["media"],clipArt:["clipart"],chart:["chart"],dgm:["smartart"],tbl:["table"],pic:["picture"],sldNum:null,ftr:null,dt:null},b.PLACEHOLDER_TEMPLATE_BUTTONS_ODF={contentBody:["picture","table"],body:["picture","table"],title:null,ctrTitle:null,subTitle:null,media:["media"],clipArt:["clipart"],chart:["chart"],dgm:["smartart"],tbl:["table"],pic:["picture"],sldNum:null,ftr:null,dt:null},b.PLACEHOLDER_DRAWING_NAMES={content:e("Content placeholder"),contentv:e("Vertical content placeholder"),text:e("Text placeholder"),textv:e("Vertical text placeholder"),picture:e("Image placeholder"),table:e("Table placeholder")},b.PLACEHOLDER_TEXT_CONTENT=[e("Edit Master text styles"),e("Second level"),e("Third level"),e("Fourth level"),e("Fifth level")],b.PLACEHOLDER_TITLE_CONTENT=e("Click to edit Master title style"),b.DEFAULT_PLACEHOLDER_INDEX=0,b.isPlaceHolderAttributeSet=function(t){return!(!t||!t.presentation||!t.presentation.phType&&!_.isNumber(t.presentation.phIndex))},b.isTitlePlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&b.TITLE_PLACEHOLDER_TYPES[t.presentation.phType])},b.isTitleOrSubtitlePlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&b.TITLE_OR_SUBTITLE_PLACEHOLDER_TYPES[t.presentation.phType])},b.isBodyPlaceHolderAttributeSet=function(t){return!(!(t&&t.presentation&&_.isNumber(t.presentation.phIndex))||t.presentation.phType!==b.DEFAULT_PLACEHOLDER_TYPE&&t.presentation.phType)},b.isTextBodyPlaceHolderAttributeSet=function(t,e){return!(e||!1||!t||!t.presentation||!_.isNumber(t.presentation.phIndex)||t.presentation.phType!==b.DEFAULT_PLACEHOLDER_TYPE)},b.isContentBodyPlaceHolderAttributeSet=function(t,e){var i=e||!1;return!(!t||!t.presentation||!_.isNumber(t.presentation.phIndex)&&!i||t.presentation.phType&&(!i||t.presentation.phType!==b.DEFAULT_PLACEHOLDER_TYPE))},b.isPlaceHolderWithoutTextAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&b.NO_TEXT_PLACEHOLDER_TYPE[t.presentation.phType])},b.isCustomPromptPlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.customPrompt)},b.isODFReadOnlyPlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&b.ODF_MASTER_READONLY_TYPES[t.presentation.phType])},b.isBodyPlaceHolderAttributeSetWithoutIndex=function(t){return!(!t||!t.presentation||_.isNumber(t.presentation.phIndex)||t.presentation.phType!==b.DEFAULT_PLACEHOLDER_TYPE)},b.isUserModifiedPlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.userTransformed)},b.isPlaceHolderDrawing=function(t){return b.isPlaceHolderAttributeSet(v.getExplicitAttributeSet(t))},b.getPlaceHolderDrawingType=function(t,e){var i=e||v.getExplicitAttributeSet(t);return i&&i.presentation&&i.presentation.phType?i.presentation.phType:null},b.getPlaceHolderDrawingIndex=function(t,e){var i=e||v.getExplicitAttributeSet(t);return i&&i.presentation&&_.isNumber(i.presentation.phIndex)?i.presentation.phIndex:null},b.isTitlePlaceHolderDrawing=function(t){return b.isTitlePlaceHolderAttributeSet(v.getExplicitAttributeSet(t))},b.isTitleOrSubtitlePlaceHolderDrawing=function(t){return b.isTitleOrSubtitlePlaceHolderAttributeSet(v.getExplicitAttributeSet(t))},b.isBodyPlaceHolderDrawing=function(t){return b.isBodyPlaceHolderAttributeSet(v.getExplicitAttributeSet(t))},b.isTextBodyPlaceHolderDrawing=function(t){return b.isTextBodyPlaceHolderAttributeSet(v.getExplicitAttributeSet(t))},b.isContentBodyPlaceHolderDrawing=function(t){return b.isContentBodyPlaceHolderAttributeSet(v.getExplicitAttributeSet(t))},b.isPlaceHolderWithoutTextDrawing=function(t){return b.isPlaceHolderWithoutTextAttributeSet(v.getExplicitAttributeSet(t))},b.isEmptyPlaceHolderDrawing=function(t){var e=v.getExplicitAttributeSet(t),i=!1,r=null;return b.isPlaceHolderWithoutTextAttributeSet(e)?"undefined"!==$(t).attr("data-type")&&(r=b.NO_TEXT_PLACEHOLDER_CONTENT_PROPERTY[e.presentation.phType],e&&r&&e[r]||(i=!0)):b.isPlaceHolderAttributeSet(e)&&(i=x.isEmptyTextframe(t,{ignoreTemplateText:!0})),i},b.isCustomPromptPlaceHolderDrawing=function(t){return b.isCustomPromptPlaceHolderAttributeSet(v.getExplicitAttributeSet(t))},b.isODFReadOnlyPlaceHolderDrawing=function(t){return b.isODFReadOnlyPlaceHolderAttributeSet(v.getExplicitAttributeSet(t))},b.isBodyPlaceHolderWithoutIndexDrawing=function(t){return b.isBodyPlaceHolderAttributeSetWithoutIndex(v.getExplicitAttributeSet(t))},b.isUserModifiedPlaceHolderDrawing=function(t){return b.isUserModifiedPlaceHolderAttributeSet(v.getExplicitAttributeSet(t))},b.requiresUserTransformedProperty=function(t){var e=v.getExplicitAttributeSet(t);return b.isPlaceHolderAttributeSet(e)&&!b.isUserModifiedPlaceHolderAttributeSet(e)},b.getDrawingModelDescriptor=function(t,e){var i=v.getExplicitAttributeSet(t),r=O.getBooleanOption(e,"useDefaultValues",!0),n=null;return b.isPlaceHolderAttributeSet(i)&&((n={}).target=x.getTargetContainerId($(t).parent()),n.type=i.presentation.phType,n.index=i.presentation.phIndex,r&&(n.type&&!_.isNumber(n.index)&&(n.index=b.DEFAULT_PLACEHOLDER_INDEX),_.isNumber(n.index)&&!n.type&&(n.type=b.DEFAULT_PLACEHOLDER_TYPE))),n},b.getValidTypeIndexSet=function(t){return t&&t.presentation&&("phType"in t.presentation||"phIndex"in t.presentation)?{type:O.getStringOption(t.presentation,"phType",b.DEFAULT_PLACEHOLDER_TYPE),index:O.getIntegerOption(t.presentation,"phIndex",b.DEFAULT_PLACEHOLDER_INDEX)}:null},b.getPlaceHolderTemplateText=function(t,e){var i=b.getPlaceHolderDrawingType(t),r=e||!1;return!i&&_.isNumber(b.getPlaceHolderDrawingIndex(t))&&(i=b.DEFAULT_PLACEHOLDER_TYPE),i?r?b.PLACEHOLDER_TEMPLATE_TEXTS_ODF[i]:b.PLACEHOLDER_TEMPLATE_TEXTS[i]:null},b.getPlaceHolderTemplateButtonsList=function(t,e){return(e?b.PLACEHOLDER_TEMPLATE_BUTTONS_ODF:b.PLACEHOLDER_TEMPLATE_BUTTONS)[t||"contentBody"]},b.getODFFooterRepresentation=function(t){var e=b.PLACEHOLDER_TEMPLATE_TEXTS_ODF[t];return e?"<"+e+">":""},b.convertAppContentBoxToOperationBox=function(t,e,i){var r=t.getView().getZoomFactor(),n=t.getModel().getSlideById(t.getModel().getActiveSlideId()).offset(),o=t.getView().getContentRootNode(),a=o.offset(),l=o.scrollLeft(),p=o.scrollTop(),d={},c=!!_.isBoolean(i)&&i;return d.left=(e.left-(n.left-a.left)-l)/r,d.top=(e.top-(n.top-a.top)-p)/r,d.width=c?e.width:Math.round(e.width/r),d.height=c?e.height:Math.round(e.height/r),d.left=O.convertLengthToHmm(d.left,"px"),d.top=O.convertLengthToHmm(d.top,"px"),d.width=O.convertLengthToHmm(d.width,"px"),d.height=O.convertLengthToHmm(d.height,"px"),d.left<0&&(d.left=0),d},b.extendPlaceholderProp=function(t,e,i){if(i&&i.attrs&&i.attrs.drawing){var r=v.getExplicitAttributeSet(e);if(b.isPlaceHolderAttributeSet(r)){var n=t.getModel().getDrawingStyles().getElementAttributes(e).drawing;_.each(n,function(t,e){e in i.attrs.drawing||!_.contains(b.PLACEHOLDER_DRAWING_IMPORTANT_ATTRS,e)||e in r.drawing||(i.attrs.drawing[e]=t)})}}},b.checkEventPosition=function(t,e,i,r){var n,o,a=!0,l=t.getModel();if(x.isTextSpan(e.target)||x.isParagraphNode(e.target))return a;if(e.target&&$(e.target.parentNode).is(".borders"))return a;if(b.isPlaceHolderDrawing(i))return a;if(R.isGroupDrawingFrame(i))return!a;if(!R.isShapeDrawingFrame(i))return a;var p=R.getCanvasNode(i);if(!p||0===p.length)return a;var d,c,u,s,g=r||v.getExplicitAttributes(i,"drawing"),T=l.getActiveSlide().offset(),E=0,f=0,h=g.flipH,A=g.flipV,P=b.normalizeRotationAndGrouping(t,i,e,T),L=P.rect;if(!P.point)return a;d=L.left,c=L.top,u=L.width,s=L.height,E=P.point.left,f=P.point.top,E-=d,f-=c,h&&(E=u-E),A&&(f=s-f),n=Math.max(E-6,0),o=Math.max(f-6,0);var m=p[0].getContext("2d").getImageData(n,o,12,12);return a=!_.every(m.data,function(t){return 0===t})},b.findValidDrawingNodeBehindDrawing=function(t,e,i){for(var r=0,n=!1,o=(R.isGroupedDrawingFrame(i)?R.getGroupNode(i,{farthest:!0,rootNode:t.getModel().getCurrentRootNode()}):i).prevAll(".drawing"),a=o.length,l=null;r<a&&!n;){var p=$(o[r]);r++,(l=b.checkEventPositionInDrawing(t,e.pageX,e.pageY,p))&&(n=!0)}return l},b.checkEventPositionInDrawing=function(g,T,E,t){var e,n,i,o=g.getModel().getActiveSlide().offset(),r=v.getExplicitAttributes(t,"drawing"),a=b.normalizeRotationAndGrouping(g,t,{pageX:T,pageY:E},o),l=a.rect,p=a.drawingRect,f=a.point.left,h=a.point.top,d=g.getView().getZoomFactor(),A=null,P=null,L=!1,m=null;function c(t,e,i){if(R.isTextFrameShapeDrawingFrame(t)&&(A=R.getTextFrameNode(t))){var r=(n=A,o=i,a=e,l=Math.round(O.convertCssLength(n.css("left"),"px")),p=Math.round(O.convertCssLength(n.css("top"),"px")),d=n.width(),c=n.height(),u=a.flipH,s=a.flipV,u&&(l=o.width-d-l),s&&(p=o.height-c-p),l+=o.left,p+=o.top,new N(l,p,d,c));y.pointInsideRect({x:f,y:h},r,1)?(P=t,L=!0,m={rect:r,posX:f,posY:h}):A=null}var n,o,a,l,p,d,c,u,s;L||b.checkEventPosition(g,{pageX:T,pageY:E,target:null},t,e)&&(P=t,L=!0)}return y.pointInsideRect({x:f,y:h},l,6)&&(R.isGroupDrawingFrame(t)?_.each(t.find(".drawing"),function(t){if(!R.isGroupDrawingFrame(t)){t=$(t);var e=b.normalizeRotationAndGrouping(g,t,{pageX:T,pageY:E},o),i=e.rect,r=e.drawingRect;f=e.point.left,h=e.point.top;var n=v.getExplicitAttributes(t,"drawing");y.pointInsideRect({x:f,y:h},i,6)&&c(t,n,r)}}):R.isTableDrawingFrame(t)?(e=t,n=null,(i=_.find(e.find("div.cell"),function(t){var e=(t=$(t)).offset(),i=(e.left-o.left)/d,r=(e.top-o.top)/d;return n=new N(i,r,t.width(),t.height()),y.pointInsideRect({x:f,y:h},n,1)}))&&(P=e,A=i,L=!0,m={rect:n,posX:f,posY:h})):c(t,r,p)),L?{drawing:P,textFrameNode:A,info:m}:null},b.normalizeRotationAndGrouping=function(l,t,e,i){var r,n,o,a,p,d,c,u,s,g=l.getView().getZoomFactor(),T=R.isGroupedDrawingFrame(t),E=!!e,f=i||{left:0,top:0},h=0,A=0,P=0,L=0,m=0,x=!1,b=v.getExplicitAttributes(t,"drawing"),D=b.rotation,H=0<t.children(".canvasexpansion").length,C=null,S=null;function w(t,e){var i=0,r=0,n=R.isGroupedDrawingFrame(t);_.isNumber(e.left)&&_.isNumber(e.top)||(e=l.getModel().getDrawingStyles().getElementAttributes(t).drawing),r=n?(i=Math.round(O.convertCssLength(t.css("left"),"px")),Math.round(O.convertCssLength(t.css("top"),"px"))):(i=O.convertHmmToLength(e.left,"px",1),O.convertHmmToLength(e.top,"px",1)),i+=P,r+=L;var o=t.width(),a=t.height();return new N(i,r,o,a)}return E&&(_.isNumber(e.pageX)&&_.isNumber(e.pageY)?(h=(e.pageX-f.left)/g,A=(e.pageY-f.top)/g):x=!0),T&&function(t){var e=[];for(e.push(R.getGroupNode(t));R.isGroupedDrawingFrame(_.last(e));)e.push(R.getGroupNode(_.last(e)));e=e.reverse(),_.each(e,function(t){var e=v.getExplicitAttributes(t,"drawing"),i=null;E&&_.isNumber(e.rotation)&&(i=w(t,e),m=y.rotatePointWithAngle(i.centerX(),i.centerY(),h,A,e.rotation),h=m.left,A=m.top),P+=Math.round(O.convertCssLength(t.css("left"),"px")),L+=Math.round(O.convertCssLength(t.css("top"),"px"))})}(t),S=w(t,b),E&&_.isNumber(D)&&0!==D&&(m=y.rotatePointWithAngle(S.centerX(),S.centerY(),h,A,D),h=m.left,A=m.top),H&&(r=S,n=b,o=R.getCanvasNode(t),a=o.width(),p=o.height(),d=n.flipH,c=n.flipV,s=u=0,u=d?-(a-r.width+Math.round(O.convertCssLength(o.css("left"),"px"))):Math.round(O.convertCssLength(o.css("left"),"px")),s=c?-(p-r.height+Math.round(O.convertCssLength(o.css("top"),"px"))):Math.round(O.convertCssLength(o.css("top"),"px")),C=_.copy(r),r.left+=u,r.top+=s,r.width=a,r.height=p),{rect:S,drawingRect:C||S,point:x?null:{left:h,top:A}}},b.getBackgroundTextPosition=function(l,t,e,p){var d=null,c=l.getModel().getCurrentRootNode();if((e=$(e)).parent().is(".emptytextframe"))d=s.getLastTextPositionInTextFrame(c,t);else{var i=e.find("div.p"),u=e.offset();_.each(i,function(t){if(!d){var e=$(t).offset(),i=(e.left-u.left)/l.getView().getZoomFactor(),r=(e.top-u.top)/l.getView().getZoomFactor(),n=p.posX-p.rect.left-i,o=p.posY-p.rect.top-r,a=s.getPositionInsideParagraph(c,t,n,o,100*l.getView().getZoomFactor());a&&a.pos&&(d=a.pos)}})}return d=d||(R.isTableDrawingFrame(t)?s.getLastTextPositionInTableCell(c,e):s.getLastTextPositionInTextFrame(c,t))},b});