define("io.ox/office/rt2/rt2protocol",["io.ox/office/rt2/jss_objectutils","io.ox/office/rt2/jss_stringutils","io.ox/office/rt2/jss_hashmap","io.ox/office/rt2/rt2messageflags"],function(i,r,c,N){"use strict";function O(){var o=null,h=null,S=null,D=null;this.encode=function(_){var e=o.get(_);if(r.isEmpty(e))throw Error('RT2Protocol-Error : no encoded value for "'+_+'"');return e},this.decode=function(_){var e=h.get(_);if(r.isEmpty(e))throw Error('RT2Protocol-Error : no decoded value for "'+_+'"');return e},this.getFlags4Type=function(_){var e=S.get(_);if(i.isNull(e))throw Error('RT2Protocol-Error : no flags value for type "'+_+'"');return e},this.getFlag4Header=function(_){if(r.startsWithIgnoreCase(_,O.HEADER_PREFIX_JMS)||r.startsWithIgnoreCase(_,O.HEADER_PREFIX_DEBUG)||r.startsWithIgnoreCase(_,O.HEADER_PREFIX_INTERNAL)||r.equalsIgnoreCase(_,"breadcrumbId"))return N.FLAG_NONE;var e=D.get(_);if(i.isNull(e))throw Error('RT2Protocol-Error : no flag value for header "'+_+'"');return e},this.init=function(){var _,e,r,E,t,a,p,d,s,u,A,R,n;(i.isNull(o)||i.isNull(h)||i.isNull(S)||i.isNull(D))&&((_=new c).put("ping","ping"),_.put("pong","pong"),_.put("simple_ack","ak0"),_.put("error_ack","ak1"),_.put("simple_nack","nk0"),_.put("close_doc_route_admintask","at0"),_.put("close_doc_route_admintask_completed","at1"),_.put("cleanup_for_crashed_node_admintask","at2"),_.put("cleanup_for_crashed_node_admintask_completed","at3"),_.put("join_request","rq0"),_.put("leave_request","rq1"),_.put("open_doc_request","rq2"),_.put("save_doc_request","rq3"),_.put("close_doc_request","rq4"),_.put("apply_ops_request","rq5"),_.put("app_action_request","rq6"),_.put("switch_docstate_request","rq7"),_.put("update_slide_request","rq8"),_.put("reset_request","rq9"),_.put("sync_request","rq10"),_.put("editrights_request","rq11"),_.put("unavailability_request","rq12"),_.put("abort_open_request","rq13"),_.put("emergency_leave_request","rq14"),_.put("sync_stable_request","rq15"),_.put("generic_error_response","rp0"),_.put("join_response","rp1"),_.put("leave_response","rp2"),_.put("open_doc_response","rp3"),_.put("open_doc_chunk_response","rp4"),_.put("save_doc_response","rp5"),_.put("close_doc_response","rp6"),_.put("apply_ops_response","rp7"),_.put("app_action_response","rp8"),_.put("switch_docstate_response","rp9"),_.put("update_slide_response","rp10"),_.put("reset_response","rp11"),_.put("sync_response","rp12"),_.put("editrights_response","rp13"),_.put("unavailability_response","rp14"),_.put("abort_open_response","rp15"),_.put("emergency_leave_response","rp16"),_.put("sync_stable_response","rp17"),_.put("update_broadcast","bc0"),_.put("update_clients_broadcast","bc1"),_.put("chat_message_broadcast","bc2"),_.put("editrequest_state_broadcast","bc3"),_.put("shutdown_broadcast","bc4"),_.put("crashed_broadcast","bc5"),_.put("renamed_reload_broadcast","bc6"),_.put("hangup_broadcast","bc7"),_.put("ot_reload_broadcast","bc8"),_.put("msg_id_header","h0"),_.put("seq_nr_header","h1"),_.put("client_uid_header","h2"),_.put("session_id_header","h3"),_.put("doc_uid_header","h4"),_.put("drive_doc_id_header","h5"),_.put("folder_id_header","h6"),_.put("file_id_header","h7"),_.put("doc_type_header","h8"),_.put("doc_state_header","h9"),_.put("app_action_header","h10"),_.put("useragent_header","h11"),_.put("node_uid_header","h12"),_.put("storage_version_header","h13"),_.put("storage_osn_header","h14"),_.put("old_client_uid_header","h15"),_.put("preview_header","h16"),_.put("err_class_header","h17"),_.put("err_code_header","h18"),_.put("err_name_header","h19"),_.put("err_desc_header","h20"),_.put("err_value_header","h21"),_.put("fast_empty_header","h22"),_.put("fast_empty_osn_header","h23"),_.put("active_slide_header","h24"),_.put("auth_code_header","h25"),_.put("new_doc_header","h26"),_.put("auto_close_header","h27"),_.put("no_restore_header","h28"),_.put("unavail_time_header","h29"),_.put("ack_start_header","h30"),_.put("ack_end_header","h31"),_.put("nack_start_header","h32"),_.put("nack_end_header","h33"),_.put("admin_id_header","h34"),_.put("admin_hz_member_uuid_header","h35"),_.put("admin_hz_master_uuid_header","h36"),_.put("internal_chunk_header","hi0"),_.put("internal_doctype_header","hi1"),_.put("internal_recipients_header","hi2"),_.put("internal_client_ep_id_header","hi3"),_.put("internal_client_ep_uri_header","hi4"),_.put("internal_time_queued_header","hi5"),_.put("internal_force_header","hi6"),_.put("internal_referrer_header","hi7"),_.put("internal_is_response_header","hi8"),_.put("internal_is_broadcast_header","hi9"),_.put("dbg_seqnum_header","hd0"),_.put("dbg_disable_session_validation_header","hd1"),_.put("dbg_perf_client_in_header","hd2"),_.put("dbg_perf_client_out_header","hd3"),_.put("dbg_perf_server_in_header","hd4"),_.put("dbg_perf_server_out_header","hd5"),_.put("dbg_perf_server_load_start_header","hd6"),_.put("dbg_perf_server_load_end_header","hd7"),_.put("dbg_perf_server_applyops_start_header","hd8"),_.put("dbg_perf_server_applyops_end_header","hd9"),_.put("dbg_perf_server_save_start_header","hd10"),_.put("dbg_perf_server_save_end_header","hd11"),_.put("dbg_perf_server_recentlist_start_header","hd12"),_.put("dbg_perf_server_recentlist_end_header","hd13"),_.put("dbg_perf_server_sequencer_start_header","hd14"),_.put("dbg_perf_server_sequencer_end_header","hd15"),_.put("dbg_perf_server_route_doc_in_header","hd16"),_.put("dbg_perf_server_route_doc_out_header","hd17"),_.put("dbg_stat_node_id_header","hd18"),o=_,(e=new c).put("ping","ping"),e.put("pong","pong"),e.put("ak0","simple_ack"),e.put("ak1","error_ack"),e.put("nk0","simple_nack"),e.put("at0","close_doc_route_admintask"),e.put("at1","close_doc_route_admintask_completed"),e.put("at2","cleanup_for_crashed_node_admintask"),e.put("at3","cleanup_for_crashed_node_admintask_completed"),e.put("rq0","join_request"),e.put("rq1","leave_request"),e.put("rq2","open_doc_request"),e.put("rq3","save_doc_request"),e.put("rq4","close_doc_request"),e.put("rq5","apply_ops_request"),e.put("rq6","app_action_request"),e.put("rq7","switch_docstate_request"),e.put("rq8","update_slide_request"),e.put("rq9","reset_request"),e.put("rq10","sync_request"),e.put("rq11","editrights_request"),e.put("rq12","unavailability_request"),e.put("rq13","abort_open_request"),e.put("rq14","emergency_leave_request"),e.put("rq15","sync_stable_request"),e.put("rp0","generic_error_response"),e.put("rp1","join_response"),e.put("rp2","leave_response"),e.put("rp3","open_doc_response"),e.put("rp4","open_doc_chunk_response"),e.put("rp5","save_doc_response"),e.put("rp6","close_doc_response"),e.put("rp7","apply_ops_response"),e.put("rp8","app_action_response"),e.put("rp9","switch_docstate_response"),e.put("rp10","update_slide_response"),e.put("rp11","reset_response"),e.put("rp12","sync_response"),e.put("rp13","editrights_response"),e.put("rp14","unavailability_response"),e.put("rp15","abort_open_response"),e.put("rp16","emergency_leave_response"),e.put("rp17","sync_stable_response"),e.put("bc0","update_broadcast"),e.put("bc1","update_clients_broadcast"),e.put("bc2","chat_message_broadcast"),e.put("bc3","editrequest_state_broadcast"),e.put("bc4","shutdown_broadcast"),e.put("bc5","crashed_broadcast"),e.put("bc6","renamed_reload_broadcast"),e.put("bc7","hangup_broadcast"),e.put("bc8","ot_reload_broadcast"),e.put("h0","msg_id_header"),e.put("h1","seq_nr_header"),e.put("h2","client_uid_header"),e.put("h3","session_id_header"),e.put("h4","doc_uid_header"),e.put("h5","drive_doc_id_header"),e.put("h6","folder_id_header"),e.put("h7","file_id_header"),e.put("h8","doc_type_header"),e.put("h9","doc_state_header"),e.put("h10","app_action_header"),e.put("h11","useragent_header"),e.put("h12","node_uid_header"),e.put("h13","storage_version_header"),e.put("h14","storage_osn_header"),e.put("h15","old_client_uid_header"),e.put("h16","preview_header"),e.put("h17","err_class_header"),e.put("h18","err_code_header"),e.put("h19","err_name_header"),e.put("h20","err_desc_header"),e.put("h21","err_value_header"),e.put("h22","fast_empty_header"),e.put("h23","fast_empty_osn_header"),e.put("h24","active_slide_header"),e.put("h25","auth_code_header"),e.put("h26","new_doc_header"),e.put("h27","auto_close_header"),e.put("h28","no_restore_header"),e.put("h29","unavail_time_header"),e.put("h30","ack_start_header"),e.put("h31","ack_end_header"),e.put("h32","nack_start_header"),e.put("h33","nack_end_header"),e.put("h34","admin_id_header"),e.put("h35","admin_hz_member_uuid_header"),e.put("h36","admin_hz_master_uuid_header"),e.put("hi0","internal_chunk_header"),e.put("hi1","internal_doctype_header"),e.put("hi2","internal_recipients_header"),e.put("hi3","internal_client_ep_id_header"),e.put("hi4","internal_client_ep_uri_header"),e.put("hi5","internal_time_queued_header"),e.put("hi6","internal_force_header"),e.put("hi7","internal_referrer_header"),e.put("hi8","internal_is_response_header"),e.put("hi9","internal_is_broadcast_header"),e.put("hd0","dbg_seqnum_header"),e.put("hd1","dbg_disable_session_validation_header"),e.put("hd2","dbg_perf_client_in_header"),e.put("hd3","dbg_perf_client_out_header"),e.put("hd4","dbg_perf_server_in_header"),e.put("hd5","dbg_perf_server_out_header"),e.put("hd6","dbg_perf_server_load_start_header"),e.put("hd7","dbg_perf_server_load_end_header"),e.put("hd8","dbg_perf_server_applyops_start_header"),e.put("hd9","dbg_perf_server_applyops_end_header"),e.put("hd10","dbg_perf_server_save_start_header"),e.put("hd11","dbg_perf_server_save_end_header"),e.put("hd12","dbg_perf_server_recentlist_start_header"),e.put("hd13","dbg_perf_server_recentlist_end_header"),e.put("hd14","dbg_perf_server_sequencer_start_header"),e.put("hd15","dbg_perf_server_sequencer_end_header"),e.put("hd16","dbg_perf_server_route_doc_in_header"),e.put("hd17","dbg_perf_server_route_doc_out_header"),e.put("hd18","dbg_stat_node_id_header"),h=e,r=new c,E=N.FLAG_SESSION_BASED|N.FLAG_DOC_BASED,t=N.FLAG_SESSION_BASED|N.FLAG_SEQUENCE_NR_BASED|N.FLAG_DOC_BASED,a=N.FLAG_DOC_BASED,p=N.FLAG_SESSION_BASED|N.FLAG_DOC_BASED,d=N.FLAG_SESSION_BASED|N.FLAG_SEQUENCE_NR_BASED|N.FLAG_DOC_BASED,s=N.FLAG_SESSION_BASED|N.FLAG_DOC_BASED,u=N.FLAG_ALL,A=N.FLAG_NONE,R=N.FLAG_DOC_BASED,r.put(O.PING,A),r.put(O.PONG,A),r.put(O.ACK_SIMPLE,s),r.put(O.ACK_ERROR,s),r.put(O.NACK_SIMPLE,s),r.put(O.ADMIN_TASK_CLOSE_DOC_ROUTE,t),r.put(O.ADMIN_TASK_COMPLETED_CLOSE_DOC_ROUTE,t),r.put(O.ADMIN_TASK_CLEANUP_FOR_CRASHED_NODE,A),r.put(O.ADMIN_TASK_COMPLETED_CLEANUP_FOR_CRASHED_NODE,A),r.put(O.REQUEST_JOIN,E),r.put(O.REQUEST_LEAVE,E),r.put(O.REQUEST_OPEN_DOC,t),r.put(O.REQUEST_SAVE_DOC,t),r.put(O.REQUEST_CLOSE_DOC,t),r.put(O.REQUEST_APPLY_OPS,t),r.put(O.REQUEST_APP_ACTION,t),r.put(O.REQUEST_SWITCH_DOCSTATE,a),r.put(O.REQUEST_UPDATE_SLIDE,t),r.put(O.REQUEST_RESET,p),r.put(O.REQUEST_SYNC,p),r.put(O.REQUEST_SYNC_STABLE,d),r.put(O.REQUEST_EDITRIGHTS,t),r.put(O.REQUEST_UNAVAILABILITY,a),r.put(O.REQUEST_ABORT_OPEN,p),r.put(O.REQUEST_EMERGENCY_LEAVE,E),r.put(O.RESPONSE_GENERIC_ERROR,u),r.put(O.RESPONSE_JOIN,E),r.put(O.RESPONSE_LEAVE,E),r.put(O.RESPONSE_OPEN_DOC,t),r.put(O.RESPONSE_OPEN_DOC_CHUNK,t),r.put(O.RESPONSE_SAVE_DOC,t),r.put(O.RESPONSE_CLOSE_DOC,t),r.put(O.RESPONSE_APPLY_OPS,t),r.put(O.RESPONSE_APP_ACTION,t),r.put(O.RESPONSE_SWITCH_DOCSTATE,a),r.put(O.RESPONSE_UPDATE_SLIDE,t),r.put(O.RESPONSE_RESET,p),r.put(O.RESPONSE_SYNC,d),r.put(O.RESPONSE_SYNC_STABLE,d),r.put(O.RESPONSE_EDITRIGHTS,t),r.put(O.RESPONSE_UNAVAILABILITY,a),r.put(O.RESPONSE_ABORT_OPEN,p),r.put(O.RESPONSE_EMERGENCY_LEAVE,E),r.put(O.BROADCAST_UPDATE,t),r.put(O.BROADCAST_UPDATE_CLIENTS,t),r.put(O.BROADCAST_CHAT_MESSAGE,A),r.put(O.BROADCAST_SHUTDOWN,p),r.put(O.BROADCAST_CRASHED,p),r.put(O.BROADCAST_RENAMED_RELOAD,t),r.put(O.BROADCAST_HANGUP,R),r.put(O.BROADCAST_OT_RELOAD,R),S=r,(n=new c).put(O.HEADER_MSG_ID,N.FLAG_NONE),n.put(O.HEADER_SEQ_NR,N.FLAG_SEQUENCE_NR_BASED),n.put(O.HEADER_CLIENT_UID,N.FLAG_NONE),n.put(O.HEADER_SESSION_ID,N.FLAG_SESSION_BASED),n.put(O.HEADER_DOC_UID,N.FLAG_DOC_BASED),n.put(O.HEADER_DRIVE_DOC_ID,N.FLAG_DOC_BASED),n.put(O.HEADER_FOLDER_ID,N.FLAG_DOC_BASED),n.put(O.HEADER_FILE_ID,N.FLAG_DOC_BASED),n.put(O.HEADER_DOC_TYPE,N.FLAG_DOC_BASED),n.put(O.HEADER_DOC_STATE,N.FLAG_DOC_BASED),n.put(O.HEADER_APP_ACTION,N.FLAG_DOC_BASED),n.put(O.HEADER_OLD_CLIENT_UID,N.FLAG_DOC_BASED),n.put(O.HEADER_USERAGENT,N.FLAG_NONE),n.put(O.HEADER_UNAVAIL_TIME,N.FLAG_DOC_BASED),n.put(O.HEADER_NODE_UID,N.FLAG_NONE),n.put(O.HEADER_AUTO_CLOSE,N.FLAG_NONE),n.put(O.HEADER_NO_RESTORE,N.FLAG_DOC_BASED),n.put(O.HEADER_PREVIEW,N.FLAG_NONE),n.put(O.HEADER_ERROR_CLASS,N.FLAG_NONE),n.put(O.HEADER_ERROR_CODE,N.FLAG_NONE),n.put(O.HEADER_ERROR_NAME,N.FLAG_NONE),n.put(O.HEADER_ERROR_DESCRIPTION,N.FLAG_NONE),n.put(O.HEADER_ERROR_VALUE,N.FLAG_NONE),n.put(O.HEADER_FAST_EMPTY,N.FLAG_NONE),n.put(O.HEADER_FAST_EMPTY_OSN,N.FLAG_NONE),n.put(O.HEADER_ACTIVE_SLIDE,N.FLAG_NONE),n.put(O.HEADER_AUTH_CODE,N.FLAG_NONE),n.put(O.HEADER_NEW_DOC,N.FLAG_NONE),n.put(O.HEADER_STORAGE_VERSION,N.FLAG_NONE),n.put(O.HEADER_STORAGE_OSN,N.FLAG_NONE),n.put(O.HEADER_ACK_START,N.FLAG_SIMPLE_MSG),n.put(O.HEADER_ACK_END,N.FLAG_SIMPLE_MSG),n.put(O.HEADER_NACK_START,N.FLAG_SIMPLE_MSG),n.put(O.HEADER_NACK_END,N.FLAG_SIMPLE_MSG),n.put(O.HEADER_ADMIN_ID,N.FLAG_NONE),n.put(O.HEADER_ADMIN_HZ_MEMBER_UUID,N.FLAG_NONE),n.put(O.HEADER_ADMIN_HZ_MASTER_UUID,N.FLAG_NONE),D=n)}}O.HEADER_PREFIX_JMS="JMS",O.HEADER_PREFIX_INTERNAL="internal",O.HEADER_PREFIX_DEBUG="dbg",O.HEADER_PREFIX_DEBUG_STATISTIC="dbg_stat",O.HEADER_PREFIX_DEBUG_PERFORMANCE="dbg_perf",O.PING="ping",O.PONG="pong",O.ACK_SIMPLE="simple_ack",O.ACK_ERROR="error_ack",O.NACK_SIMPLE="simple_nack",O.ADMIN_TASK_CLOSE_DOC_ROUTE="close_doc_route_admintask",O.ADMIN_TASK_COMPLETED_CLOSE_DOC_ROUTE="close_doc_route_admintask_completed",O.ADMIN_TASK_CLEANUP_FOR_CRASHED_NODE="cleanup_for_crashed_node_admintask",O.ADMIN_TASK_COMPLETED_CLEANUP_FOR_CRASHED_NODE="cleanup_for_crashed_node_admintask_completed",O.REQUEST_JOIN="join_request",O.REQUEST_LEAVE="leave_request",O.REQUEST_OPEN_DOC="open_doc_request",O.REQUEST_SAVE_DOC="save_doc_request",O.REQUEST_CLOSE_DOC="close_doc_request",O.REQUEST_APPLY_OPS="apply_ops_request",O.REQUEST_APP_ACTION="app_action_request",O.REQUEST_SWITCH_DOCSTATE="switch_docstate_request",O.REQUEST_UPDATE_SLIDE="update_slide_request",O.REQUEST_RESET="reset_request",O.REQUEST_SYNC="sync_request",O.REQUEST_SYNC_STABLE="sync_stable_request",O.REQUEST_EDITRIGHTS="editrights_request",O.REQUEST_UNAVAILABILITY="unavailability_request",O.REQUEST_ABORT_OPEN="abort_open_request",O.REQUEST_EMERGENCY_LEAVE="emergency_leave_request",O.RESPONSE_GENERIC_ERROR="generic_error_response",O.RESPONSE_JOIN="join_response",O.RESPONSE_LEAVE="leave_response",O.RESPONSE_OPEN_DOC="open_doc_response",O.RESPONSE_OPEN_DOC_CHUNK="open_doc_chunk_response",O.RESPONSE_SAVE_DOC="save_doc_response",O.RESPONSE_CLOSE_DOC="close_doc_response",O.RESPONSE_APPLY_OPS="apply_ops_response",O.RESPONSE_APP_ACTION="app_action_response",O.RESPONSE_SWITCH_DOCSTATE="switch_docstate_response",O.RESPONSE_UPDATE_SLIDE="update_slide_response",O.RESPONSE_RESET="reset_response",O.RESPONSE_SYNC="sync_response",O.RESPONSE_SYNC_STABLE="sync_stable_response",O.RESPONSE_EDITRIGHTS="editrights_response",O.RESPONSE_UNAVAILABILITY="unavailability_response",O.RESPONSE_ABORT_OPEN="abort_open_response",O.RESPONSE_EMERGENCY_LEAVE="emergency_leave_response",O.BROADCAST_UPDATE="update_broadcast",O.BROADCAST_UPDATE_CLIENTS="update_clients_broadcast",O.BROADCAST_CHAT_MESSAGE="chat_message_broadcast",O.BROADCAST_EDITREQUEST_STATE="editrequest_state_broadcast",O.BROADCAST_SHUTDOWN="shutdown_broadcast",O.BROADCAST_CRASHED="crashed_broadcast",O.BROADCAST_RENAMED_RELOAD="renamed_reload_broadcast",O.BROADCAST_HANGUP="hangup_broadcast",O.BROADCAST_OT_RELOAD="ot_reload_broadcast",O.HEADER_MSG_ID="msg_id_header",O.HEADER_SEQ_NR="seq_nr_header",O.HEADER_CLIENT_UID="client_uid_header",O.HEADER_SESSION_ID="session_id_header",O.HEADER_DOC_UID="doc_uid_header",O.HEADER_DRIVE_DOC_ID="drive_doc_id_header",O.HEADER_FOLDER_ID="folder_id_header",O.HEADER_FILE_ID="file_id_header",O.HEADER_DOC_TYPE="doc_type_header",O.HEADER_DOC_STATE="doc_state_header",O.HEADER_APP_ACTION="app_action_header",O.HEADER_USERAGENT="useragent_header",O.HEADER_NODE_UID="node_uid_header",O.HEADER_STORAGE_VERSION="storage_version_header",O.HEADER_STORAGE_OSN="storage_osn_header",O.HEADER_OLD_CLIENT_UID="old_client_uid_header",O.HEADER_PREVIEW="preview_header",O.HEADER_ERROR_CLASS="err_class_header",O.HEADER_ERROR_CODE="err_code_header",O.HEADER_ERROR_NAME="err_name_header",O.HEADER_ERROR_DESCRIPTION="err_desc_header",O.HEADER_ERROR_VALUE="err_value_header",O.HEADER_FAST_EMPTY="fast_empty_header",O.HEADER_FAST_EMPTY_OSN="fast_empty_osn_header",O.HEADER_ACTIVE_SLIDE="active_slide_header",O.HEADER_AUTH_CODE="auth_code_header",O.HEADER_NEW_DOC="new_doc_header",O.HEADER_AUTO_CLOSE="auto_close_header",O.HEADER_NO_RESTORE="no_restore_header",O.HEADER_UNAVAIL_TIME="unavail_time_header",O.HEADER_ACK_START="ack_start_header",O.HEADER_ACK_END="ack_end_header",O.HEADER_NACK_START="nack_start_header",O.HEADER_NACK_END="nack_end_header",O.HEADER_ADMIN_ID="admin_id_header",O.HEADER_ADMIN_HZ_MEMBER_UUID="admin_hz_member_uuid_header",O.HEADER_ADMIN_HZ_MASTER_UUID="admin_hz_master_uuid_header",O.HEADER_INTERNAL_CHUNK_ID="internal_chunk_header",O.HEADER_INTERNAL_DOCTYPE="internal_doctype_header",O.HEADER_INTERNAL_RECIPIENTS="internal_recipients_header",O.HEADER_INTERNAL_CLIENT_ENDPOINT_ID="internal_client_ep_id_header",O.HEADER_INTERNAL_CLIENT_ENDPOINT_URI="internal_client_ep_uri_header",O.HEADER_INTERNAL_TIME_QUEUED="internal_time_queued_header",O.HEADER_INTERNAL_FORCE="internal_force_header",O.HEADER_INTERNAL_REFERRER="internal_referrer_header",O.HEADER_INTERNAL_IS_RESPONSE="internal_is_response_header",O.HEADER_INTERNAL_IS_BROADCAST="internal_is_broadcast_header",O.HEADER_DEBUG_SEQNUM="dbg_seqnum_header",O.HEADER_DEBUG_DISABLE_SESSION_VALIDATION="dbg_disable_session_validation_header",O.HEADER_DEBUG_PERFORMANCE_CLIENT_IN="dbg_perf_client_in_header",O.HEADER_DEBUG_PERFORMANCE_CLIENT_OUT="dbg_perf_client_out_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_IN="dbg_perf_server_in_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_OUT="dbg_perf_server_out_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_LOAD_START="dbg_perf_server_load_start_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_LOAD_END="dbg_perf_server_load_end_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_APPLYOPS_START="dbg_perf_server_applyops_start_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_APPLYOPS_END="dbg_perf_server_applyops_end_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_SAVE_START="dbg_perf_server_save_start_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_SAVE_END="dbg_perf_server_save_end_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_RECENTLIST_START="dbg_perf_server_recentlist_start_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_RECENTLIST_END="dbg_perf_server_recentlist_end_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_SEQUENCER_START="dbg_perf_server_sequencer_start_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_SEQUENCER_END="dbg_perf_server_sequencer_end_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_ROUTE_DOC_IN="dbg_perf_server_route_doc_in_header",O.HEADER_DEBUG_PERFORMANCE_SERVER_ROUTE_DOC_OUT="dbg_perf_server_route_doc_out_header",O.HEADER_DEBUG_STATISTIC_NODEID="dbg_stat_node_id_header",O.BODYPART_ACKS="ACKS",O.BODYPART_NACKS="NACKS";var e=null;return O.get=function(){if(i.isNull(e)){var _=new O;_.init(),e=_}return e},O});