define("io.ox/office/spreadsheet/controller/drawingmixin",["io.ox/office/tk/utils","io.ox/office/tk/algorithms","io.ox/office/tk/render/rectangle","io.ox/office/editframework/utils/color","io.ox/office/drawinglayer/utils/drawingutils","io.ox/office/drawinglayer/utils/imageutils","io.ox/office/drawinglayer/view/drawingframe","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/drawing/text/textframeutils","io.ox/office/spreadsheet/view/labels","gettext!io.ox/office/spreadsheet/main"],function(w,e,t,i,m,a,v,y,o,n,x,D){"use strict";var S=e.modulo,b=e.roundp,l=e.createDict,A=e.hasSingleProperty,M=e.getAnyPropertyKey,T=t.Rectangle,F=o.AnchorMode,V=21e3;function O(e){return e.isDeepRotatable()}function C(e){return e.supportsFamily("line")&&"chart"!==e.getType()}function E(e){return e.supportsFamily("fill")&&!P(e)&&"chart"!==e.getType()}function P(e){var t=e.getExplicitAttributeSet(!0);return e.supportsFamily("geometry")&&t.geometry&&x.isPresetConnector(t.geometry.presetShape)}function I(e){return e.supportsFamily("shape")&&null!==n.getTextFrame(e.getModelFrame())}return function(u){var c=this,s=this.docApp,d=s.isOOXML(),p=s.isODF(),g=u.docModel,f=g.drawingAttrPool,r=null,h=null;function n(e,s,g){"function"!=typeof s&&(s=_.constant(s));var t=e.map(function(e){var t=e.getMergedAttributeSet(!0),n=s.call(g,e,t);if("drawing"in n){var r=t.drawing,i=n.drawing;if("rotation"in i&&(i.rotation=S(b(i.rotation,.1),360)),d&&("flipH"in i||"flipV"in i||"rotation"in i)){var a=e.getRectangle();if(a&&!a.square()){var o=m.hasSwappedDimensions(r),l=m.hasSwappedDimensions(_.extend({},r,i));if(o!==l){l&&a.rotateSelf();var u=h.generateAnchorAttributesForRect(e,a,{pixel:!0});u&&f.extendAttributeSet(n,{drawing:u})}}}p&&"flipV"in i&&(i.flipV!==e.isFlippedV()&&(i.flipH="flipH"in i?!i.flipH:!e.isFlippedH(),i.rotation=S(("rotation"in i?i.rotation:e.getRotationDeg())+180,360)),delete i.flipV)}return{position:e.getPosition(),attrs:n}}),n=c.execChangeDrawings(t);return u.yellOnFailure(n)}this.execInsertDrawings=function(n,a){var e=u.leaveTextEditMode();return(e=e.then(function(){return u.ensureUnlockedDrawings({errorCode:"drawing:insert:locked"})})).then(function(){return r.createAndApplyOperations(function(e){var t=[h.getModelCount()],i=[];return h.generateInsertDrawingOperations(e,t,n,function(e,t,n,r){return i.push(n),_.isFunction(a)?a.call(c,e,t,n,r):null}).done(function(){u.setDrawingSelection(i)})},{storeSelection:!0})})},this.execInsertImages=function(e){var t=_.getArray(e).map(function(t){return t?s.createImageNode(a.getFileUrl(s,t.url)).then(function(e){return{node:e[0],url:t.url,name:t.name}},_.constant($.when())):c.createRejectedPromise()});return $.when.apply($,t).then(function(){var e=_.filter(arguments,_.identity);if(0===e.length)return $.Deferred().reject();var i=u.getActiveCell(),a=$(),t=e.map(function(e){a=a.add(e.node);var t=w.convertLengthToHmm(e.node.width,"px"),n=w.convertLengthToHmm(e.node.height,"px");n<t?V<t&&(n=Math.round(n*V/t),t=V):V<n&&(t=Math.round(t*V/n),n=V);var r=h.getAnchorAttributesForCellAndSize(F.ONE_CELL,i,t,n);return r.name=e.name,r.aspectLocked=!0,{type:"image",attrs:{drawing:r,image:{imageUrl:e.url}}}});return s.destroyImageNodes(a),c.execInsertDrawings(t)}).catch(function(){return o.makeRejected("image:insert")})},this.execInsertShape=function(e,t,n){var r=m.createDefaultShapeAttributeSet(g,e,n);if(0===t.area()){var i=u.convertHmmToPixel(2450),a=m.createDefaultSizeForShapeId(e,i,i);(t=t.clone()).width=a.width,t.height=a.height}var o=h.getAnchorAttributesForRect(F.TWO_CELL,t,{pixel:!0});f.extendAttributeSet(r,{drawing:o});var l=x.getPresetShape(e).type;return c.execInsertDrawings([{type:l,attrs:r}],function(e,t,n){"shape"===l&&(r=f.extendAttributeSet(r,m.getParagraphAttrsForDefaultShape(g),{clone:!0}),e.generateDrawingOperation(y.PARA_INSERT,n.concat(0),{attrs:r}))})},this.execDeleteDrawings=function(t){var e=u.leaveTextEditMode();return(e=(e=e.then(function(){return u.ensureUnlockedDrawings({errorCode:"drawing:delete:locked"})})).then(function(){return!t.every(function(e){return h.getModel(e).isDeepRestorable()})&&u.showQueryDialog(x.DELETE_CONTENTS_TITLE,x.DELETE_CONTENTS_QUERY)})).then(function(e){return r.createAndApplyOperations(function(e){return u.removeDrawingSelection(),h.generateDeleteDrawingOperations(e,t)},{storeSelection:!0,undoMode:e?"clear":"generate"})})},this.execReorderDrawings=function(t,n){var e=u.leaveTextEditMode();return(e=e.then(function(){return u.ensureUnlockedDrawings()})).then(function(){return r.createAndApplyOperations(function(e){return h.generateReorderDrawingOperations(e,t,n)},{storeSelection:!0})})},this.execChangeDrawings=function(t){return u.ensureUnlockedDrawings().then(function(){return r.createAndApplyOperations(function(e){return h.generateChangeDrawingOperations(e,t)},{storeSelection:!0})})},this.registerItemsOnSuccess({"drawing/insert/enable":{parent:"document/editable/worksheet",enable:function(){return!r.isLocked()}},"image/insert/dialog":{parent:"drawing/insert/enable",set:function(e){var t=u.leaveTextEditMode();return t=(t=t.then(function(){return u.showInsertImageDialog(e,{autoCloseKey:"image/insert/dialog",autoCloseScope:"activeSheet"})})).then(function(e){return c.execInsertImages([e])}),u.yellOnFailure(t)}},"shape/insert":{parent:"drawing/insert/enable",get:function(){return u.isFrameSelectionMode("shape")},set:function(r,e){if(w.TOUCHDEVICE||"click"!==w.getStringOption(e,"sourceType")){var t=u.getCellRectangle(u.getActiveCell()),n=new T(t.left,t.top,0,0);return u.yellOnFailure(c.execInsertShape(r,n))}var i=x.isPresetConnector(r),a=x.getPresetAspectRatio(r);function o(e){return i?{flipH:e.reverseX,flipV:e.reverseY}:null}var l=u.enterFrameSelectionMode("shape",{statusLabel:D("Insert a shape"),renderer:function(e,t){var n=_.extend({transparent:!0},o(t));v.drawPreviewShape(s,e,t,r,n)},trackingOptions:{twoPointMode:i,aspectRatio:a}});l=l.then(function(e){return c.execInsertShape(r,e,o(e))}),u.yellOnFailure(l)}},"drawing/models":{parent:"document/editable/drawing",get:function(e){return e.map(h.getModel,h).filter(Boolean)}},"drawing/types":{parent:"drawing/models",get:function(e){return l(_.invoke(e,"getType"),!0)}},"drawing/type/shape":{parent:"drawing/types",enable:function(e){return"shape"in e||"connector"in e}},"drawing/type/label":{parent:"drawing/types",get:function(e){var t=A(e)?M(e):null;return x.getDrawingTypeLabel(t)}},"drawing/operation":{parent:"drawing/models",enable:function(){return!r.isLocked()}},"drawing/delete":{parent:"drawing/operation",set:function(){var e=c.execDeleteDrawings(u.getSelectedDrawings());return u.yellOnFailure(e)}},"drawing/order":{parent:"drawing/operation",set:function(e){var t=c.execReorderDrawings(u.getSelectedDrawings(),e);return u.yellOnFailure(t)}},"drawing/change/explicit":{parent:"drawing/operation",set:function(e){var t=c.execChangeDrawings(e);return u.yellOnFailure(t)}},"drawing/operation/transform":{parent:"drawing/operation",enable:function(){return 0<this.getValue().length},get:function(e){return e.filter(O)}},"drawing/transform/fliph":{parent:"drawing/operation/transform",set:function(){return n(this.getParentValue(),function(e){return{drawing:{flipH:!e.isFlippedH(),rotation:-e.getRotationDeg()}}})}},"drawing/transform/flipv":{parent:"drawing/operation/transform",set:function(){return n(this.getParentValue(),function(e){return{drawing:{flipV:!e.isFlippedV(),rotation:-e.getRotationDeg()}}})}},"drawing/transform/rotate":{parent:"drawing/operation/transform",enable:function(){return!p},set:function(t){return n(this.getParentValue(),function(e){return{drawing:{rotation:e.getRotationDeg()+t}}})}},"drawing/transform/angle":{parent:"drawing/operation/transform",enable:function(){return!p},get:function(e){return m.getMixedAttributeValue(e,"drawing","rotation")},set:function(e){return n(this.getParentValue(),{drawing:{rotation:e}})}},"drawing/operation/line":{parent:"drawing/operation",enable:function(){return 0<this.getValue().length},get:function(e){return m.resolveModelsDeeply(e,C)}},"drawing/border/style":{parent:"drawing/operation/line",get:m.getMixedPresetBorder,set:function(e){var r=m.resolvePresetBorder(e);return"none"===r.type&&(r.color=null),n(this.getParentValue(),function(e,t){var n={line:_.clone(r)};return"none"!==r.type&&"auto"===t.line.color.type&&(n.line.color=i.BLACK),n})}},"drawing/border/color":{parent:"drawing/operation/line",get:m.getMixedBorderColor,set:function(r){return n(this.getParentValue(),function(e,t){var n={line:{color:r}};return m.hasVisibleBorder(t.line)||(n.line.type="solid"),n})}},"drawing/operation/fill":{parent:"drawing/operation",enable:function(){return 0<this.getValue().length},get:function(e){return m.resolveModelsDeeply(e,E)}},"drawing/fill/color":{parent:"drawing/operation/fill",get:m.getMixedFillColor,set:function(e){var t="auto"===e.type?"none":"solid";return n(this.getParentValue(),{fill:{type:t,color:e}})}},"drawing/operation/connector":{parent:"drawing/operation",enable:function(){return 0<this.getValue().length},get:function(e){return m.resolveModelsDeeply(e,P)}},"drawing/connector/arrows":{parent:"drawing/operation/connector",get:function(e){var t=m.getMixedAttributeValue(e,"line","headEndType"),n=m.getMixedAttributeValue(e,"line","tailEndType");return t&&n?t+":"+n:null},set:function(e){var t=e.split(":");return n(this.getParentValue(),{line:{headEndType:t[0],tailEndType:t[1]}})}},"drawing/operation/text":{parent:"drawing/operation",enable:function(){return 0<this.getValue().length},get:function(e){return m.resolveModelsDeeply(e,I)}},"drawing/verticalalignment":{parent:"drawing/operation/text",get:function(e){return m.getMixedAttributeValue(e,"shape","anchor")},set:function(e){return n(this.getParentValue(),{shape:{anchor:e}})}}}),this.listenTo(u,"change:activesheet",function(){r=u.getSheetModel(),h=r.drawingCollection}),this.registerDestructor(function(){c=s=u=g=f=null,r=h=null})}});