define("io.ox/office/spreadsheet/controller/tablemixin",["io.ox/office/tk/utils","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/view/dialogs","gettext!io.ox/office/spreadsheet/main"],function(R,S,r,l){"use strict";var A=S.SortDirection;return function(s){var o=this,u=null,i=null,c=null,g=null,f=null,d=null,h=!1;function p(e,t){var n=t===A.VERTICAL,r=n?e.cols():i.countVisibleIndexes(e.colInterval());if((n?S.MAX_SORT_LINE_LENGTH:S.MAX_SORT_LINES_COUNT)<r)return!1;var a=t===A.HORIZONTAL,l=a?e.rows():c.countVisibleIndexes(e.rowInterval());return!((a?S.MAX_SORT_LINE_LENGTH:S.MAX_SORT_LINES_COUNT)<l)}function a(e){return s.ensureUnlockedRanges(e,{lockMatrixes:"full"}).then(function(){return p(e)?f.coversAnyMergedRange(e)?S.makeRejected("sort:merge:overlap"):e:S.makeRejected("sort:overflow")})}function v(n){var r=n?n.getDataRange():s.getActiveRange();if(!r)return S.makeRejected("sort:blank");if(!n&&g.areRangesBlank(r))return S.makeRejected("sort:blank");var e=a(r);return(e=e.then(function(){if(n||!r.singleCol()&&!r.singleRow())return r;var t=g.findContentRange(r);return t.equals(r)?r:(r.single()?o.createResolvedPromise(!0):s.showQueryDialog(l("Sorting"),l("Expand the selection?"),{cancel:!0,autoCloseScope:"activeSheet"})).then(function(e){return e?a(t):r})})).then(function(e){return s.selectRange(e,{active:s.getActiveCell()}),{sortRange:e,hasHeader:n?n.hasHeaderRow():g.hasHeaderRow(e)}})}function b(t,n,r,a,l){var e=p(t,r)?o.createResolvedPromise():S.makeRejected("sort:overflow");return e=e.then(function(){return u.createAndApplyOperations(function(e){return n?n.generateSortOperations(e,a):(l&&(t=t.clone()).start.move(1,r===A.HORIZONTAL),g.generateSortOperations(e,t,r,a))},{storeSelection:!0})})}this.registerItemsOnSuccess({"sheet/table/selected":{parent:"sheet/operation/unlocked/cell",get:function(){return d.getTableModelAt(s.getActiveCell())}},"sheet/table/selected/real":{parent:"sheet/table/selected",get:function(e){return e&&!e.isAutoFilter()?e:null}},"sheet/table/active":{parent:"sheet/table/selected",get:function(e){return e||d.getAutoFilterModel()}},"table/flags":{parent:"sheet/table/selected/real",get:function(e){return e?e.getStyleFlags():null}},"table/filter":{parent:"sheet/table/active",enable:function(e){return!e||e.isAutoFilter()},get:function(e){return!!e&&e.isAutoFilter()},set:function(e){return t=this.getParentValue(),n=e,r=(r=s.ensureUnlockedSheet()).then(function(){return u.createAndApplyOperations(function(r){if(t&&!t.isAutoFilter())return R.error("TableMixin.toggleTableFilter(): missing implementation"),o.createRejectedPromise();var e=o.createResolvedPromise();return t&&(e=e.then(function(){return t.generateDeleteOperations(r)})),n&&(e=e.then(function(){var e=s.getSelectedRanges();if(1!==e.length)return S.makeRejected("autofilter:multiselect");var t=u.getContentRangeForCell(e.first()),n=g.getUsedRange();return!(t=n?t.intersect(n):null)||g.areRangesBlank(t)?S.makeRejected("autofilter:blank"):d.generateInsertTableOperations(r,"",t,{table:{headerRow:!0}})})),e.catch(function(e){throw e.cause=e.cause.replace(/^table:/,"autofilter:"),e})},{storeSelection:!0})}),s.yellOnFailure(r);var t,n,r}},"table/refresh":{parent:"sheet/table/active",enable:function(e){return!!e&&e.isRefreshable()},set:function(){return t=this.getParentValue(),e=(e=s.ensureUnlockedSheet()).then(function(){return u.createAndApplyOperations(function(e){return t.generateRefreshOperations(e,{updateFilter:!0,updateSort:!0})},{storeSelection:!0})}),s.yellOnFailure(e);var t,e}},"table/sort/enabled":{parent:"sheet/table/selected",enable:function(e){var t=s.getSelectedRanges();if(1!==t.length)return!1;var n=t[0];return e?e.getRange().contains(n):d.createModelIterator({overlapRange:n}).next().done}},"table/sort":{parent:"table/sort/enabled",get:function(){return h?"descending":"ascending"},set:function(e){return t=this.getParentValue(),r="toggle"===(n=e)?h:"descending"===n,a={index:s.getActiveCell()[0],descending:r},l=(l=(l=v(t)).then(function(e){return b(e.sortRange,t,A.VERTICAL,[a],e.hasHeader)})).then(function(){h=!r}),s.yellOnFailure(l);var t,n,r,a,l}},"table/sort/dialog":{parent:"table/sort/enabled",set:function(){return n=this.getParentValue(),e=(e=(e=v(n)).then(function(e){var t=e.sortRange;return new r.CustomSortDialog(s,t,n,e.hasHeader).show().then(function(e){return b(t,n,e.sortDir,e.sortRules,e.hasHeader)})})).then(function(){h=!1}),s.yellOnFailure(e);var n,e},preserveFocus:!0},"table/stylesheet":{parent:"sheet/table/selected/real",enable:function(e){return!!e},get:function(e){return e&&e.getStyleId()||""},set:function(r){var e=s.ensureUnlockedSheet();return e=e.then(function(){return u.createAndApplyOperations(function(t){var n=s.getSelectedRanges(),e=d.createModelIterator();return r=r||null,o.iterateSliced(e,function(e){e.getStyleId()!==r&&n.overlaps(e.getRange())&&e.generateChangeOperations(t,{styleId:r})},"TableMixin.changeTableStyle")},{storeSelection:!0})}),s.yellOnFailure(e)}},"table/column/attributes":{parent:"sheet/operation/unlocked/cell",set:function(e){return t=e.tableName,o=e.tableCol,i=e.attributes,n=(n=s.ensureUnlockedSheet()).then(function(){var n=d.getTableModel(t);if(!n)return $.Deferred().reject();var e=n.getDataRange(),r=R.getObjectOption(i,"sort",null),a=!1;if(r){var l=n.getColumnModel(o).getMergedAttributeSet(!0).sort;a=_.some(r,function(e,t){return l[t]!==e})}return a&&e&&f.coversAnyMergedRange(e)?S.makeRejected("sort:merge:overlap"):u.createAndApplyOperations(function(e){var t=a&&"none"!==r.type;return n.generateChangeColumnOperations(e,o,i,{resetSort:t})},{storeSelection:!0})}),s.yellOnFailure(n);var t,o,i,n}}}),this.listenTo(s,"change:activesheet",function(){u=s.getSheetModel(),i=u.colCollection,c=u.rowCollection,g=u.cellCollection,f=u.mergeCollection,d=u.tableCollection}),this.registerDestructor(function(){o=s=u=i=c=null,g=f=d=null})}});