define("io.ox/office/spreadsheet/model/formula/funcs/conversionfuncs",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/utils/logger","io.ox/office/spreadsheet/utils/scalar","io.ox/office/spreadsheet/model/formula/funcs/types"],function(r,t,o,i,s,a,l,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var u=i.repeatString("0",255),f={Y:24,Z:21,E:18,P:15,T:12,G:9,M:6,k:3,h:2,da:1,e:1,d:-1,c:-2,m:-3,u:-6,n:-9,p:-12,f:-15,a:-18,z:-21,y:-24},m={Yi:80,Zi:70,Ei:60,Pi:50,Ti:40,Gi:30,Mi:20,ki:10},h=(n.prototype.toBase=function(r){return r*this.factor},n.prototype.toUnit=function(r){return r/this.factor},n);function n(r){this.factor=r}var v=(c.prototype.toBase=function(r){return(r+this.offset)*this.factor},c.prototype.toUnit=function(r){return r/this.factor-this.offset},c);function c(r,t){this.factor=r,this.offset=t}var p=new e.FunctionSpecBuilder("conversion"),g=new s.TMap,E=new s.TMap;function w(r,t,e,n){if(r.length>e)throw l.ErrorCode.NUM;if(o.isNumber(t)){if(n&&t<r.length||e<t)throw l.ErrorCode.NUM;r.length<t&&(r=(u+r).slice(-t))}return r}function d(r){if(!/^[01]{0,10}$/.test(r))throw l.ErrorCode.NUM;var t=0<r.length?parseInt(r,2):0;return 10===r.length&&/^1/.test(r)?t-1024:t}function y(r){if(!/^[0-7]{0,10}$/.test(r))throw l.ErrorCode.NUM;var t=0<r.length?parseInt(r,8):0;return 10===r.length&&/^[4-7]/.test(r)?t-1073741824:t}function C(r){if(!/^[0-9a-f]{0,10}$/i.test(r))throw l.ErrorCode.NUM;var t=0<r.length?parseInt(r,16):0;return 10===r.length&&/^[89a-f]/i.test(r)?t-1099511627776:t}function M(r,t){if(512<-r||511<r)throw l.ErrorCode.NUM;return r<0&&(r+=1024),w(r.toString(2),t,10,!0)}function N(r,t){if(536870912<-r||536870911<r)throw l.ErrorCode.NUM;return r<0&&(r+=1073741824),w(r.toString(8),t,10,!0)}function O(r,t){if(549755813888<-r||549755813887<r)throw l.ErrorCode.NUM;return r<0&&(r+=1099511627776),w(r.toString(16).toUpperCase(),t,10,!0)}function U(r,t,e){var n=E.getOrConstruct(t,s.TMap);n.has(r)&&a.globalLogger.error('duplicate measurement unit "'+t+'" in category "'+r+'"'),n.insert(r,e)}function b(o,r,a,t){i.splitTokens(r).forEach(function(e){if(U(o,e,new h(a)),null!=t&&t.si){var n=Math.pow(10,t.si);s.forEachElement(f,function(r,t){return U(o,t+e,new h(a*Math.pow(n,r)))})}null!=t&&t.bin&&s.forEachElement(m,function(r,t){return U(o,t+e,new h(a*Math.pow(2,r)))})})}function T(t,r,e,n){i.splitTokens(r).forEach(function(r){return U(t,r,new v(e,n))})}t.default={ARABIC:p.unary("val:num","val:str",{name:{ooxml:"_xlfn.ARABIC"},resolve:function(r){if(255<(r=r.replace(/^ +| +$/g,"")).length)throw l.ErrorCode.VALUE;var t=1;"-"===r[0]&&(t=-1,r=r.substr(1));var e=i.parseRoman(r);return isFinite(e)?t*e:l.ErrorCode.VALUE.throw()}}),BASE:p.ternaryUniOpt1("val:str","val:int",{name:{ooxml:"_xlfn.BASE"},resolve:function(r,t,e){if(r<0||9007199254740991<r)throw l.ErrorCode.NUM;if(t<2||36<t)throw l.ErrorCode.NUM;if(o.isNumber(e)&&(e<0||255<e))throw l.ErrorCode.NUM;return w(r.toString(t).toUpperCase(),e,255)}}),BIN2DEC:p.unary("val:num","val:str",d),BIN2HEX:p.binaryOpt("val:str",["val:str","val:int"],function(r,t){return O(d(r),t)}),BIN2OCT:p.binaryOpt("val:str",["val:str","val:int"],function(r,t){return N(d(r),t)}),COLOR:p.genericFixed("val:num",3,4,{name:{ooxml:null,odf:"ORG.LIBREOFFICE.COLOR"},signature:["val:int","val:int","val:int","val:int"],resolve:function(r,t,e,n){if(n=n||0,r<0||255<r)throw l.ErrorCode.VALUE;if(t<0||255<t)throw l.ErrorCode.VALUE;if(e<0||255<e)throw l.ErrorCode.VALUE;if(n<0||255<n)throw l.ErrorCode.VALUE;return 16777216*n+65536*r+256*t+e}}),CONVERT:p.ternary("val:num",["val:num","val:str","val:str"],function(r,t,e){E.empty()&&function(){var r=453.59237;b("mass","g",1,{si:1}),b("mass","u",1660538782e-33,{si:1}),b("mass","lbm",r),b("mass","ozm",r/16),b("mass","grain",r/7e3),b("mass","cwt shweight",100*r),b("mass","ton",2e3*r),b("mass","stone",14*r),b("mass","uk_cwt lcwt hweight",112*r),b("mass","uk_ton LTON brton",2240*r),b("mass","sg",14593.9029372064);var t=9460730472580800,e=.0254,n=.3048,o=.9144,a=1609.344,i=e/6,s=i/12,l=1/39.37*12*3;b("length","m",1,{si:1}),b("length","ang",1e-10,{si:1}),b("length","ly",9460730472580800,{si:1}),b("length","pc parsec",0x6da012f93c9a8c,{si:1}),b("length","in",e),b("length","ft",n),b("length","yd",o),b("length","ell",1.143),b("length","mi",a),b("length","pica",i),b("length","Picapt Pica",s),b("length","Nmi",1852),b("length","survey_mi",1609.3472186944375);var u=Math.pow(e,2);b("area","m2 m^2",1,{si:2}),b("area","ang2 ang^2",1e-20,{si:2}),b("area","ar",100),b("area","Morgen",2500),b("area","ha",1e4),b("area","ly2 ly^2",Math.pow(t,2)),b("area","in2 in^2",u),b("area","ft2 ft^2",Math.pow(n,2)),b("area","yd2 yd^2",Math.pow(o,2)),b("area","mi2 mi^2",Math.pow(a,2)),b("area","Picapt2 Picapt^2 Pica2 Pica^2",Math.pow(s,2)),b("area","Nmi2 Nmi^2",Math.pow(1852,2)),b("area","uk_acre",4840*Math.pow(o,2)),b("area","us_acre",4840*Math.pow(l,2));var f=Math.pow(e,3),m=Math.pow(n,3),h=492892159375e-17,v=.00056826125;b("volume","m3 m^3",1,{si:3}),b("volume","ang3 ang^3",1e-30,{si:3}),b("volume","l L lt",.001,{si:1}),b("volume","ly3 ly^3",Math.pow(t,3)),b("volume","in3 in^3",f),b("volume","ft3 ft^3",m),b("volume","yd3 yd^3",Math.pow(o,3)),b("volume","mi3 mi^3",Math.pow(a,3)),b("volume","Picapt3 Picapt^3 Pica3 Pica^3",Math.pow(s,3)),b("volume","Nmi3 Nmi^3",Math.pow(1852,3)),b("volume","bushel",2150.42*f),b("volume","MTON",40*m),b("volume","GRT regton",100*m),b("volume","tspm",5e-6),b("volume","tsp",h),b("volume","tbs",3*h),b("volume","oz",6*h),b("volume","cup",48*h),b("volume","pt us_pt",96*h),b("volume","qt",192*h),b("volume","gal",768*h),b("volume","barrel",32256*h),b("volume","uk_pt",v),b("volume","uk_qt",2*v),b("volume","uk_gal",8*v);var c=3600;b("time","s sec",1),b("time","mn min",60),b("time","hr",c),b("time","d day",86400),b("time","yr",8766*c),b("speed","m/s m/sec",1,{si:1}),b("speed","m/h m/hr",1/c,{si:1}),b("speed","mph",a/c),b("speed","kn",1852/c),b("speed","admkn",1853.184/c);var p=9.80665,g=r*p/1e3;b("force","N",1,{si:1}),b("force","dy dyn",1e-5,{si:1}),b("force","pond",p/1e3,{si:1}),b("force","lbf",g),b("pressure","Pa p",1,{si:1}),b("pressure","atm at",101325,{si:1}),b("pressure","mmHg",133.322,{si:1}),b("pressure","Torr",101325/760),b("pressure","psi",g/u);var E=n*g*550;b("power","W w",1,{si:1}),b("power","PS",75*p),b("power","HP h",E),b("energy","J",1,{si:1}),b("energy","e",1e-7,{si:1}),b("energy","c",4.184,{si:1}),b("energy","cal",4.1868,{si:1}),b("energy","eV ev",1602176487e-28,{si:1}),b("energy","Wh wh",c,{si:1}),b("energy","HPh hh",E*c),b("energy","flb",n*g),b("energy","BTU btu",1055.05585262),b("magnetism","T",1,{si:1}),b("magnetism","ga",1e-4,{si:1}),b("temperature","K kel",1,{si:1}),T("temperature","C cel",1,273.15),T("temperature","F fah",5/9,459.67),b("temperature","Rank",5/9),T("temperature","Reau",5/4,218.52),b("information","bit",1,{si:1,bin:!0}),b("information","byte",8,{si:1,bin:!0})}();var n,o,a=E.get(t),i=E.get(e);if(!a||!i)throw l.ErrorCode.NA;if(a.forEach(function(r,t){if(i.has(t)){if(n)throw l.ErrorCode.NA;n=r,o=i.get(t)}}),!n||!o)throw l.ErrorCode.NA;return o.toUnit(n.toBase(r))}),"CONVERT.ODF":p.ternary("val:num",["val:num","val:str","val:str"],{name:{ooxml:null,odf:"ORG.OPENOFFICE.CONVERT"},hidden:!0}),DEC2BIN:p.binaryUniOpt("val:str","val:int",M),DEC2HEX:p.binaryUniOpt("val:str","val:int",O),DEC2OCT:p.binaryUniOpt("val:str","val:int",N),DECIMAL:p.binary("val:num",["val:str","val:int"],{name:{ooxml:"_xlfn.DECIMAL"},resolve:function(r,t){if(t<2||36<t)throw l.ErrorCode.NUM;if(!g.getOrCreate(t.toString(),function(){var r=t<=10?"0-"+(t-1):"0-9A-"+i.formatAlphabetic(t-10,i.AlphabeticMethod.DIGIT);return new RegExp("^["+r+"]+$","i")}).test(r))throw l.ErrorCode.NUM;var e=parseInt(r,t);return isFinite(e)&&0<=e?e:l.ErrorCode.NUM.throw()}}),HEX2BIN:p.binaryOpt("val:str",["val:str","val:int"],function(r,t){return M(C(r),t)}),HEX2DEC:p.unary("val:num","val:str",C),HEX2OCT:p.binaryOpt("val:str",["val:str","val:int"],function(r,t){return N(C(r),t)}),OCT2BIN:p.binaryOpt("val:str",["val:str","val:int"],function(r,t){return M(y(r),t)}),OCT2DEC:p.unary("val:num","val:str",y),OCT2HEX:p.binaryOpt("val:str",["val:str","val:int"],function(r,t){return O(y(r),t)}),ROMAN:p.binaryUniOpt("val:str","val:int",function(r,t){if((t=t||0)<0||5<=t||r<0||3999<r)throw l.ErrorCode.VALUE;return i.formatRoman(r,t)})}});