define("io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter",["io.ox/office/tk/utils","io.ox/office/tk/locale/locale","io.ox/office/tk/object/baseobject","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/presetformattable","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens","io.ox/office/spreadsheet/model/formula/interpret/operand","io.ox/office/spreadsheet/model/formula/interpret/formulacontext"],function(R,e,r,o,t,n,a,i,u,l){"use strict";var T=e.LOCALE_DATA,w=t.ErrorCode,E=t.isErrorCode,k=t.Address,x=t.Range,A=t.Range3DArray,F=n.PresetCode,b=n.getPercentId,O=n.getFractionId,I=n.getTimeId,M=a.ContextType,D=a.InternalErrorCode,N=a.isValType,S=a.isMatType,C=a.isRefType,V=a.isAnyType,c=a.isInternalError,P=a.Dimension,f=a.CompareNullMode,p=a.equalScalars,d=a.compareScalars,m=a.scalarToString,L=a.isValidMatrixDim,U=a.Matrix,j=a.throwEngineError,s=a.FormulaErrorCode,y=a.FormulaError,z=a.formulaLogger,W=i.TokenType,q=u.Operand,H=u.OperandResolver,Y=l.combineParsedFormats,B=l.FormulaContext;function G(e,r){if(C(r)&&!C(e)&&!V(e))throw new y("expected reference token",s.REFERENCE)}var v=r.extend({constructor:function(l,u,s,c,e){var f=l.numberFormatter,p=R.getIntegerOption(e,"refSheet",null),d=R.getOption(e,"wrapReferences",!1),m=R.getOption(e,"recalcDirty",!1),y=new B(l,c,e);function v(e,r){return!r&&e instanceof q?e:y.createOperand(e,r)}function o(e,r,t){var n,o,a=e.token,i=null,u=null;switch(z.log("> resolving operand token "+a+" with context type "+r),a.type){case W.LIT:i=(u=a.value)===w.REF?M.REF:M.VAL;break;case W.MAT:u=a.value,i=M.MAT;break;case W.REF:u=(o=a.getRange3D(s,c,p,d))?new A(o):w.REF,i=M.REF;break;case W.NAME:u=function(e,r,t){var n=l.resolveNameModel(e,p);if(!n)return w.NAME;var o=y.getRefAddress(),a={refSheet:p,recalcDirty:m};return t&&(a.matrixRange=x.createFromAddressAndSize(o,t.cols,t.rows)),S(r)&&!t&&(r=M.ANY),n.tokenArray.interpretFormula(r,k.A1,o,a).value}(a,r,t),i=M.ANY;break;case W.TABLE:u=(n=a.getRange3D(c))?new A(n):w.REF,i=M.REF;break;default:j('InterpreterInstance.resolveOperandNode(): unknown token type: "'+a.type+'"')}return G(i,r),v(u)}function h(r,t,n,o,a){return y.checkEvalTime(),v(function(){try{y.setMatrixPosition(o,a);var e=n.map(function(e,r){return e?y.convertOperandToValue(e,t[r].typeSpec):null});return z.logTokens("  resolving with parameters",e),r.resolve.apply(y,e)}catch(e){if(E(e))return e;throw e}}())}function a(a,i,u){if(a.error)throw a.error;var e=a.token;z.log("> processing operator "+e+" with "+a.operands.length+" parameters and context type "+i);var o=a.resource;if(!o)return v(w.NAME);if(G(o.retType,i),!_.isFunction(o.resolve))return z.warn('InterpreterInstance.resolveOperatorNode(): unsupported operator or function "'+e+'"'),v(D.UNSUPPORTED);if(u&&!L(u))return v(D.UNSUPPORTED);var l=new H,s=a.signature;s.forEach(function(e,r){var t=a.operands[r],n=S(i)&&e.preferMat?M.MAT:e.contextType,o=S(n)&&e.forwardDim;l.push(g.bind(null,t,n,o?u:null))});var c=s.map(function(e,r){return"any:lazy"===e.typeSpec?null:l.resolve(r)});if(!u&&N(o.retType)){var n=S(i);if(n||o.allValType){try{c.forEach(function(e,r){if(e&&(n?N(s[r].baseType)&&!N(e.type):S(e.type))){var t=e.getDimension({errorCode:w.VALUE});u=P.boundary(u,t)}})}catch(e){if(E(e))return v(e);throw e}if(u){if(!L(u))return v(D.UNSUPPORTED);i=M.MAT}}}var r=z.takeTime(o.key,function(){try{y.pushOperandResolver(l,i,u);var n=h(o,s,c,0,0),e=o.retType;if(S(e)&&N(n.type)&&(n=v(new U(n.getRawValue()))),V(e)||e===n.type||C(e)&&N(n.type)&&E(n.getRawValue())||N(e)&&S(i)&&S(n.type)||j("InterpreterInstance.resolveOperatorNode(): "+o.key+": operator result type does not match operator return type"),u&&N(n.type))z.info("  expand scalar result to "+u+" matrix"),n=v(new U(u.rows,u.cols,function(e,r){if(0===e&&0===r)return n.getRawValue();var t=h(o,s,c,e,r);if(N(t.type))return t.getRawValue();j("InterpreterInstance.resolveOperatorNode(): invalid matrix element type")}));return n}finally{y.popOperandResolver()}}),t=o.format&&!S(i)?function(e,r){if("infer"===r){for(var t=f.standardFormat,n=0;t&&n<e.size();n+=1){var o=e.get(n),a=o&&o.format||f.standardFormat;t=Y(t,a)}return t}var i=null;switch(r){case"percent":i=b({int:!0});break;case"currency":i=f.presetTable.getCurrencyCode({red:!0});break;case"fraction":i=O(2);break;case"date":i=F.DATE_SHORT;break;case"time":i=I({hours24:T.hours24,seconds:!0});break;case"datetime":i=F.DATETIME_SHORT}return null===i?null:f.getParsedFormat(i)}(l,o.format):null;return t?v(r,{format:t}):r}function g(e,r,t){var n=(e.operands?a:o)(e,r,t);return z.log("< result of "+e+": "+n),n}r.call(this,l),this.getResult=function(e,r){var t=function(){try{return g(u,e,r)}catch(e){if(E(e))return v(e);throw e}}(),n=V(e)?t.type:e,o={value:function(){try{switch(n){case M.VAL:return t.getScalar(null,null);case M.MAT:return t.getMatrix();case M.REF:return t.getRanges();default:j('InterpreterInstance.getResult(): unknown context type: "'+n+'"')}}catch(e){if(E(e))return e;throw e}}()},a=t.format;a&&!a.isStandard()&&(o.format=a);var i=t.url;return null!==i&&(o.url=i),o},this.registerDestructor(function(){l=u=e=f=y=null})}});return o.extend({constructor:function(s){var t={withCase:"odf"===s.docApp.getFileFormat(),nullMode:f.CONVERT};function n(e,r,t,n){var o=S(e)?new U(n):n;return z.info(function(){return"result: type="+r+" code="+t+" value="+m(o)}),{type:r,code:t,value:o}}o.call(this,s),this.equalScalars=function(e,r){return p(e,r,t)},this.compareScalars=function(e,r){return d(e,r,t)},this.createWarnResult=function(e,r){var t=c(r)?r.value:r;return n(e,"warn",r.key,t)},this.createErrorResult=function(e,r){return n(e,"error",r,w.NA)},this.interpretTokens=z.profileMethod("FormulaInterpreter.interpretTokens",function(r,e,t,n,o){z.log("contextType="+r);var a=new v(s,e,t,n,o);try{var i=S(r)?R.getOption(o,"matrixRange",null):null,u=i?P.createFromRange(i):null,l=a.getResult(r,u);return c(l.value)?this.createWarnResult(r,l.value):(l.type="valid",z.info(function(){return"result: type=valid value="+m(l.value)+" format="+l.format+" url="+l.url}),l)}catch(e){if(E(e))return this.createWarnResult(r,e);if(e instanceof y)return z.warn("  error: "+e.message),this.createErrorResult(r,e.code);throw e}finally{a.destroy()}}),this.registerDestructor(function(){s=null})}})});