var __extends=this&&this.__extends||function(){var o=function(e,t){return(o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(e,t)};return function(e,t){function r(){this.constructor=e}o(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}}();define("io.ox/office/spreadsheet/model/formula/parser/formulagrammar",["require","exports","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/locale/autoformat","io.ox/office/tk/object/dobject","io.ox/office/baseframework/utils/apputils","io.ox/office/spreadsheet/utils/scalar","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/range","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/utils/types","io.ox/office/spreadsheet/model/formula/utils/logger","io.ox/office/spreadsheet/model/formula/utils/sheetref","io.ox/office/spreadsheet/model/formula/utils/cellref","io.ox/office/spreadsheet/model/formula/parser/referencegrammar","io.ox/office/spreadsheet/model/formula/parser/formulaparser","io.ox/office/spreadsheet/model/formula/parser/rangelistparser"],function(e,t,n,r,o,a,C,i,s,c,R,L,h,E,m,O,p,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FormulaGrammar=void 0;var f="_xludf.",u=new r.TMap;function g(e){return e instanceof E.SheetRef?e:null==e?void 0:e.r1}function A(e){return e instanceof E.SheetRef||null==e?void 0:e.r2}function M(e){return new RegExp("^(?:"+e[0]+"(\\d*))?(?:"+e[1]+"(\\d*))?$","i")}var I,d=(I=a.DObject,__extends(T,I),T.get=function(e,t){var r=e.getResource(t),o=t!==L.GrammarType.OP&&t!==L.GrammarType.OP_OOX,a=t===L.GrammarType.UI_RC||t===L.GrammarType.EN_RC,n=r.uid+":"+(o?1:0)+(a?1:0);return u.getOrCreate(n,function(){return new T(r,o,a)})},T.prototype.isReservedSymbol=function(e,t){return this._isBooleanLiteral(t)||this._isReferenceSymbol(e,t)},T.prototype.isSimpleSheetName=function(e,t,r){var o=t.match(this.SIMPLE_EXT_SHEET_NAME_RE);return!(!o||o[1]&&(null==r||!r.external)||o[3]&&(null==r||!r.range)||this.isReservedSymbol(e,o[2])||o[3]&&this.isReservedSymbol(e,o[3]))},T.prototype.validateNameLabel=function(e,t){return 0===t.length?"name:empty":!this.VALID_NAME_RE.test(t)||!this.odf&&this._isBooleanLiteral(t)?"name:invalid":this._isReferenceSymbol(e,t)?"name:address":""},T.prototype.formatScalar=function(e){switch(i.getScalarType(e)){case i.ScalarTypeId.NUMBER:var t=e;return isFinite(t)?n.isZero(t)?"0":o.autoFormatNumber(e,R.MAX_LENGTH_STANDARD_EDIT,{dec:this.DEC}).text:this.getErrorName(i.ErrorCode.NUM);case i.ScalarTypeId.STRING:return'"'+e.replace(/"/g,'""')+'"';case i.ScalarTypeId.BOOLEAN:return this.getBooleanName(e);case i.ScalarTypeId.ERROR:return this.getErrorName(e)||this.NA_ERROR;case i.ScalarTypeId.NULL:return""}return h.formulaLogger.warn("FormulaGrammar.formatScalar: unsupported scalar value type"),""},T.prototype.formatGenericRange=function(e,t,r,o){if(this.REF_SYNTAX===L.RefSyntaxType.OF){var a=g(o),n=this._generateOFSheetPrefix(e,a);if(null===n)return this.REF_ERROR;var i=A(o),s=i?this._generateOFSheetPrefix(e,i):"";if(null===s)return this.REF_ERROR;var R=n+t;return(s||r)&&(R+=":"+s+(r||t)),R}var E=this._generateSheetRangePrefix(e,o);return null===E?this.REF_ERROR:""+E+t+(r?":"+r:"")},T.prototype.formatReference=function(e,t,r,o){var a=this.RC_STYLE,n=this.PREFIX_CHARS,i=this.REF_ERROR;if(!this.UI&&a)return h.formulaLogger.error("FormulaGrammar.formatReference: R1C1 notation not supported in native grammar"),this.NA_ERROR;var s=r instanceof m.CellRef?r:null==r?void 0:r.r1,R=r instanceof m.CellRef||null==r?void 0:r.r2;if(this.REF_SYNTAX===L.RefSyntaxType.OF){if(!s)return"["+i+"]";var E=s.refText();g(o)||(E="."+E);var p="";return R&&(p=R.refText(),A(o)||(p="."+p)),"["+this.formatGenericRange(e,E,p,o)+"]"}if(!s)return this.odf?i:this.formatGenericRange(e,i,null,o);var l=c.Range.createFromAddresses(s.toAddress(),null==R?void 0:R.toAddress()),f="",u="";return s.absCol&&null!=R&&R.absCol&&e.addressFactory.isRowRange(l)?(f=a?s.rowTextRC(n,t):s.rowText(),a&&l.singleRow()&&s.absRow===R.absRow||(u=a?R.rowTextRC(n,t):R.rowText())):s.absRow&&null!=R&&R.absRow&&e.addressFactory.isColRange(l)?(f=a?s.colTextRC(n,t):s.colText(),a&&l.singleCol()&&s.absCol===R.absCol||(u=a?R.colTextRC(n,t):R.colText())):(f=a?s.refTextRC(n,t):s.refText(),R&&(u=a?R.refTextRC(n,t):R.refText())),this.formatGenericRange(e,f,u,o)},T.prototype.formatName=function(e,t,r,o){if(this.odf&&(r||o))return this.NA_ERROR;var a=this._generateSheetRangePrefix(e,r,o);return null===a?this.REF_ERROR:a+t},T.prototype.formatMacro=function(e,t,r,o){if(this.odf)return r||o?this.NA_ERROR:t;var a=f.length<t.length&&n.stringStartsWith(t.toLowerCase(),f);return this.UI&&a?t=t.substr(f.length):this.UI||a||!this.functionMap.getKey(t,!1)||(t=f+t),this.formatName(e,t,r,o)},T.prototype.getBooleanName=function(e){return this.booleanMap.getName(e?"t":"f",this.UI)},T.prototype.getBooleanValue=function(e){var t=this.booleanMap.getKey(e,this.UI);return t?"t"===t:null},T.prototype.getErrorName=function(e){return this.errorMap.getName(e.key,this.UI)},T.prototype.getErrorCode=function(e){var t=this.errorMap.getKey(e,this.UI);return t?i.ErrorCode[t]:null},T.prototype.getOperatorName=function(e){return this.operatorMap.getName(e,this.UI)},T.prototype.getOperatorKey=function(e){return this.operatorMap.getKey(e,this.UI)},T.prototype.getFunctionName=function(e){return this.functionMap.getName(e,this.UI)},T.prototype.getFunctionKey=function(e){return this.functionMap.getKey(e,this.UI)},T.prototype.getTableRegionName=function(e){return this.regionMap.getName(e,this.UI)},T.prototype.getTableRegionKey=function(e){return this.regionMap.getKey(e,this.UI)},T.prototype.isSimpleTableColumn=function(e){return this.SIMPLE_TABLE_COLUMN_NAME_RE.test(e)},T.prototype.decodeTableColumn=function(e){return e.replace(/'(.)/g,"$1")},T.prototype.encodeTableColumn=function(e){return e.replace(this.TABLE_COL_ESCAPE_RE,"'$&")},T.prototype.generateAutoFormula=function(e,t,r,o){var a=this.getFunctionName(t);if(!r)return a+"()";var n=new m.CellRef(r.start[0],r.start[1],!1,!1),i=r.single()?void 0:new m.CellRef(r.end[0],r.end[1],!1,!1);return a+"("+this.formatReference(e,o,{r1:n,r2:i})+")"},T.prototype.parseFormula=function(e,t,r,o){return(this._formulaParser||(this._formulaParser=p.createFormulaParser(this))).parse(e,t,r,o)},T.prototype.parseRangeList=function(e,t,r){return(this._rangeListParser||(this._rangeListParser=l.createRangeListParser(this))).parse(e,t,r)},T.prototype.formatRangeList=function(e,t,r){return(this._rangeListParser||(this._rangeListParser=l.createRangeListParser(this))).format(e,t,r)},T.prototype._isBooleanLiteral=function(e){return null!==this.booleanMap.getKey(e,this.UI)},T.prototype._isReferenceSymbol=function(e,t){if(0===t.length)return!1;if(e.addressFactory.parseAddress(t))return!0;var r=t.match(this.SIMPLE_RCREF_RE)||this.SIMPLE_RCREF_EN_RE&&t.match(this.SIMPLE_RCREF_EN_RE);if(!r)return!1;var o=r[1]?parseInt(r[1],10)-1:0,a=r[2]?parseInt(r[2],10)-1:0;return e.addressFactory.isValidAddress(new s.Address(a,o))},T.prototype._encodeAbsSheetName=function(e,t,r){return t&&!this.isSimpleSheetName(e,t)&&(t=E.encodeComplexSheetName(t)),(r&&t?"$":"")+t},T.prototype._generateSheetRangePrefix=function(e,t,r){var o=r?"["+r.index+"]":"",a=g(t);if(a){var n=a.resolve(e,r);if(null===n)return null;var i=A(t),s=i&&!a.equals(i)?i.resolve(e,r):"";if(null===s)return null;o+=this.odf?this._encodeAbsSheetName(e,n,a.abs):n,s&&(o+=":"+(this.odf?this._encodeAbsSheetName(e,s,i.abs):s)),this.odf||this.isSimpleSheetName(e,n)&&(!s||this.isSimpleSheetName(e,s))||(o=E.encodeComplexSheetName(o))}return o?o+"!":""},T.prototype._generateOFSheetPrefix=function(e,t){if(!t)return"";var r=t.resolve(e);return r?this._encodeAbsSheetName(e,r,t.abs)+".":null},T);function T(e,t,r){var o=I.call(this)||this,a=o.odf=e.fileFormat===C.FileFormatType.ODF;o.UI=t,o.REF_SYNTAX=a?t?L.RefSyntaxType.ODF_UI:L.RefSyntaxType.OF:L.RefSyntaxType.OOX,o.RC_STYLE=r,o.DEC=e.getDec(t);var n=o.SEP=e.getSeparator(t);o.TABLE_SEP=n,o.MAT_OPEN="{",o.MAT_ROW=a||t?"|":";",o.MAT_COL=a||t?";":",",o.MAT_CLOSE="}",o.PREFIX_CHARS=e.getRCPrefixChars(t);var i=o.booleanMap=e.booleanMap,s=o.errorMap=e.errorMap,R=o.regionMap=e.regionMap,E=o.operatorMap=e.operatorMap;o.functionMap=e.functionMap,o.ISECT_SPACE=" "===E.getName("isect",t),o.NA_ERROR=s.getName("NA",t),o.REF_ERROR=s.getName("REF",t),o.refGrammar=O.createReferenceGrammar(e,t,r);var p=o.refGrammar.sheetConfig,l=p.PATTERNS,f=l.TERMINATE_REF,u=l.NAME_INNER_CHAR_CLASS,c=l.DEFINED_NAME,h=_.escapeRegExp(n),m=_.escapeRegExp(o.TABLE_SEP),g="\\[\\]'#"+(t?"@":""),A="\\x00-\\x2B\\x2D-\\x2F\\x3A-\\x40\\x5B-\\x60\\x7B\\x7D\\x7E"+(","===n?n:""),d="([^"+A+"]+)",T="((?:[^"+g+"]|'.)+)",S="(?:"+d+"|\\["+T+"\\])",x="(["+O.WHITESPACE_CHARS+"]*)",N="(?:(["+O.WHITESPACE_CHARS+"]+)(?=\\[|\\]|"+m+(t?"|@":"")+"|$))?";o.SIMPLE_RCREF_RE=M(o.PREFIX_CHARS);var y=e.getRCPrefixChars(!1);return o.SIMPLE_RCREF_EN_RE=o.PREFIX_CHARS!==y?M(y):void 0,o.SIMPLE_EXT_SHEET_NAME_RE=p.RE.SIMPLE_EXT_SHEET_NAME,o.VALID_NAME_RE=new RegExp("^"+c+"$","i"),o.TABLE_COL_ESCAPE_RE=new RegExp("["+g+"]","g"),o.SIMPLE_TABLE_COLUMN_NAME_RE=new RegExp("^[^"+A+"]+$","i"),o.RE={STRING_LIT:/^(".*?")+/,BOOLEAN_LIT:new RegExp("^"+i.getAllPattern(t)+f,"i"),ERROR_LIT:new RegExp("^"+s.getAllPattern(t)+"(?!"+u+")","i"),FRACTION_LIT:/^(\d+) (\d+)\/(0*[1-9]\d*)/,MATRIX_OPEN:new RegExp("^"+_.escapeRegExp(o.MAT_OPEN)),MATRIX_COL_SEPARATOR:new RegExp("^"+_.escapeRegExp(o.MAT_COL)),MATRIX_ROW_SEPARATOR:new RegExp("^"+_.escapeRegExp(o.MAT_ROW)),MATRIX_CLOSE:new RegExp("^"+_.escapeRegExp(o.MAT_CLOSE)),WHITESPACE:new RegExp("^["+O.WHITESPACE_CHARS+"]+"),SEPARATOR:new RegExp("^"+h),OPERATOR:new RegExp("^"+E.getAllPattern(t)),OPEN:/^\(/,CLOSE:/^\)/,TABLE_OPEN:new RegExp("^\\["+N),TABLE_CLOSE:new RegExp("^"+x+"(\\]|$)"),TABLE_SEPARATOR:new RegExp("^"+x+m+N),TABLE_SINGLE_REGION_NAME:new RegExp("^"+R.getAllPattern(t)+"(?=\\])","i"),TABLE_SINGLE_COLUMN_NAME:new RegExp("^"+T+"(?=\\])","i"),TABLE_SIMPLE_COLUMN_NAME:new RegExp("^"+d,"i"),TABLE_REGION_REF:new RegExp("^\\["+R.getAllPattern(t)+"\\]","i"),TABLE_COLUMN_REF:new RegExp("^\\["+T+"\\]","i"),TABLE_MIXED_COLUMN_REF:new RegExp("^"+x+S,"i"),TABLE_COLUMN_RANGE_REF:new RegExp("^\\["+T+"\\]:\\["+T+"\\]","i"),TABLE_MIXED_COLUMN_RANGE_REF:new RegExp("^"+x+S+":"+S,"i"),TABLE_THISROW_REF:/^@/},o}t.FormulaGrammar=d});