define("io.ox/office/spreadsheet/model/formula/parser/formulaparser",["exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/utils/class","io.ox/office/tk/object/dobject","io.ox/office/tk/locale/parser","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(e,t,r,s,n,a,c,i,o){"use strict";var f=t.isNumber,l=t.toNumber,E=t.toBoolean,R=r.stringStartsWith,T=s.TArray,h=a.DObject,u=c.parseLeadingNumber,x=i.Matrix,p=i.SheetRef,g=i.RefSyntaxType,k=i.formulaLogger,m=o.TokenType,A=o.FixedToken,C=o.ScalarToken,S=o.MatrixToken,N=o.OperatorToken,O=o.FunctionToken,F=o.SeparatorToken,d=o.ParenthesisToken,L=o.ReferenceToken,w=o.DefNameToken,I=o.MacroToken,v=o.TableToken;function b(e,t){this.token=t,this.index=-1,this.text=e,this.start=0,this.end=0}b.fixed=function(e,t){return new b(e,new A(t,e))},b.scalar=function(e,t){return new b(e,new C(t))},b.operator=function(e,t){return new b(e,new N(t))},b.prototype.toString=function(){return this.token.toString()};var B=n.extend(h,function(e){h.call(this),this.grammar=e,this.RE=e.RE,this.refGrammar=e.refGrammar});B.prototype._parseNextToken=function(e){var t=this.RE,r=null,s=null;return(r=t.STRING_LIT.exec(e))?b.scalar(r[0],r[0].slice(1,r[0].length-1).replace(/""/g,'"')):(r=t.BOOLEAN_LIT.exec(e))?b.scalar(r[0],this.grammar.getBooleanValue(r[0])):(r=t.ERROR_LIT.exec(e))?b.scalar(r[0],this.grammar.getErrorCode(r[0])):(r=t.FRACTION_LIT.exec(e))?b.scalar(r[0],parseInt(r[1],10)+parseInt(r[2],10)/parseInt(r[3],10)):(r=t.WHITESPACE.exec(e))?b.fixed(r[0],m.WS):(r=t.SEPARATOR.exec(e))?new b(r[0],new F):(r=t.OPERATOR.exec(e))?b.operator(r[0],this.grammar.getOperatorKey(r[0])):(r=t.OPEN.exec(e))?new b(r[0],new d(!0)):(r=t.CLOSE.exec(e))?new b(r[0],new d(!1)):(r=t.MATRIX_OPEN.exec(e))?this._parseMatrixLit(e):(s=this.parseNextRefToken(e))?s:(r=u(e,{dec:this.grammar.DEC}))?b.scalar(r.text,r.number):(s=this.parseNextNameToken(e))?s:void 0},B.prototype._parseMatrixLit=function(e){var t=e,r="start",s=this.RE,n=null,a=[],c=null;function i(){return a.every(function(e,t){return 0===t||e.length===a[t-1].length})}for(;"end"!==r;){switch(r){case"start":(n=s.MATRIX_OPEN.exec(e))&&(a.push(c=[]),r="open");break;case"open":case"sep":(n=s.WHITESPACE.exec(e))||((n=s.FRACTION_LIT.exec(e))?(c.push(parseInt(n[1],10)+parseInt(n[2],10)/parseInt(n[3],10)),r="lit"):(n=u(e,{dec:this.grammar.DEC,sign:!0}))?(c.push(n.number),n=[n.text],r="lit"):(n=s.STRING_LIT.exec(e))?(c.push(n[0].slice(1,n[0].length-1).replace(/""/g,'"')),r="lit"):(n=s.BOOLEAN_LIT.exec(e))?(c.push(this.grammar.getBooleanValue(n[0])),r="lit"):(n=s.ERROR_LIT.exec(e))&&(c.push(this.grammar.getErrorCode(n[0])),r="lit"));break;case"lit":0===e.length?(n=this.autoCorrect&&i()?[""]:null,r="end"):(n=s.WHITESPACE.exec(e))||((n=s.MATRIX_ROW_SEPARATOR.exec(e))?(a.push(c=[]),r="sep"):(n=s.MATRIX_COL_SEPARATOR.exec(e))?r="sep":(n=s.MATRIX_CLOSE.exec(e))&&(i()||(n=null),r="end"))}if(!n)return null;e=e.substr(n[0].length)}return new b(t.substr(0,t.length-e.length),new S(new x(a)))},B.prototype.createReferenceToken=function(e,t,r){return!r&&this.extendSheet&&0<=this.refSheet&&(r={r1:new p(this.refSheet,!0)}),new b(e,new L(this.docAccess,t,r))},B.prototype.createNameToken=function(e,t,r){!r&&this.extendSheet&&0<=this.refSheet&&this.docAccess.resolveName(this.refSheet,t)&&(r=new p(this.refSheet,!0));var s=!r&&R(e,"[0]!")?{index:0}:void 0;return new b(e,new w(this.docAccess,t,r,s))},B.prototype.createFunctionToken=function(e,t,r){var s=r?null:this.grammar.getFunctionKey(t);return new b(e,s?new O(s):new I(this.docAccess,t,r))},B.prototype.createTableToken=function(e,t,r){return new b(e,new v(this.docAccess,t,r))},B.prototype.createNameOrTableToken=function(e,t,r){var s=this.createNameToken(e,t,r);return s.token.resolveTable()?this.createTableToken(e,t):s},B.prototype.createSheetRef=function(e,t){return this.refGrammar.createSheetRef(this.docAccess,e,t)},B.prototype.createSheetRefs=function(e,t,r){return this.refGrammar.createSheetRefs(this.docAccess,e,t,r)},B.prototype.createCellRangeRefs=function(e,t,r){return this.refGrammar.createCellRangeRefs(this.docAccess,this.refAddress,this.wrapReferences,e,t,r)},B.prototype.createColRangeRefs=function(e,t,r){return this.refGrammar.createColRangeRefs(this.docAccess,this.refAddress,this.wrapReferences,e,t,r)},B.prototype.createRowRangeRefs=function(e,t,r){return this.refGrammar.createRowRangeRefs(this.docAccess,this.refAddress,this.wrapReferences,e,t,r)},B.prototype.parseNextRefToken=function(){return k.error("FormulaParserBase.parseNextRefToken - missing implementation"),null},B.prototype.parseNextNameToken=function(){return k.error("FormulaParserBase.parseNextNameToken - missing implementation"),null},B.prototype.parse=k.profileMethod("FormulaParser.parse",function(e,t,r,s){k.log(function(){return'formula="'+t+'"'}),this.docAccess=e,this.refAddress=r,this.refSheet=l(s&&s.refSheet,-1),this.wrapReferences=E(s&&s.wrapReferences),this.autoCorrect=E(s&&s.autoCorrect),this.extendSheet=E(s&&s.extendSheet),this.unqualifiedTables=E(s&&s.unqualifiedTables);for(var R=new T;0<t.length;){var n=this._parseNextToken(t)||b.fixed(t,m.BAD);R.push(n),t=t.substr(n.text.length)}k.logTokens("tokenize",R);var h=this.grammar.ISECT_SPACE;return R.forEachReverse(function(e,t){var r=e.token,s=R[t-1],n=R[t+1];if(r.type===m.OP&&"sub"===r.value&&n&&n.token.type===m.LIT){var a=n.token.value;if(f(a)&&0<a){var c=s&&s.token.type===m.WS?R[t-2]:s;c&&!c.token.isType(m.OP,m.SEP,m.OPEN)||(e.token=new C(-a),e.text+=n.text,R.deleteAt(t+1))}}if(h&&r.type===m.WS){var i=i=e.text.indexOf(" ");if(0<=i&&s&&s.token.isType(m.REF,m.NAME,m.CLOSE)&&n&&n.token.isType(m.REF,m.NAME,m.OPEN,m.FUNC)){if(i+1<e.text.length){var o=e.text.slice(i+1);R.insertAt(t+1,b.fixed(o,m.WS))}R.insertAt(t+1,b.operator(" ","isect")),0<i?(r.setValue(e.text.slice(0,i)),e.text=r.value):R.deleteAt(t)}}},this),k.logTokens("postprocess",R),R.forEach(function(e,t){e.index=t,e.start=0===t?0:R[t-1].end,e.end=e.start+e.text.length}),R});var y=B.extend(function(e){B.call(this,e)});y.prototype._parseTableRef=function(e,t){var r=this.RE,s=e;t&&(e=e.substr(t.text.length));var n=t?t.token:null,a=r.TABLE_OPEN.test(e),c=n?n.resolveTable():void 0;if(n&&a&&!c)return null;if(n&&!a&&c)return this.createTableToken(t.text,n.value);if(!a)return t;if(!n&&this.grammar.UI&&this.unqualifiedTables&&0<=this.refSheet&&(c=this.docAccess.resolveTableAt(this.refSheet,this.refAddress)),!c)return null;var i=this.grammar,o=this.autoCorrect,R="start",h=null,f={},l={};function E(){l[i.getTableRegionKey(h[1])]=!0,R="ref"}function T(e,t){R="col1Name"in f?(h=null,"end"):(f.col1Name=i.decodeTableColumn(e),f.col2Name=t?i.decodeTableColumn(t):null,"ref")}function u(){T(h[1],h[2])}function x(e){e&&h[1]&&(f.openWs=!0),T(h[2]||h[3],h[4]||h[5])}function p(){h[1]&&(f.closeWs=!0),o||0!==h[2].length||(h=null),R="end"}for(;"end"!==R;){switch(R){case"start":(h=r.TABLE_OPEN.exec(e))&&(h[1]&&(f.openWs=!0),R="open");break;case"open":(h=r.TABLE_CLOSE.exec(e))?p():(h=r.TABLE_SINGLE_REGION_NAME.exec(e))?E():(h=r.TABLE_SINGLE_COLUMN_NAME.exec(e))?u():(h=r.TABLE_REGION_REF.exec(e))?E():!this.grammar.UI&&(h=r.TABLE_COLUMN_RANGE_REF.exec(e))||!this.grammar.UI&&(h=r.TABLE_COLUMN_REF.exec(e))?u():this.grammar.UI&&(h=r.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))||this.grammar.UI&&(h=r.TABLE_MIXED_COLUMN_REF.exec(e))?x(!0):this.grammar.UI&&(h=r.TABLE_THISROW_REF.exec(e))&&(l.ROW=!0,R="row");break;case"ref":(h=r.TABLE_CLOSE.exec(e))?p():(h=r.TABLE_SEPARATOR.exec(e))&&(h[2]&&(f.sepWs=!0),R="sep");break;case"sep":(h=r.TABLE_REGION_REF.exec(e))?E():!this.grammar.UI&&(h=r.TABLE_COLUMN_RANGE_REF.exec(e))||!this.grammar.UI&&(h=r.TABLE_COLUMN_REF.exec(e))?u():(this.grammar.UI&&(h=r.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))||this.grammar.UI&&(h=r.TABLE_MIXED_COLUMN_REF.exec(e)))&&x();break;case"row":(h=r.TABLE_CLOSE.exec(e))?(p(),f.closeWs&&(h=null)):(h=r.WHITESPACE.exec(e))||((h=r.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))||(h=r.TABLE_MIXED_COLUMN_REF.exec(e)))&&x()}if(!h)return null;e=e.substr(h[0].length)}switch((l=_.keys(l)).length){case 0:break;case 1:f.regionSpec=l[0];break;case 2:if("HEADERS,DATA"===(l=l.join(","))||"DATA,HEADERS"===l)f.regionSpec="HEADERS,DATA";else{if("DATA,TOTALS"!==l&&"TOTALS,DATA"!==l)return null;f.regionSpec="DATA,TOTALS"}break;default:return null}var g=s.substr(0,s.length-e.length);return this.createTableToken(g,c.name,f)},y.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null,s=null;return(r=t.RANGE_REF.exec(e))&&(s=this.createCellRangeRefs(r,1,5))?this.createReferenceToken(r[0],s):(r=t.RANGE_3D_REF.exec(e))&&(s=this.createCellRangeRefs(r,4,8))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.RANGE_CUBE_REF.exec(e))&&(s=this.createCellRangeRefs(r,5,9))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1,!0)):(r=t.CELL_REF.exec(e))&&(s=this.createCellRangeRefs(r,1))?this.createReferenceToken(r[0],s):(r=t.CELL_3D_REF.exec(e))&&(s=this.createCellRangeRefs(r,4))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.CELL_CUBE_REF.exec(e))&&(s=this.createCellRangeRefs(r,5))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1,!0)):(r=t.COLS_REF.exec(e))&&(s=this.createColRangeRefs(r,1,3))?this.createReferenceToken(r[0],s):(r=t.COLS_3D_REF.exec(e))&&(s=this.createColRangeRefs(r,4,6))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.COLS_CUBE_REF.exec(e))&&(s=this.createColRangeRefs(r,5,7))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1,!0)):(r=t.COL_REF.exec(e))&&(s=this.createColRangeRefs(r,1))?this.createReferenceToken(r[0],s):(r=t.COL_3D_REF.exec(e))&&(s=this.createColRangeRefs(r,4))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.COL_CUBE_REF.exec(e))&&(s=this.createColRangeRefs(r,5))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1,!0)):(r=t.ROWS_REF.exec(e))&&(s=this.createRowRangeRefs(r,1,3))?this.createReferenceToken(r[0],s):(r=t.ROWS_3D_REF.exec(e))&&(s=this.createRowRangeRefs(r,4,6))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.ROWS_CUBE_REF.exec(e))&&(s=this.createRowRangeRefs(r,5,7))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1,!0)):(r=t.ROW_REF.exec(e))&&(s=this.createRowRangeRefs(r,1))?this.createReferenceToken(r[0],s):(r=t.ROW_3D_REF.exec(e))&&(s=this.createRowRangeRefs(r,4))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.ROW_CUBE_REF.exec(e))&&(s=this.createRowRangeRefs(r,5))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1,!0)):(r=t.ERROR_3D_REF.exec(e))?this.createReferenceToken(r[0],void 0,this.createSheetRefs(r,1)):(r=t.ERROR_CUBE_REF.exec(e))?this.createReferenceToken(r[0],void 0,this.createSheetRefs(r,1,!0)):void 0},y.prototype.parseNextNameToken=function(e){var t=this.RE,r=this.refGrammar.RE,s=null;return(s=r.FUNCTION_REF.exec(e))?this.createFunctionToken(s[0],s[1]):(s=r.FUNCTION_3D_REF.exec(e))?this.createFunctionToken(s[0],s[4],this.createSheetRef(s,1)):(s=r.NAME_3D_REF.exec(e))?this._parseTableRef(e,this.createNameToken(s[0],s[4],this.createSheetRef(s,1))):(s=r.NAME_REF.exec(e))?this._parseTableRef(e,this.createNameToken(s[0],s[1])):this.grammar.UI&&(s=t.TABLE_OPEN.exec(e))?this._parseTableRef(e,null):void 0};var U=B.extend(function(e){B.call(this,e)});U.prototype.createSheetRangeRefs=function(e,t){return{r1:p.create(this.docAccess,e[t+1],e[t+2],void 0,!!e[t]),r2:p.create(this.docAccess,e[t+4],e[t+5],void 0,!!e[t+3])}},U.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null,s=null;return(r=t.RANGE_REF.exec(e))&&(s=this.createCellRangeRefs(r,1,5))?this.createReferenceToken(r[0],s):(r=t.RANGE_3D_REF.exec(e))&&(s=this.createCellRangeRefs(r,5,9))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.RANGE_CUBE_REF.exec(e))&&(s=this.createCellRangeRefs(r,7,11))?this.createReferenceToken(r[0],s,this.createSheetRangeRefs(r,1)):(r=t.CELL_REF.exec(e))&&(s=this.createCellRangeRefs(r,1))?this.createReferenceToken(r[0],s):(r=t.CELL_3D_REF.exec(e))&&(s=this.createCellRangeRefs(r,5))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.CELL_CUBE_REF.exec(e))&&(s=this.createCellRangeRefs(r,7))?this.createReferenceToken(r[0],s,this.createSheetRangeRefs(r,1)):(r=t.COLS_REF.exec(e))&&(s=this.createColRangeRefs(r,1,3))?this.createReferenceToken(r[0],s):(r=t.COLS_3D_REF.exec(e))&&(s=this.createColRangeRefs(r,5,7))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.COLS_CUBE_REF.exec(e))&&(s=this.createColRangeRefs(r,7,9))?this.createReferenceToken(r[0],s,this.createSheetRangeRefs(r,1)):(r=t.COL_REF.exec(e))&&(s=this.createColRangeRefs(r,1))?this.createReferenceToken(r[0],s):(r=t.COL_3D_REF.exec(e))&&(s=this.createColRangeRefs(r,5))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.COL_CUBE_REF.exec(e))&&(s=this.createColRangeRefs(r,7))?this.createReferenceToken(r[0],s,this.createSheetRangeRefs(r,1)):(r=t.ROWS_REF.exec(e))&&(s=this.createRowRangeRefs(r,1,3))?this.createReferenceToken(r[0],s):(r=t.ROWS_3D_REF.exec(e))&&(s=this.createRowRangeRefs(r,5,7))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.ROWS_CUBE_REF.exec(e))&&(s=this.createRowRangeRefs(r,7,9))?this.createReferenceToken(r[0],s,this.createSheetRangeRefs(r,1)):(r=t.ROW_REF.exec(e))&&(s=this.createRowRangeRefs(r,1))?this.createReferenceToken(r[0],s):(r=t.ROW_3D_REF.exec(e))&&(s=this.createRowRangeRefs(r,5))?this.createReferenceToken(r[0],s,this.createSheetRefs(r,1)):(r=t.ROW_CUBE_REF.exec(e))&&(s=this.createRowRangeRefs(r,7))?this.createReferenceToken(r[0],s,this.createSheetRangeRefs(r,1)):(r=t.ERROR_3D_REF.exec(e))?this.createReferenceToken(r[0],void 0,this.createSheetRefs(r,1)):(r=t.ERROR_CUBE_REF.exec(e))?this.createReferenceToken(r[0],void 0,this.createSheetRangeRefs(r,1)):void 0},U.prototype.parseNextNameToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.FUNCTION_REF.exec(e))?this.createFunctionToken(r[0],r[1]):(r=t.NAME_REF.exec(e))?this.createNameOrTableToken(r[0],r[1]):void 0};var D=B.extend(function(e){B.call(this,e)});D.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.CELL_REF.exec(e))?this.createReferenceToken(r[0],this.createCellRangeRefs(r,1)):(r=t.CELL_3D_REF.exec(e))?this.createReferenceToken(r[0],this.createCellRangeRefs(r,5),this.createSheetRefs(r,1)):(r=t.RANGE_REF.exec(e))?this.createReferenceToken(r[0],this.createCellRangeRefs(r,1,5)):(r=t.RANGE_3D_REF.exec(e))?this.createReferenceToken(r[0],this.createCellRangeRefs(r,5,9),this.createSheetRefs(r,1)):(r=t.RANGE_CUBE_REF.exec(e))?this.createReferenceToken(r[0],this.createCellRangeRefs(r,5,13),this.createSheetRefs(r,1,9)):void 0},D.prototype.parseNextNameToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.FUNCTION_REF.exec(e))?this.createFunctionToken(r[0],r[1]):(r=t.NAME_REF.exec(e))?this.createNameOrTableToken(r[0],r[1]):void 0},e.createFormulaParser=function(e){switch(e.REF_SYNTAX){case g.OOX:return new y(e);case g.ODF_UI:return new U(e);case g.OF:return new D(e)}throw k.error('createFormulaParser - invalid reference syntax: "'+e.REF_SYNTAX+'"'),new TypeError('invalid enumeration value "'+e.REF_SYNTAX+'"')}});