define("io.ox/office/spreadsheet/model/formula/parser/rangelistparser",["exports","io.ox/office/tk/types","io.ox/office/tk/utils/class","io.ox/office/tk/object/dobject","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/range","io.ox/office/spreadsheet/utils/rangearray","io.ox/office/spreadsheet/model/formula/formulautils"],function(e,t,r,s,n,i,a,o){"use strict";var c=t.toString,R=t.toNumber,g=t.toBoolean,l=s.DObject,h=n.stringifyCol,u=n.stringifyRow,f=i.Range,p=a.RangeArray,d=o.SheetRef,m=o.RefSyntaxType,_=o.formulaLogger,x=r.extend(l,function(e){l.call(this),this.grammar=e,this.refGrammar=e.refGrammar,this.addrConfig=this.refGrammar.addrConfig,this.RE=this.refGrammar.RE});x.prototype._initDocAccess=function(e){this.docAccess=e,this.addressFactory=e.addressFactory,this.MAXCOL=this.addressFactory.maxCol,this.MAXROW=this.addressFactory.maxRow},x.prototype._parseSeparator=function(e){var t=this.RE,r=null;return(r=t.RL_SEP_WS.exec(e))?{sep:" ",text:r[0]}:this.extSep&&(r=t.RL_SEP_OTHER.exec(e))?{sep:r[0],text:r[0]}:null},x.prototype.getAddress=function(e,t){return this.addrConfig.getAddress(e,t,this.MAXCOL,this.MAXROW)},x.prototype.getRange=function(e,t,r){var s=this.getAddress(e,t),n="number"==typeof r?this.getAddress(e,r):s;return s&&n?f.createFromAddresses(s,n):null},x.prototype.getColRange=function(e,t,r){var s=this.addrConfig.getCol(e,t,this.MAXCOL),n="number"==typeof r?this.addrConfig.getCol(e,r,this.MAXCOL):s;return 0<=s&&0<=n?f.create(s,0,n,this.MAXROW):null},x.prototype.getRowRange=function(e,t,r){var s=this.addrConfig.getRow(e,t,this.MAXROW),n="number"==typeof r?this.addrConfig.getRow(e,r,this.MAXROW):s;return 0<=s&&0<=n?f.create(0,s,this.MAXCOL,n):null},x.prototype.createRangeDesc=function(e,t,r){if(!t)return null;if(e){if(e.r1.sheet!==this.refSheet)return null;if(e.r2&&e.r2.sheet!==this.refSheet)return null}return{range:t,text:r}},x.prototype.implParseRange=function(){return _.error("RangeListParserBase.implParseRange - missing implementation"),null},x.prototype.implFormatRange=function(){return _.error("RangeListParserBase.implFormatRange - missing implementation"),null},x.prototype.parse=_.profileMethod("RangeListParser.parse",function(e,t,r){_.log(function(){return'formula="'+t+'"'}),this._initDocAccess(e),this.refSheet=R(r&&r.refSheet,-1),this.extSep=g(r&&r.extSep),this.skipSheets=g(r&&r.skipSheets);for(var s="start",n=new p,i=null;"end"!==s;)switch(s){case"start":s="range";break;case"range":var a=this.implParseRange(t);if(!a)return;n.push(a.range),t=t.substr(a.text.length),s="sep";break;case"sep":if(0===t.length){s="end";break}var o=this._parseSeparator(t);if(!o||null!==i&&i!==o.sep)return;i=o.sep,t=t.substr(o.text.length),s="range"}return n}),x.prototype.format=_.profileMethod("RangeListParser.format",function(e,t,r){this._initDocAccess(e);var s=c(r&&r.sep," "),n=r&&r.sheetName;return p.map(t,function(e){return this.implFormatRange(e,n)},this).join(s)});var L=x.extend(function(e){x.call(this,e)});L.prototype.implParseRange=function(e){var t=this.RE,r=null;if(this.skipSheets){if(r=t.RL_RANGE_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3,5),r[0]);if(r=t.RL_CELL_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3),r[0]);if(r=t.RL_COLS_3D_REF.exec(e))return this.createRangeDesc(null,this.getColRange(r,3,4),r[0]);if(r=t.RL_COL_3D_REF.exec(e))return this.createRangeDesc(null,this.getColRange(r,3),r[0]);if(r=t.RL_ROWS_3D_REF.exec(e))return this.createRangeDesc(null,this.getRowRange(r,3,4),r[0]);if(r=t.RL_ROW_3D_REF.exec(e))return this.createRangeDesc(null,this.getRowRange(r,3),r[0])}return(r=t.RL_RANGE_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1,3),r[0]):(r=t.RL_CELL_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1),r[0]):(r=t.RL_COLS_REF.exec(e))?this.createRangeDesc(null,this.getColRange(r,1,2),r[0]):(r=t.RL_COL_REF.exec(e))?this.createRangeDesc(null,this.getColRange(r,1),r[0]):(r=t.RL_ROWS_REF.exec(e))?this.createRangeDesc(null,this.getRowRange(r,1,2),r[0]):(r=t.RL_ROW_REF.exec(e))?this.createRangeDesc(null,this.getRowRange(r,1),r[0]):void 0},L.prototype.implFormatRange=function(e,t){var r=null,s=null;e.single()?r=e.start.toString():s=this.addressFactory.isRowRange(e)?(r=u(e.start[1]),u(e.end[1])):this.addressFactory.isColRange(e)?(r=h(e.start[0]),h(e.end[0])):(r=e.start.toString(),e.end.toString());var n=t?new d(t,!1):void 0;return this.grammar.formatGenericRange(this.docAccess,r,s,n)};var E=x.extend(function(e){x.call(this,e)});E.prototype.implParseRange=function(e){var t=this.RE,r=null;if(this.skipSheets){if(r=t.RL_RANGE_CUBE_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3,7),r[0]);if(r=t.RL_RANGE_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3,5),r[0]);if(r=t.RL_CELL_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3),r[0])}return(r=t.RL_RANGE_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1,3),r[0]):(r=t.RL_CELL_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1),r[0]):void 0},E.prototype.implFormatRange=function(e,t){var r=e.start.toString(),s=e.single()?null:e.end.toString(),n=t?new d(t,!1):void 0,i=t&&s?n:void 0;return this.grammar.formatGenericRange(this.docAccess,r,s,{r1:n,r2:i})},e.createRangeListParser=function(e){switch(e.REF_SYNTAX){case m.OOX:case m.ODF_UI:return new L(e);case m.OF:return new E(e)}throw _.error('createRangeListParser - invalid reference syntax: "'+e.REF_SYNTAX+'"'),new TypeError('invalid enumeration value "'+e.REF_SYNTAX+'"')}});