define("io.ox/office/spreadsheet/model/model",["exports","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/locale/locale","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/model/viewattributesmixin","io.ox/office/textframework/utils/dom","io.ox/office/textframework/model/editor","io.ox/office/textframework/model/listhandlermixin","io.ox/office/textframework/model/updatelistsmixin","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/addressfactory","io.ox/office/spreadsheet/model/operationcontext","io.ox/office/spreadsheet/model/operationgenerator","io.ox/office/spreadsheet/model/numberformatter","io.ox/office/spreadsheet/model/namecollection","io.ox/office/spreadsheet/model/sortlistcollection","io.ox/office/spreadsheet/model/sheetmodel","io.ox/office/spreadsheet/model/modelattributesmixin","io.ox/office/spreadsheet/model/modelsnapshot","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/updatetask","io.ox/office/spreadsheet/model/formula/parser/formularesource","io.ox/office/spreadsheet/model/formula/parser/formulagrammar","io.ox/office/spreadsheet/model/formula/interpret/formulacompiler","io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter","io.ox/office/spreadsheet/model/formula/deps/dependencymanager"],function(e,O,t,n,r,i,o,y,T,A,I,R,a,M,x,s,l,h,N,c,b,w,D,u,d,p,g,f,m,F,L){"use strict";var H=t.isNumber,G=t.isString,U=t.isBoolean,V=t.toNumber,k=t.toBoolean,P=t.getDict,B=t.newDict,K=t.newFulfilled,W=n.clamp,E=n.createDict,j=n.fastChain,X=r.arrayForEachReverse,Y=r.arraySome,z=r.TArray,q=r.TSet,J=r.UidSet,Q=r.TMap,Z=i.LOCALE_DATA,ee=o.transformIndexInsert,te=o.transformIndexDelete,ne=o.transformIndexSort,re=a.MAX_SHEET_COUNT,ie=a.getDebugFlag,oe=a.setDebugFlag,ae=x.SheetType,se=x.Range3DArray,le=x.modelLogger,he=x.mapKey,ce=x.inverseSortVector,ue=s.AddressFactory,de=l.SheetOperationContext,pe=h.resolveOperations,ge=h.SheetOperationGenerator,fe=c.NameCollection,me=u.DocumentSnapshot,Ee=d.GrammarType,Se=p.DeleteSheetUpdateTask,ve=p.RenameSheetUpdateTask,Ce=g.FormulaResourceFactory,Oe=f.FormulaGrammar,ye=m.FormulaCompiler,Te={activeSheet:{def:-1,validate:function(e){return-1<=e&&e<this.getSheetCount()?e:void 0}},rcStyle:{def:!1}},Ae=e.SHEET_TO_DOCUMENT_INJECT_EVENTS=["move:columns","change:columns","move:rows","change:rows","change:cells","move:cells","merge:cells"],Ie=e.SHEET_TO_DOCUMENT_MAPPED_EVENTS={"change:attributes":"change:sheet:attributes","change:viewattributes":"change:sheet:viewattributes"},_e=e.SHEET_TO_DOCUMENT_INSERT_EVENTS=["change:attributes","change:viewattributes","insert:name","delete:name","change:name","insert:table","delete:table","change:table","insert:cfrule","delete:cfrule","change:cfrule","insert:drawing","delete:drawing","change:drawing","change:drawing:text","move:drawing","insert:note","delete:note","change:note","change:note:text","move:note","change:usedarea","refresh:ranges"],Re=E([M.SET_ATTRIBUTES,M.DELETE,M.MOVE,M.TEXT_INSERT,M.TAB_INSERT,M.HARDBREAK_INSERT,M.PARA_INSERT,M.PARA_SPLIT,M.PARA_MERGE,M.INSERT_LIST,M.DELETE_LIST],!0),Me=/^'|[\x00-\x1f\x80-\x9f[\]*?:/\\]|'$/,xe=/^'|[\x00-\x1f\x80-\x9f[\]*?:/\\]/;function Ne(e){var t={model:e,name:e.getName(),sheet:e.sheetModel.getIndex(),range:e.getRange(),header:e.hasHeaderRow(),footer:e.hasFooterRow()};return Object.defineProperty(t,"columns",{get:function(){return this.model.getColumnKeys()},enumerable:!0}),t}var S=e.SpreadsheetModel=A.extend({constructor:le.profileMethod("$badge{SpreadsheetModel} constructor",function(o,t){A.call(this,o,{contextClass:de,defaultStyleFamily:"cell",slideMode:!0,disableRedoWithOT:!0}),y.call(this,Te),I.call(this,o),R.call(this,o);var u=this,p=new z,d=new Q,g=new q(function(e){return e.getKey()}),r=[],e=null,f=null;function a(e){return 0<=(e=H(e)?e:G(e)?u.getSheetIndex(e):-1)&&e<p.length?p[e]:null}function m(e,t){if(0===e.length)return"sheet:name:empty";if((t&&t.importing&&o.isOOXML()?xe:Me).test(e))return"sheet:name:invalid";var n=u.getSheetModel(e),r=t&&t.skipSheet,i=H(r)?u.getSheetModel(r):null;return n&&n!==i?"sheet:name:used":null}function s(e,t,n){e.importing&&(n=_.extend({importing:!0},n)),e.ensure(null===m(t,n),"invalid sheet name")}function l(t,e,n,r){if(!u.canInsertSheet())return null;u.trigger("insert:sheet:before",t);var i=u.getActiveSheet(),o=ee(i,t,1),a=i!==o;a&&u.setActiveSheet(-1);var s=new w(u,e,r),l=s.uid,h=s.drawingCollection.getContainerNode();p.insertAt(t,{model:s,uid:l,name:n,node:h}),f.insertBefore(h,f.childNodes.item(t)),t===p.length?d.insert(l,t):d.clear(),a&&u.setActiveSheet(o),u.trigger("insert:sheet:after",t,s);var c=_.times(p.length-1,function(e){return e<t?e:e+1});return u.trigger("transform:sheets",c),Ae.forEach(function(e){u.forwardEvent(s,e,{transformFn:function(e){e.sheetModel=s,e.sheet=s.getIndex()}})}),_e.concat(Object.keys(Ie)).forEach(function(e){u.forwardEvent(s,e,{triggerType:Ie[e],transformFn:function(){return[s.getIndex()].concat(_.toArray(arguments))}})}),s}function h(t,e){u.trigger("move:sheets:before",e);var n=u.getActiveSheet(),r=ne(n,e),i=n!==r;i&&u.setActiveSheet(-1),p.permute(e);try{p.forEach(function(e,t){var n=f.childNodes.item(t);e.node!==n&&f.insertBefore(e.node,n)})}catch(e){le.exception(e),t.error("failed to reorder drawing page nodes")}d.clear(),i&&u.setActiveSheet(r),u.trigger("move:sheets:after",e),u.trigger("transform:sheets",e)}var i=this.createDebouncedMethod("SpreadsheetModel.sendActiveSelectionDebounced",null,function(){var e=u.getSelectionState();e&&o.updateUserData({sheet:e.sheet,ranges:e.selection.ranges.toOpStr(),drawings:e.selection.drawings})},{delay:250});function n(e,t,n){u.registerContextOperationHandler(e,function(e){t[n](e)})}function c(e,i,t){var o=t&&t.allowDoc;return u.registerContextOperationHandler(e,function(e){var t=o&&!e.has("sheet"),n=t?null:e.getInt("sheet"),r=t?u:u.getSheetModel(n);return e.ensure(r,"missing sheet"),i.call(u,e,r,n)})}function E(e,n,r,t){c(e,function(e,t){t[n][r](e)},t)}function S(e,r){return u.registerContextOperationHandler(e,function(e){var t=e.getPos("start");e.ensure(2<=t.length,"invalid drawing start position");var n=u.getSheetModel(t[0]);return e.ensure(n,"invalid sheet index"),r.call(u,e,n.drawingCollection,t.slice(1))})}function v(e,r){S(e,function(e,t,n){t[r](e,n)})}function C(e,i,t){var o=t&&t.type;S(e,function(e,t,n){var r=t.getModelDescriptor(n);e.ensure(r,"invalid drawing position"),e.ensure(!o||o===r.model.getType(),"invalid drawing type"),e.ensure(0===r.remaining.length,"invalid drawing start position"),r.model[i](e)})}this.postProcessImport=function(){return p.empty()?$.Deferred().reject():(this.cellStyles.createMissingStyles(),this.iterateArraySliced(p,function(e){return e.model.postProcessImport()},"SpreadsheetModel.postProcessImport"))},this._registerTableModel=function(e){e.isAutoFilter()||g.insert(e)},this._unregisterTableModel=function(e){e.isAutoFilter()||g.remove(e)},this.getSelectionState=function(){var e=this.getActiveSheet(),t=this.getSheetModel(e);return t&&{sheet:e,selection:t.getViewAttribute("selection").clone()}},this.setSelectionState=function(e){var t=this.getSheetModel(e.sheet);t?(this.setActiveSheet(e.sheet),t.setViewAttribute("selection",e.selection)):le.warn("$badge{SpreadsheetModel} setSelectionState: invalid sheet index: "+e.sheet)},this.createReloadSettings=function(){return{recalcFormulas:this.dependencyManager.needsCalcOnLoad(),docViewAttributes:this.getViewAttributes(),sheetViewAttributes:p.map(function(e){return e.model.getChangedViewAttributes()})}},this.getFormulaGrammar=function(e){return e===Ee.UI?this.formulaGrammarUI:Oe.get(t,e)},this.getFormulaGrammarUI=function(e){return U(e)||(e=this.getViewAttribute("rcStyle")),Oe.get(t,e?Ee.UI_RC:Ee.UI_A1)},this.parseRangeList=function(e,t,n){return this.getFormulaGrammar(e).parseRangeList(this,t,n)},this.formatRangeList=function(e,t,n){return this.getFormulaGrammar(e).formatRangeList(this,t,n)},this.getMaxCol=function(){return this.addressFactory.maxCol},this.getMaxRow=function(){return this.addressFactory.maxRow},this.getMaxIndex=function(e){return this.addressFactory.getMaxIndex(e)},this.getSheetRange=function(){return this.addressFactory.getSheetRange()},this.isColRange=function(e){return this.addressFactory.isColRange(e)},this.makeColRange=function(e){return this.addressFactory.getColRange(e)},this.makeColRanges=function(e){return this.addressFactory.getColRangeList(e)},this.isRowRange=function(e){return this.addressFactory.isRowRange(e)},this.makeRowRange=function(e){return this.addressFactory.getRowRange(e)},this.makeRowRanges=function(e){return this.addressFactory.getRowRangeList(e)},this.isFullRange=function(e,t){return this.addressFactory.isFullRange(e,t)},this.makeFullRange=function(e,t){return this.addressFactory.getFullRange(e,t)},this.makeFullRanges=function(e,t){return this.addressFactory.getFullRangeList(e,t)},this.isValidAddress=function(e){return this.addressFactory.isValidAddress(e)},this.getMaxSheetNameLength=function(){return o.isOOXML()?31:65535},this.hasSheet=function(e){return null!==a(e)},this.getSheetName=function(e){var t=a(e);return t?t.name:null},this.getSheetIndex=function(e){var t=he(e);return p.findIndex(function(e){return he(e.name)===t})},this.getSheetIndexOfModel=function(e){var t=G(e)?e:e.uid;return d.getOrCreate(t,function(){return p.findIndex(function(e){return e.uid===t})})},this.getSheetModel=function(e){var t=a(e);return t?t.model:void 0},this.getSheetCount=function(e){return e?this.createSheetIterator(e).count():p.length},this.createSheetIterator=function(e){var t=O.getIntegerOption(e,"first",0),n=O.getIntegerOption(e,"last",p.length-1),r=e&&e.reverse,i=r?n:t,o=r?t-1:n+1,a=p.entryIterator({begin:i,end:o,reverse:r}),s=e&&e.supported,l=U(s)?function(e){return s===e.isSupportedType()}:_.constant(!0),h=e&&e.cells,c=U(h)?function(e){return h===e.isCellType()}:_.constant(!0),u=e&&e.visible,d=U(u)?function(e){return u===e.isVisible()}:_.constant(!0);return a.mapIterator(function(e){var t=e.value.model;return l(t)&&c(t)&&d(t)?t:void 0})},this.findVisibleSheet=function(e,t){var n=function(){switch(t){case"next":return{first:e,supported:!0,visible:!0};case"prev":return{last:e,reverse:!0,supported:!0,visible:!0}}return null}();if(n){var r=this.createSheetIterator(n).next();return r.done?-1:r.value.getIndex()}var i=this.findVisibleSheet(e,"next");return i<0?this.findVisibleSheet(e,"prev"):i},this.getActiveSheet=function(){return this.getViewAttribute("activeSheet")},this.setActiveSheet=function(e){le.takeTime("$badge{SpreadsheetModel} activating sheet "+e,function(){u.setViewAttribute("activeSheet",e)})},this.canInsertSheet=function(){return re<1||p.length<re},this.generateUnusedSheetName=function(){for(var e="",t=p.length;0===e.length||this.hasSheet(e);)e=x.generateSheetName(t),t+=1;return e},this.hasUnsavedComments=function(){return p.some(function(e){return e.model.hasUnsavedComment()})},this.discardUnsavedComments=function(){p.forEach(function(e){e.model.discardUnsavedComment()})},this.hasName=function(e,t){return!!this.getNameModel(e,t)},this.getNameModel=function(e,t){return(null===e?this:this.getSheetModel(e)).nameCollection.getNameModel(t)},this.resolveName=function(e,t){var n=this.getNameModel(e,t);return n?{model:n,sheet:e,label:n.getLabel()}:void 0},this.resolveNameModel=function(e,t){var n=e.resolveName(t);return n?n.model:void 0},this.createNameIterator=function(t){var e=this.nameCollection.createModelIterator(t),n=this.createSheetIterator({supported:!0}).nestedIterator(function(e){return e.nameCollection.createModelIterator(t)});return e.chainIterator(n)},this.hasTable=function(e){return g.hasKey(he(e))},this.getTableModel=function(e){return g.get(he(e))},this.resolveTable=function(e){return g.with(he(e),Ne)},this.resolveTableAt=function(e,t){var n=this.getSheetModel(e).tableCollection.getTableModelAt(t);return n?Ne(n):void 0},this.resolveTableModel=function(e){var t=e.resolveTable();return t?t.model:void 0},this.createTableIterator=function(){return g.valueIterator()},this.getRangeContents=function(e,i){var o=O.getIntegerOption(i,"maxCount",null,1),a=[],s=0;return e=se.filter(e,function(e){return!(!this.hasSheet(e.sheet1)||!e.singleSheet())||(le.warn("$badge{SpreadsheetModel} getRangeContents: invalid sheet index in range address"),!1)},this),i=_.clone(i),Y(e,function(e){var t=this.getSheetModel(e.sheet1).cellCollection,n=e.toRange(),r=t.getRangeContents(n,i);if(a=a.concat(r),s+=r.count,o===s)return!0;o&&(i.maxCount-=r.count)},this),a.count=s,a},this.sendOperations=_.wrap(this.sendOperations,function(e,t,n){return n&&n.defer?(r=r.concat(pe(t,n)),!0):e.call(this,t,n)}),this.createAndApplyOperations=_.wrap(this.createAndApplyOperations,function(e,t,n){return 0<r.length&&(this.sendOperations(r),r=[]),e.call(this,t,n)}),this.createSheetOperationGenerator=function(e){return new ge(this,e)},this.createAndApplySheetOperations=le.profileMethod("$badge{SpreadsheetModel} createAndApplySheetOperations",function(t,e){e=_.extend({applyImmediately:!0,preventSelectionChange:!0},e,{generatorClass:ge}),o.isOTEnabled()&&(e.afterApplyHandler=function(e){e.setUserData(me.fromModel(this),{undo:!0})}),this.setBlockKeyboardEvent(!0);var n=this.createAndApplyOperations(function(e){return o.isOTEnabled()&&e.setUserData(me.fromModel(this)),t.call(this,e)},e);return this.finally(n,function(){this.setBlockKeyboardEvent(!1)}),n}),this.generateOperationsForAllSheets=function(n,r,e){var t=n.getSheetIndex(),i=e&&e.skipSheet;return this.iterateSliced(this.createSheetIterator(e),function(e){var t=e.getIndex();if(t!==i)return n.setSheetIndex(t),r.call(u,e,t)},"SpreadsheetModel.generateOperationsForAllSheets").always(function(){n.setSheetIndex(t)})},this.generateUpdateFormulaOperations=le.profileMethod("$badge{SpreadsheetModel} generateUpdateFormulaOperations",function(t,n,e){var r=e&&e.moveCellsMode;return j("after"!==r&&function(){return u.nameCollection.generateUpdateFormulaOperations(t,n,e)},function(){return u.generateOperationsForAllSheets(t,function(e){return e.generateUpdateFormulaOperations(t,n,r)},e)})}),this.generateInsertSheetOperations=function(e,t,n,r,i){var o=m(r);if(o)return x.makeRejected(o);var a={sheetName:r};return n!==ae.WORKSHEET&&(a.type=n),_.isObject(i)&&(a.attrs=i),e.setSheetIndex(t),e.generateSheetOperation(M.DELETE_SHEET,null,{undo:!0}),e.generateSheetOperation(M.INSERT_SHEET,a),K()},this.generateDeleteSheetOperations=function(e,t){var n=new Se(t),r=this.generateUpdateFormulaOperations(e,n,{skipSheet:t});return(r=r.then(function(){return e.setSheetIndex(t),u.getSheetModel(t).generateRestoreOperations(e)})).done(function(){e.setSheetIndex(t),e.generateSheetOperation(M.DELETE_SHEET)})},this.generateMoveSheetOperations=function(e,t,n){return e.generateOperation(M.MOVE_SHEET,{sheet:n,to:t},{undo:!0,prepend:!0}),e.generateOperation(M.MOVE_SHEET,{sheet:t,to:n}),K()},this.generateMoveSheetsOperations=function(e,t){return e.generateOperation(M.MOVE_SHEETS,{sheets:ce(t)},{undo:!0}),e.generateOperation(M.MOVE_SHEETS,{sheets:t}),K()},this.generateCopySheetOperations=function(t,e,n,r){var i=m(r);if(i)return x.makeRejected(i);var a=B();g.forEach(function(e){a[e.getKey()]=!0});var o=this.getSheetModel(e),s=B();o.tableCollection.createModelIterator().forEach(function(e){for(var t=e.getName(),n=/^(.*?)(\d+)$/.exec(t),r=n?n[1]:x.getTableName(),i=n?parseInt(n[2],10)+1:1;he(r+i)in a;)i+=1;var o=r+i;a[he(o)]=!0,s[t]=o});var l={to:n,sheetName:r};_.isEmpty(s)||(l.tableNames=s),t.setSheetIndex(e).generateSheetOperation(M.COPY_SHEET,l);var h=this.getSheetModel(n),c=new ve(e,r,s);t.setSheetIndex(n);var u=o.drawingCollection.createModelIterator({deep:!0,reverse:!0}),d=this.iterateSliced(u,function(e){"chart"!==e.getType()||e.isRestorable()||t.generateDrawingOperation(M.DELETE_DRAWING,e.getPosition())},"SpreadsheetModel.generateCopySheetOperations");return(d=d.then(function(){return h.generateUpdateFormulaOperations(t,c)})).done(function(){t.clearOperations({undo:!0}),t.generateSheetOperation(M.DELETE_SHEET,null,{undo:!0})})},this.generateRenameSheetOperations=function(e,t,n){var r=this.getSheetName(t);if(r===n)return K();var i=m(n,{skipSheet:t});if(i)return x.makeRejected(i);e.setSheetIndex(t),e.generateSheetOperation(M.CHANGE_SHEET,{sheetName:r},{undo:!0}),e.generateSheetOperation(M.CHANGE_SHEET,{sheetName:n});var o=new ve(t,n);return this.generateUpdateFormulaOperations(e,o)},this.generateChangedViewAttributeOperations=function(n){var e=this.getActiveSheet();e!==this.getDocumentAttribute("activeSheet")&&n.generateDocAttrsOperation({activeSheet:e}),this.createSheetIterator().forEach(function(e){var t=e.getChangedViewAttributes();_.isEmpty(t)||(n.setSheetIndex(e.getIndex()),e.generateChangeSheetOperations(n,{sheet:t}))})},this.addressFactory=new ue(1,1),this.numberFormatter=new N(this),this.formulaResource=t.getResource(Ee.UI),this.formulaGrammarOP=this.getFormulaGrammar(Ee.OP),this.formulaGrammarUI=this.getFormulaGrammarUI(),this.formulaCompiler=new ye(this),this.formulaInterpreter=new F(this),this.nameCollection=new fe(this),this.sortListCollection=new b(this),this.dependencyManager=new L(this),D.call(this),e=this.getNode()[0],(f=T.getPageContentNode(e)[0]).innerHTML="",o.isOOXML()&&(n(M.INSERT_NUMBER_FORMAT,this.numberFormatter,"applyInsertOperation"),n(M.DELETE_NUMBER_FORMAT,this.numberFormatter,"applyDeleteOperation")),this.registerContextOperationHandler(M.INSERT_SHEET,function(e){var t=e.getInt("sheet"),n=e.getStr("sheetName"),r=e.optEnum("type",ae,ae.WORKSHEET),i=e.optDict("attrs");ie("spreadsheet:failing-import")&&(oe("spreadsheet:failing-import",!1),e.error("debug mode: insert sheet fails")),e.ensure(0<=t&&t<=p.length,"invalid sheet index"),s(e,n);var o=l(t,r,n,i);e.ensure(o,"cannot create sheet")}),this.registerContextOperationHandler(M.MOVE_SHEETS,function(e){var t=e.getPos("sheets"),n=p.length;e.ensure(t.length===n,"invalid length of transformation vector");var r=_.unique(_.sortBy(t),!0);e.ensure(r.length===n,"duplicate sheet indexes in transformation vector"),e.ensure(0===r[0]&&_.last(r)===n-1,"invalid sheet indexes in transformation vector"),h(e,t)}),c(M.DELETE_SHEET,function(e,t,n){e.ensure(1<p.length,"cannot delete last sheet"),u.trigger("delete:sheet:before",n,t);var r=u.getActiveSheet(),i=te(r,n,1),o=r!==i;o&&u.setActiveSheet(-1),n+1===p.length?d.remove(t.uid):d.clear(),f.removeChild(p[n].node),p.deleteAt(n),t.destroy(),o&&(H(i)||(i=Math.min(n,p.length-1)),u.setActiveSheet(u.findVisibleSheet(i))),u.trigger("delete:sheet:after",n);var a=_.times(p.length+1,function(e){return e<n?e:e===n?null:e-1});u.trigger("transform:sheets",a)}),c(M.CHANGE_SHEET,function(e,t,n){var r=a(n),i=e.optStr("sheetName");i&&(s(e,i,{skipSheet:n}),r.name!==i&&(u.trigger("rename:sheet:before",n,i,t),r.name=i,u.trigger("rename:sheet",n,i,t)));var o=e.optDict("attrs");o&&t.setAttributes(o)}),c(M.MOVE_SHEET,function(e,t,n){var r=e.getInt("to");if(e.ensure(0<=r&&r<p.length,"invalid target index"),n!==r){var i=_.range(0,p.length);i.splice(n,1),i.splice(r,0,n),h(e,i)}}),c(M.COPY_SHEET,function(e,t){var n=e.getInt("to");e.ensure(0<=n&&n<=p.length,"invalid target index");var r=e.getStr("sheetName");s(e,r);var i=l(n,t.getType(),r);e.ensure(i,"cannot create sheet"),i.applyCopySheetOperation(e,t)}),E(M.CHANGE_CELLS,"cellCollection","applyChangeCellsOperation"),E(M.INSERT_CELLS,"cellCollection","applyInsertCellsOperation"),E(M.DELETE_CELLS,"cellCollection","applyDeleteCellsOperation"),E(M.INSERT_HYPERLINK,"hyperlinkCollection","applyInsertHyperlinkOperation"),E(M.DELETE_HYPERLINK,"hyperlinkCollection","applyDeleteHyperlinkOperation"),E(M.MERGE_CELLS,"mergeCollection","applyMergeCellsOperation"),E(M.INSERT_COLUMNS,"colCollection","applyInsertOperation"),E(M.DELETE_COLUMNS,"colCollection","applyDeleteOperation"),E(M.CHANGE_COLUMNS,"colCollection","applyChangeOperation"),E(M.INSERT_ROWS,"rowCollection","applyInsertOperation"),E(M.DELETE_ROWS,"rowCollection","applyDeleteOperation"),E(M.CHANGE_ROWS,"rowCollection","applyChangeOperation"),E(M.INSERT_NAME,"nameCollection","applyInsertOperation",{allowDoc:!0}),E(M.DELETE_NAME,"nameCollection","applyDeleteOperation",{allowDoc:!0}),E(M.CHANGE_NAME,"nameCollection","applyChangeOperation",{allowDoc:!0}),E(M.INSERT_TABLE,"tableCollection","applyInsertOperation"),E(M.DELETE_TABLE,"tableCollection","applyDeleteOperation"),E(M.CHANGE_TABLE,"tableCollection","applyChangeOperation"),E(M.CHANGE_TABLE_COLUMN,"tableCollection","applyChangeColumnOperation"),E(M.INSERT_DVRULE,"validationCollection","applyInsertOperation"),E(M.DELETE_DVRULE,"validationCollection","applyDeleteOperation"),E(M.CHANGE_DVRULE,"validationCollection","applyChangeOperation"),E(M.INSERT_CFRULE,"condFormatCollection","applyInsertOperation"),E(M.DELETE_CFRULE,"condFormatCollection","applyDeleteOperation"),E(M.CHANGE_CFRULE,"condFormatCollection","applyChangeOperation"),E(M.INSERT_NOTE,"noteCollection","applyInsertNoteOperation"),E(M.DELETE_NOTE,"noteCollection","applyDeleteNoteOperation"),E(M.CHANGE_NOTE,"noteCollection","applyChangeNoteOperation"),E(M.MOVE_NOTES,"noteCollection","applyMoveNotesOperation"),E(M.INSERT_COMMENT,"commentCollection","applyInsertCommentOperation"),E(M.DELETE_COMMENT,"commentCollection","applyDeleteCommentOperation"),E(M.CHANGE_COMMENT,"commentCollection","applyChangeCommentOperation"),E(M.MOVE_COMMENTS,"commentCollection","applyMoveCommentsOperation"),v(M.INSERT_DRAWING,"applyInsertDrawingOperation"),v(M.DELETE_DRAWING,"applyDeleteDrawingOperation"),v(M.MOVE_DRAWING,"applyMoveDrawingOperation"),C(M.CHANGE_DRAWING,"applyChangeOperation"),C(M.INSERT_CHART_SERIES,"applyInsertSeriesOperation",{type:"chart"}),C(M.DELETE_CHART_SERIES,"applyDeleteSeriesOperation",{type:"chart"}),C(M.CHANGE_CHART_SERIES,"applyChangeSeriesOperation",{type:"chart"}),C(M.DELETE_CHART_AXIS,"applyDeleteAxisOperation",{type:"chart"}),C(M.CHANGE_CHART_AXIS,"applyChangeAxisOperation",{type:"chart"}),C(M.CHANGE_CHART_GRID,"applyChangeGridOperation",{type:"chart"}),C(M.CHANGE_CHART_TITLE,"applyChangeTitleOperation",{type:"chart"}),C(M.CHANGE_CHART_LEGEND,"applyChangeLegendOperation",{type:"chart"}),this.waitForImport(function(){if(!p.empty()){p.forEach(function(e){e.model.initializeViewAttributes()});var e=P(o.getLaunchOptions(),"docViewAttributes",!0),t=V(e.activeSheet,this.getDocumentAttribute("activeSheet")),n=this.findVisibleSheet(W(t,0,p.length-1));0<=n&&this.setActiveSheet(n),this.setViewAttribute("rcStyle",k(e.rcStyle,k(this.getDocumentAttribute("rcStyle"),!1)))}},this),this.forwardEvents(this.nameCollection,{transformFn:function(e){return[e,null].concat(_.rest(arguments))}}),this.addressFactory.updateSheetSize(this.getDocumentAttribute("cols"),this.getDocumentAttribute("rows")),this.on("change:attributes",function(e,t){this.addressFactory.updateSheetSize(t.cols,t.rows)}),this.on("change:sheet:attributes",function(e,t){var n=this.getActiveSheet();if(t===n&&!this.getSheetModel(t).isVisible()){var r=this.findVisibleSheet(n);0<=r&&this.setActiveSheet(r)}}),this.on("change:viewattributes",function(e,t){"activeSheet"in t&&i(),"rcStyle"in t&&(this.formulaGrammarUI=this.getFormulaGrammarUI(t.rcStyle),this.trigger("change:locale"))}),this.on("change:sheet:viewattributes",function(e,t,n){"selection"in n&&t===this.getActiveSheet()&&i()}),this.listenTo(Z.changeHook,function(){Ce.create(o.getFileFormat(),Z).then(function(e){t=e,u.formulaResource=t.getResource(Ee.UI),u.formulaGrammarOP=u.getFormulaGrammar(Ee.OP),u.formulaGrammarUI=u.getFormulaGrammarUI(),u.trigger("change:locale")})}),this.on("operations:success",function(e,t){if(t.some(function(e){return e.name in Re})){var i=p.pluck("model"),o=new J;X(t,function(e){if(e.name in Re){var t=e.start;if(!_.isArray(t)||t.length<3)return;var n=i[t[0]];if(!n)return;var r=n.drawingCollection.getModelDescriptor(t.slice(1));if(!r||0===r.remaining.length)return;o.insert(r.model)}else switch(e.name){case M.INSERT_SHEET:i.deleteAt(e.sheet);break;case M.DELETE_SHEET:i.insertAt(e.sheet,null);break;case M.MOVE_SHEET:i.insertAt(e.sheet,i.deleteAt(e.to));break;case M.MOVE_SHEETS:i.permute(ce(e.sheets));break;case M.COPY_SHEET:i.deleteAt(e.to)}}),o.forEach(function(e){e.getParentCollection().trigger("change:drawing:text",e)})}}),this.listenTo(e,"mousedown touchstart",function(){this.setActiveMouseDownEvent(!0)}),this.registerDestructor(function(){this.dependencyManager.disconnect(),p.forEach(function(e){e.model.destroy()}),this.nameCollection.destroy(),this.sortListCollection.destroy(),this.formulaInterpreter.destroy(),this.formulaCompiler.destroy(),this.dependencyManager.destroy(),this.numberFormatter.destroy(),g.clear(),o=u=t=p=d=g=null,e=f=null})})});S.create=le.profileMethod("$badge{SpreadsheetModel} create",function(t){return Ce.create(t.getFileFormat(),Z).then(function(e){return new S(t,e)})})});