define("io.ox/office/spreadsheet/model/tablecollection",["exports","io.ox/office/tk/utils","io.ox/office/tk/utils/class","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/baseframework/model/modelobject","io.ox/office/editframework/model/attributedmodel","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/utils/scalarset","io.ox/office/spreadsheet/model/cellvaluecache","io.ox/office/spreadsheet/model/celloperationbuilder"],function(e,p,t,n,r,o,f,v,b,m,a,i,s){"use strict";var C=n.isString,R=r.createDict,l=o.DSet,A=o.TMap,g=m.MergeMode,M=m.SortDirection,O=m.Interval,E=m.Address,T=m.Range,y=m.IntervalArray,w=m.RangeArray,S=m.mapKey,F=m.modelLogger,x=a.ScalarSet,D=i.CellValueCache,d=s.CellOperationBuilder,I=e.TableColumnModel=v.extend({constructor:function(e,t,n){v.call(this,e.getDocModel(),n,{families:"filter sort",autoClear:!0,trigger:"always"}),this.clone=function(e,t){return new I(e,t,this.getExplicitAttributeSet(!0))},this.isButtonVisible=function(){return!this.getMergedAttributeSet(!0).filter.hideButton},this.isFiltered=function(){return"none"!==this.getMergedAttributeSet(!0).filter.type},this.isSorted=function(){return"none"!==this.getMergedAttributeSet(!0).sort.type},this.isDescending=function(){return this.getMergedAttributeSet(!0).sort.descending},this.isRefreshable=function(){return this.isFiltered()||this.isSorted()},this.registerDestructor(function(){e=null})}}),B=e.TableModel=v.extend({constructor:function(l,u,c,e){var f=this,o=l.docModel,g=(this.sheetModel=l).cellCollection,s=new A,t=new I(l,this),r=new D(l,c),i=[];function a(e,r){var o={tableCol:e,columnModel:r},a=r.uid;s.insert(e,o),f.listenTo(r,"change:attributes",function(e,t,n){f.trigger("change:column",o.tableCol,t,n),r.isSorted()&&i.push(a),r.hasExplicitAttributes()||(r.destroy(),s.remove(o.tableCol),i=_.without(i,a))})}function d(e){var t=s.get(e);return t?t.columnModel:null}function h(r,o){s.forEach(function(e){if(e.columnModel.isSorted()&&!(o&&0<=o.indexOf(e.tableCol))){var t={sort:{type:"none",descending:!1}},n=e.columnModel.getUndoAttributeSet(t);r.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,{col:e.tableCol,attrs:n},{undo:!0}),r.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,{col:e.tableCol,attrs:t})}})}v.call(this,o,e,{styleFamily:"table",autoClear:!0}),this.clone=function(e,t){return new B(e,t,c,this.getExplicitAttributeSet(!0),s)},this.applyChangeOperation=function(e){var t=e.getInt("col");e.ensure(0<=t&&t<c.cols(),"invalid table column");var n,r,o=e.getDict("attrs");(r=d(n=t))||a(n,r=new I(l,f)),r.setAttributes(o)},this.getName=function(){return u},this.getKey=function(){return S(u)},this.isAutoFilter=function(){return 0===u.length},this.getRange=function(){return c.clone()},this.containsCell=function(e){return c.containsAddress(e)},this.overlapsRange=function(e){return c.overlaps(e)},this.hasHeaderRow=function(){return this.getMergedAttributeSet(!0).table.headerRow},this.hasFooterRow=function(){return this.getMergedAttributeSet(!0).table.footerRow},this.getStyleId=function(){return this.getMergedAttributeSet(!0).styleId||null},this.getStyleFlags=function(){var e=this.getMergedAttributeSet(!0).table;return{firstRow:e.headerRow,lastRow:e.footerRow,firstCol:e.firstCol,lastCol:e.lastCol,bandsHor:e.bandsHor,bandsVert:e.bandsVert}},this.areButtonsVisible=function(){var e=this.getMergedAttributeSet(!0).table;return e.headerRow&&!e.hideButtons},this.isFiltered=function(){return s.some(function(e){return e.columnModel.isFiltered()})},this.isSorted=function(){return s.some(function(e){return e.columnModel.isSorted()})},this.getSortRules=function(){var r=c.start[0],e=s.reduce([],function(e,t){var n=t.columnModel;return n.isSorted()&&e.push({order:i.indexOf(n.uid),index:r+t.tableCol,descending:n.isDescending()}),e});return _.sortBy(e,"order")},this.getHeaderRange=function(){return this.hasHeaderRow()?c.headerRow():null},this.getFooterRange=function(){return this.hasFooterRow()?c.footerRow():null},this.getDataRange=function(){var e=this.hasHeaderRow(),t=this.hasFooterRow(),n=c.clone();if(!t&&this.isAutoFilter()&&(n=g.findContentRange(n,{directions:"down"}),c.end[1]<n.end[1])){var r=T.create(c.start[0],c.end[1]+1,c.end[0],o.getMaxRow());l.tableCollection.createModelIterator({overlapRange:r}).forEach(function(e){n.end[1]=Math.min(n.end[1],e.getRange().start[1]-1)})}return e&&(n.start[1]+=1),t&&--n.end[1],n.start[1]<=n.end[1]?n:null},this.getVisibleDataRows=function(){var e=this.getDataRange();return e?l.rowCollection.getVisibleIntervals(e.rowInterval()).move(-e.start[1]):new y},this.canMoveCells=function(t){var e=c.intersect(t.dirtyRange);if(!e)return!0;var n=c.interval(!t.columns),r=e.interval(!t.columns);if(n.differs(r))return!1;if(t.insert||t.columns||this.isAutoFilter())return!0;if(t.transformRanges(c).empty())return!0;function o(e){return!e||!t.transformRanges(e).empty()}return o(this.getHeaderRange())&&o(this.getFooterRange())&&o(this.getDataRange())},this.canRestoreDeletedRanges=function(e){return this.isAutoFilter()||e.every(function(e){return!e.contains(c)})},this.setName=function(e){if(u!==e){var t=u;u=e,this.trigger("change:name",e,t)}},this.setRange=function(e){if(c.equals(e))return this;c=e.clone(),r.setRanges(this.getHeaderRange());var n=c.cols();return s.forEach(function(e,t){e.tableCol>=n&&(e.columnModel.destroy(),s.remove(t))}),this.trigger("change:range",c.clone()),this},this.transformRange=function(n){if(!n.bandContainsRange(c))return!0;if(!n.insert&&!n.columns){var e=this.getHeaderRange();if(e&&n.transformRanges(e).empty())return!1}var r=c.start[0],o=n.transformRanges(c).first();if(o){if(!c.equals(o)&&n.columns){var a=new A;s.forEach(function(e){var t=new E(r+e.tableCol,c.start[1]);(t=n.transformAddress(t))?(e.tableCol=t[0]-o.start[0],a.insert(e.tableCol,e)):e.columnModel.destroy()}),s=a}}else F.error("$badge{TableModel} transformRange: unexpected deleted table, range="+c)},this.getColumnKeys=function(){return r.getCustom("colKeys",function(e){return e.map(function(e){return C(e.value)?S(e.value):""})})},this.getColumnModel=function(e){return d(e)||t},this.getColumnDataRange=function(e){var t=this.getDataRange(),n=c.start[0]+e;return t&&c.containsCol(n)?t.setBoth(n,!0):null},this.getColumnContents=function(e,t){var n=this.getColumnDataRange(e);if(!n)return[];var r=n.rowInterval();if((t=t?t.deepClone().move(r.first).intersect(r):new y(r)).empty())return[];var o=w.createFromRowIntervals(t,n.start[0]);return g.getRangeContents(o,{blanks:!0,display:!0,compressed:!0})},this.isRefreshable=function(){return s.some(function(e){return e.columnModel.isRefreshable()})},this.createFilterMatcher=function(e){var t=this.getColumnModel(e).getMergedAttributeSet(!0).filter;return"discrete"===t.type?function(e){if(0===e.length)return _.constant(!1);var n=x.from(e);return o.getApp().isODF()?function(e){return n.has(e)}:function(e,t){return n.has(t.replace(/^ +| +$/g,""))}}(t.entries):null},this.queryFilterResult=function(e){var t=this.getDataRange();if(!t)return this.createResolvedPromise([]);var n=[],r=R(p.getArrayOption(e,"skipColumns",[]),!0),o=t.rowInterval(),f=new y(new O(0,o.size()-1));return s.forEach(function(e){!e.columnModel.isFiltered()||e.tableCol in r||n.push(e.tableCol)}),this.iterateArraySliced(n,function(e){if(f.empty())return p.BREAK;var s=this.createFilterMatcher(e);if(s){var t=this.getColumnContents(e,f),l=new y,u=0,c=0;t.forEach(function(e){for(var t,n,r=e.count,o=s(e.value,e.display),a=null,i=0;0<r;)a=f[c],u=Math.max(u,a.first),i=Math.min(r,a.last-u+1),o&&(n=void 0,t=u+i-1,(n=l.last())&&n.last+1===u?n.last=t:l.push(new O(u,t))),r-=i,u+=i,a.last<u&&(c+=1)}),f=l}},"TableModel.queryFilterResult").then(function(){return f})},this.generateRefreshOperations=function(e,t){var a=this.getDataRange();if(!a)return this.createResolvedPromise();var n=c.boundary(a),r=this.createResolvedPromise();c.differs(n)&&(e.generateTableRangeOperation(b.CHANGE_TABLE,u,c,null,{undo:!0}),e.generateTableRangeOperation(b.CHANGE_TABLE,u,n),this.isAutoFilter()&&(r=r.then(function(){return l.nameCollection.generateFilterDatabaseOperations(e,n)})));var i=l.createOperationGenerator({applyImmediately:!0}),o=l.createOperationGenerator({applyImmediately:!0});if(p.getBooleanOption(t,"updateFilter",!1)&&(r=r.then(function(){return f.queryFilterResult(t).then(function(e){var t=a.rowInterval(),n=e.deepClone().move(t.first);p.addProperty(n,"fillData",{attrs:{visible:!0,filtered:!1}});var r=new y(t).difference(n);p.addProperty(r,"fillData",{attrs:{visible:!1,filtered:!0}});var o=n.concat(r);return l.rowCollection.generateIntervalOperations(i,o)})})),p.getBooleanOption(t,"updateSort",!1)){var s=this.getSortRules();0<s.length&&(r=r.then(function(){return g.generateSortOperations(o,a,M.VERTICAL,s)}))}return r.done(function(){e.appendOperations(i),e.appendOperations(o),e.appendOperations(o,{undo:!0}),e.appendOperations(i,{undo:!0})})},this.generateChangeOperations=function(e,t){return e.generateTableOperation(b.CHANGE_TABLE,u,{attrs:this.getUndoAttributeSet(t)},{undo:!0}),e.generateTableOperation(b.CHANGE_TABLE,u,{attrs:t}),this.generateRefreshOperations(e)},this.generateChangeColumnOperations=function(e,t,n,r){p.getBooleanOption(r,"resetSort",!1)&&h(e,[t]);var o=this.getColumnModel(t).getUndoAttributeSet(n);return e.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,{col:t,sort:"sort"in o,attrs:o},{undo:!0}),e.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,{col:t,sort:"sort"in n,attrs:n}),this.generateRefreshOperations(e,{updateFilter:"filter"in n,updateSort:"sort"in n})},this.generateDeleteOperations=function(n){var e=l.rowCollection.generateFillOperations(n,c.rowInterval(),{attrs:{visible:!0,filtered:!1}});return(e=e.catch(function(e){if(!e||"rows:overflow"!==e.cause)throw e})).then(function(){var e={attrs:f.getExplicitAttributeSet(!0)};n.generateTableRangeOperation(b.INSERT_TABLE,u,c,e,{undo:!0}),s.forEach(function(e){var t={col:e.tableCol,attrs:e.columnModel.getExplicitAttributeSet(!0)};n.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,t,{undo:!0})}),n.generateTableOperation(b.DELETE_TABLE,u)})},this.generateBeforeMoveCellsOperations=function(n,r){var e=!r.insert&&!r.columns&&this.hasHeaderRow()&&r.deleteIntervals.containsIndex(c.start[1])?null:r.transformRanges(c).first();if(!e)return this.generateDeleteOperations(n);if(!c.equals(e)){var o=new A;if(r.columns&&!s.empty()){var a=c.start[0],i=c.start[1];s.forEach(function(e){var t=new E(a+e.tableCol,i);r.transformAddress(t)||o.insert(e.tableCol,e)})}return o.empty()?this.createResolvedPromise():(o.forEach(function(e){var t={col:e.tableCol,attrs:e.columnModel.getExplicitAttributeSet(!0)};n.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,t,{undo:!0})}),this.generateRefreshOperations(n,{skipColumns:o.pluck("tableCol")}))}},this.generateAfterMoveCellsOperations=function(e,t,n){var r=t.transformRanges(c).first();if(r){if(!c.equals(r)){var o={range:r.toOpStr()},a={range:c.toOpStr()};!t.insert&&!t.columns&&this.hasFooterRow()&&t.deleteIntervals.containsIndex(c.end[1])&&(o.attrs={table:{footerRow:!1}},a.attrs={table:{footerRow:!0}}),e.generateTableOperation(b.CHANGE_TABLE,u,o),e.generateTableOperation(b.CHANGE_TABLE,u,a,{undo:!0}),t.columns&&t.insert&&function(i){var e=f.getHeaderRange();if(!f.isAutoFilter()&&e){var r=[],s={};g.createCellIterator(e).forEach(function(e){var t=e.value,n="string"==typeof t?S(t):null;!n||n in s?r.push(null):(r.push(t),s[n]=!0)});var l=m.getTableColName();r.forEach(function(e,t){if(e)l=e;else{for(var n=/^(.*?)(\d+)$/.exec(l),r=n?n[1]:m.getTableColName(),o=n?parseInt(n[2],10)+1:1;S(r+o)in s;)o+=1;var a=new E(c.start[0]+t,c.start[1]);l=r+o,i.insertCell(a,{v:l}),s[S(l)]=!0}})}}(n)}}else F.error("$badge{TableModel} generateAfterMoveCellsOperations: unexpected deleted table model, name="+u+" range="+c)},this.generateSortOperations=function(o,e){var a=c.start[0],t=e.map(function(e){return e.index-a});return h(o,t),e.forEach(function(e){var t=e.index-a,n={sort:{type:"value",descending:!!e.descending}},r=f.getColumnModel(t).getUndoAttributeSet(n);o.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,{sort:!0,col:t,attrs:r},{undo:!0}),o.generateTableOperation(b.CHANGE_TABLE_COLUMN,u,{sort:!0,col:t,attrs:n})}),this.generateRefreshOperations(o,{updateSort:!0})},c=c.clone(),o._registerTableModel(this),this.on("change:attributes",function(e,t,n){t.table.headerRow!==n.table.headerRow&&r.setRanges(f.getHeaderRange())}),arguments[B.length]instanceof A&&arguments[B.length].forEach(function(e){a(e.tableCol,e.columnModel.clone(l,this))},this),this.registerDestructor(function(){o._unregisterTableModel(f),s.forEach(function(e){e.columnModel.destroy()}).clear(),t.destroy(),r.destroy(),f=o=l=null,s=t=r=null})}}),h=t.extend(l,function(){l.call(this,function(e){return e.getKey()})});e.TableCollection=f.extend({constructor:function(s){var r=this,l=s.getDocModel(),a=new h,o=l.docApp.isOOXML();function i(e,t){var n=e.optStr("table",!0),r=0===n.length,o=a.get(S(n),null);return t&&t.insert?e.ensure(!o&&(r||!l.hasTable(n)),"table exists"):e.ensure(o,"missing table"),{name:n,model:o}}function u(t,n){return a.some(function(e){return e!==n&&e.overlapsRange(t)})}function c(t){a.insert(t),r.trigger("insert:table",t),r.forwardEvents(t,{transformFn:function(e){return["change:table",t,e].concat(_.rest(arguments,2))}})}f.call(this,l),this._getCloneData=function(){return{tableModelSet:a}},this.applyCopySheetOperation=function(r,e){var o=r.optDict("tableNames");e._getCloneData().tableModelSet.forEach(function(e){var t=e.getName(),n=t;e.isAutoFilter()||(n=p.getStringOption(o,t,null),r.ensure(n,'missing replacement name for table "%s"',t)),c(e.clone(s,n))})},this.applyInsertOperation=function(e){var t=i(e,{insert:!0}),n=e.getRange("range");e.ensure(!o||!u(n),"range covers another table"),t.model=new B(s,t.name,n,e.optDict("attrs")),c(t.model)},this.applyDeleteOperation=function(e){var t,n=i(e);t=n.model,r.trigger("delete:table",t),a.remove(t),t.destroy()},this.applyChangeOperation=function(e){var t=i(e).model,n=e.optRange("range");n&&(e.ensure(!o||!u(n,t),"range covers another table"),t.setRange(n));var r=e.optStr("newName");r&&(e.ensure(!t.isAutoFilter(),"auto-filter cannot be renamed"),e.ensure(!l.hasTable(r),"table name already used"),t.setName(r)),e.has("attrs")&&t.setAttributes(e.getDict("attrs"))},this.applyChangeColumnOperation=function(e){i(e).model.applyChangeOperation(e)},this.hasTable=function(e){return a.hasKey(S(e))},this.hasAutoFilter=function(){return a.hasKey("")},this.getTableModel=function(e){return a.get(S(e))},this.getAutoFilterModel=function(){return a.get("")},this.getTableModelAt=function(t){return a.find(function(e){return e.containsCell(t)})||null},this.createModelIterator=function(e){var t=a.valueIterator();e&&e.autoFilter||(t=t.filterIterator(function(e){return!e.isAutoFilter()}));var n=e&&e.overlapRange;return n&&(t=t.filterIterator(function(e){return e.overlapsRange(n)})),t},this.hasFilteredTables=function(){return a.some(function(e){return e.isFiltered()})},this.canMoveCells=function(t){return a.every(function(e){return e.canMoveCells(t)})},this.canRestoreDeletedRanges=function(t){return a.every(function(e){return e.canRestoreDeletedRanges(t)})},this.generateInsertTableOperations=function(o,a,i,t){var e=0===a.length;if(e?this.hasAutoFilter():l.hasTable(a))return m.makeRejected("table:duplicate");if(!this.createModelIterator({overlapRange:i,autoFilter:!0}).next().done)return m.makeRejected("table:overlap");var n=e?this.createResolvedPromise(null):s.mergeCollection.generateMergeCellsOperations(o,i,g.UNMERGE);return n=n.then(function(){var e={range:i.toOpStr()};_.isObject(t)&&(e.attrs=t),o.generateTableOperation(b.DELETE_TABLE,a,null,{undo:!0}),o.generateTableOperation(b.INSERT_TABLE,a,e)}),e&&(n=(n=n.then(function(){var e=s.mergeCollection.getMergedRanges(i.headerRow());return r.iterateArraySliced(e,function(e){for(var t=Math.max(e.start[0],i.start[0]),n=Math.min(e.end[0],i.end[0]),r=t;r<n;r+=1)o.generateTableOperation(b.CHANGE_TABLE_COLUMN,a,{col:r-i.start[0],attrs:{filter:{hideButton:!0}}})},"TableCollection.generateInsertTableOperations")})).then(function(){return s.nameCollection.generateFilterDatabaseOperations(o,i)})),n},this.generateBeforeMoveCellsOperations=function(t,n){return this.iterateSliced(a.valueIterator(),function(e){return e.generateBeforeMoveCellsOperations(t,n)},"TableCollection.generateBeforeMoveCellsOperations")},this.generateAfterMoveCellsOperations=function(t,n){var r=new d(s,t,{skipUndo:!0});return this.iterateSliced(a.valueIterator(),function(e){return e.generateAfterMoveCellsOperations(t,n,r)},"TableCollection.generateAfterMoveCellsOperations").done(function(){r.finalizeOperations()})},this.listenTo(s.cellCollection.moveHook,function(e){var t=e.transformer;a.forEach(function(e){e.transformRange(t)})}),this.waitForImportSuccess(function(e){!e&&s.isActive()&&a.forEach(function(e){s.refreshRanges(e.getRange())})},this),this.registerDestructor(function(){a.destroy(),r=l=s=a=null})}})});