define("io.ox/office/spreadsheet/utils/range",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/iterators","io.ox/office/spreadsheet/utils/interval","io.ox/office/spreadsheet/utils/address"],function(t,e,n,r,s,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.rangeKey=e.rangeKeyFromIndexes=void 0;var u=Math.min,i=Math.max,h=Math.floor,c="("+a.COL_PATTERN+")("+a.ROW_PATTERN+")",p=new RegExp("^"+c+":"+c+"$","i");function d(t,e){return t.key+":"+e.key}e.rangeKeyFromIndexes=function(t,e,r,n){return a.addressKey(t,e)+":"+a.addressKey(r,n)},e.rangeKey=d;var f=(l.create=function(t,e,r,n){return new l(new a.Address(u(t,r),u(e,n)),new a.Address(i(t,r),i(e,n)))},l.createFromIntervals=function(t,e){return l.create(t.first,e.first,t.last,e.last)},l.createFromColInterval=function(t,e,r){return n.isNumber(r)||(r=e),l.create(t.first,e,t.last,r)},l.createFromRowInterval=function(t,e,r){return n.isNumber(r)||(r=e),l.create(e,t.first,r,t.last)},l.createFromAddresses=function(t,e){return e?l.create(t[0],t[1],e[0],e[1]):new l(t.clone())},l.createFromAddressAndSize=function(t,e,r){return l.create(t[0],t[1],t[0]+e-1,t[1]+r-1)},l.parse=function(t){var e=t.match(p);if(e){var r=a.parseCol(e[1]),n=a.parseRow(e[2]),s=a.parseCol(e[3]),o=a.parseRow(e[4]);return 0<=u(r,n,s,o)?l.create(r,n,s,o):null}var i=a.Address.parse(t);return i?new l(i):null},l.compare=function(t,e){return r.comparePairs(t.start,t.end,e.start,e.end,a.Address.compare)},Object.defineProperty(l.prototype,"key",{get:function(){return d(this.start,this.end)},enumerable:!1,configurable:!0}),l.prototype.clone=function(){return new l(this.start.clone(),this.end.clone())},l.prototype.equals=function(t){return this.start.equals(t.start)&&this.end.equals(t.end)},l.prototype.differs=function(t){return this.start.differs(t.start)||this.end.differs(t.end)},l.prototype.compareTo=function(t){return l.compare(this,t)},l.prototype.cols=function(){return this.end[0]-this.start[0]+1},l.prototype.rows=function(){return this.end[1]-this.start[1]+1},l.prototype.size=function(t){return t?this.cols():this.rows()},l.prototype.cells=function(){return this.cols()*this.rows()},l.prototype.singleCol=function(){return this.start[0]===this.end[0]},l.prototype.singleRow=function(){return this.start[1]===this.end[1]},l.prototype.singleLine=function(t){return t?this.singleCol():this.singleRow()},l.prototype.single=function(){return this.start.equals(this.end)},l.prototype.equalSize=function(t){return this.cols()===t.cols()&&this.rows()===t.rows()},l.prototype.equalCols=function(t){return this.start[0]===t.start[0]&&this.end[0]===t.end[0]},l.prototype.equalRows=function(t){return this.start[1]===t.start[1]&&this.end[1]===t.end[1]},l.prototype.sizeFitsInto=function(t){return t.cols()%this.cols()==0&&t.rows()%this.rows()==0},l.prototype.startsAt=function(t){return this.start.equals(t)},l.prototype.endsAt=function(t){return this.end.equals(t)},l.prototype.indexAt=function(t){return(t[1]-this.start[1])*this.cols()+(t[0]-this.start[0])},l.prototype.addressAt=function(t){var e=this.cols();return new a.Address(this.start[0]+h(t%e),this.start[1]+h(t/e))},l.prototype.containsCol=function(t){return this.start[0]<=t&&t<=this.end[0]},l.prototype.containsRow=function(t){return this.start[1]<=t&&t<=this.end[1]},l.prototype.containsIndex=function(t,e){return e?this.containsCol(t):this.containsRow(t)},l.prototype.containsAddress=function(t){return this.containsCol(t[0])&&this.containsRow(t[1])},l.prototype.isBorderAddress=function(t){return this.containsAddress(t)&&(this.start[0]===t[0]||this.end[0]===t[0]||this.start[1]===t[1]||this.end[1]===t[1])},l.prototype.contains=function(t){return this.containsAddress(t.start)&&this.containsAddress(t.end)},l.prototype.overlaps=function(t){return this.start[0]<=t.end[0]&&t.start[0]<=this.end[0]&&this.start[1]<=t.end[1]&&t.start[1]<=this.end[1]},l.prototype.colInterval=function(){return new o.Interval(this.start[0],this.end[0])},l.prototype.rowInterval=function(){return new o.Interval(this.start[1],this.end[1])},l.prototype.interval=function(t){return t?this.colInterval():this.rowInterval()},l.prototype.colRange=function(t,e){void 0===e&&(e=1);var r=this.start[0]+t;return l.create(r,this.start[1],r+e-1,this.end[1])},l.prototype.rowRange=function(t,e){void 0===e&&(e=1);var r=this.start[1]+t;return l.create(this.start[0],r,this.end[0],r+(e||1)-1)},l.prototype.lineRange=function(t,e,r){return void 0===r&&(r=1),t?this.colRange(e,r):this.rowRange(e,r)},l.prototype.leadingCol=function(){return l.create(this.start[0],this.start[1],this.start[0],this.end[1])},l.prototype.trailingCol=function(){return l.create(this.end[0],this.start[1],this.end[0],this.end[1])},l.prototype.headerRow=function(){return l.create(this.start[0],this.start[1],this.end[0],this.start[1])},l.prototype.footerRow=function(){return l.create(this.start[0],this.end[1],this.end[0],this.end[1])},l.prototype.mirror=function(){return l.create(this.start[1],this.start[0],this.end[1],this.end[0])},l.prototype.expand=function(t){return l.create(u(this.start[0],t[0]),u(this.start[1],t[1]),i(this.end[0],t[0]),i(this.end[1],t[1]))},l.prototype.boundary=function(t){return l.create(u(this.start[0],t.start[0]),u(this.start[1],t.start[1]),i(this.end[0],t.end[0]),i(this.end[1],t.end[1]))},l.prototype.intersect=function(t){return this.overlaps(t)?l.create(i(this.start[0],t.start[0]),i(this.start[1],t.start[1]),u(this.end[0],t.end[0]),u(this.end[1],t.end[1])):null},l.prototype.getStart=function(t){return this.start.get(t)},l.prototype.getEnd=function(t){return this.end.get(t)},l.prototype.setStart=function(t,e){return this.start.set(t,e),this},l.prototype.setEnd=function(t,e){return this.end.set(t,e),this},l.prototype.setBoth=function(t,e){return this.start.set(t,e),this.end.set(t,e),this},l.prototype.moveBoth=function(t,e){return this.start.move(t,e),this.end.move(t,e),this},l.prototype.colIterator=function(t){return s.IndexIterator.interval(this.start[0],this.end[0],t)},l.prototype.rowIterator=function(t){return s.IndexIterator.interval(this.start[1],this.end[1],t)},l.prototype.indexIterator=function(t,e){return t?this.colIterator(e):this.rowIterator(e)},l.prototype.addressIterator=function(t){var e,r=this,n=null!==(e=null==t?void 0:t.columns)&&void 0!==e&&e;return this.indexIterator(n,t).nestedMapIterator(function(){return r.indexIterator(!n,t)},n?function(t,e){return new a.Address(t,e)}:function(t,e){return new a.Address(e,t)})},l.prototype.toOpStr=function(){var t=this.start.toOpStr();return this.single()?t:t+":"+this.end.toOpStr()},l.prototype.toString=function(){return this.start+":"+this.end},l);function l(t,e){this.start=t,this.end=e||t.clone()}e.Range=f});